# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from typing import Optional, Union
from pydantic import BaseModel, Field, StrictFloat, StrictInt, StrictStr

class AccountSummaryInvoice(BaseModel):
    """
    AccountSummaryInvoice
    """
    amount: Optional[Union[StrictFloat, StrictInt]] = Field(None, description="Invoice amount before adjustments, discounts, and similar items. ")
    balance: Optional[Union[StrictFloat, StrictInt]] = Field(None, description="Balance due on the invoice. ")
    due_date: Optional[date] = Field(None, alias="dueDate", description="Due date as `yyyy-mm-dd`. ")
    id: Optional[StrictStr] = Field(None, description="Invoice ID. ")
    invoice_date: Optional[date] = Field(None, alias="invoiceDate", description="Invoice date as `yyyy-mm-dd`. ")
    invoice_number: Optional[StrictStr] = Field(None, alias="invoiceNumber", description="Invoice number. ")
    status: Optional[StrictStr] = None
    __properties = ["amount", "balance", "dueDate", "id", "invoiceDate", "invoiceNumber", "status"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> AccountSummaryInvoice:
        """Create an instance of AccountSummaryInvoice from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> AccountSummaryInvoice:
        """Create an instance of AccountSummaryInvoice from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return AccountSummaryInvoice.parse_obj(obj)

        _obj = AccountSummaryInvoice.parse_obj({
            "amount": obj.get("amount"),
            "balance": obj.get("balance"),
            "due_date": obj.get("dueDate"),
            "id": obj.get("id"),
            "invoice_date": obj.get("invoiceDate"),
            "invoice_number": obj.get("invoiceNumber"),
            "status": obj.get("status")
        })
        return _obj


