# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictStr

class AccountSummaryUsage(BaseModel):
    """
    AccountSummaryUsage
    """
    quantity: Optional[StrictStr] = Field(None, description="Number of units used. ")
    start_date: Optional[StrictStr] = Field(None, alias="startDate", description="The start date of a usage period as `yyyy-mm`. Zuora uses this field value to determine the usage date. ")
    unit_of_measure: Optional[StrictStr] = Field(None, alias="unitOfMeasure", description="Unit by which consumption is measured, as configured in the Billing Settings section of the web-based UI. ")
    __properties = ["quantity", "startDate", "unitOfMeasure"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> AccountSummaryUsage:
        """Create an instance of AccountSummaryUsage from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> AccountSummaryUsage:
        """Create an instance of AccountSummaryUsage from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return AccountSummaryUsage.parse_obj(obj)

        _obj = AccountSummaryUsage.parse_obj({
            "quantity": obj.get("quantity"),
            "start_date": obj.get("startDate"),
            "unit_of_measure": obj.get("unitOfMeasure")
        })
        return _obj


