# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional, Union
from pydantic import BaseModel, Field, StrictFloat, StrictInt, StrictStr, conlist
from com.zuora.models.apply_credit_memo_item_to_debit_memo_item import ApplyCreditMemoItemToDebitMemoItem

class ApplyCreditMemoToDebitMemo(BaseModel):
    """
    ApplyCreditMemoToDebitMemo
    """
    amount: Union[StrictFloat, StrictInt] = Field(..., description="The credit memo amount to be applied to the debit memo. ")
    debit_memo_id: StrictStr = Field(..., alias="debitMemoId", description="The unique ID of the debit memo that the credit memo is applied to. ")
    items: Optional[conlist(ApplyCreditMemoItemToDebitMemoItem)] = Field(None, description="Container for items. The maximum number of items is 1,000.  If `creditMemoItemId` is the source, then it should be accompanied by a target `debitMemoItemId`.  If `creditTaxItemId` is the source, then it should be accompanied by a target `taxItemId`. ")
    __properties = ["amount", "debitMemoId", "items"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ApplyCreditMemoToDebitMemo:
        """Create an instance of ApplyCreditMemoToDebitMemo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in items (list)
        _items = []
        if self.items:
            for _item in self.items:
                if _item:
                    _items.append(_item.to_dict())
            _dict['items'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ApplyCreditMemoToDebitMemo:
        """Create an instance of ApplyCreditMemoToDebitMemo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return ApplyCreditMemoToDebitMemo.parse_obj(obj)

        _obj = ApplyCreditMemoToDebitMemo.parse_obj({
            "amount": obj.get("amount"),
            "debit_memo_id": obj.get("debitMemoId"),
            "items": [ApplyCreditMemoItemToDebitMemoItem.from_dict(_item) for _item in obj.get("items")] if obj.get("items") is not None else None
        })
        return _obj


