# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional, Union
from pydantic import BaseModel, Field, StrictFloat, StrictInt, StrictStr, conlist
from com.zuora.models.apply_credit_memo_item_to_invoice_item import ApplyCreditMemoItemToInvoiceItem

class ApplyCreditMemoToInvoice(BaseModel):
    """
    ApplyCreditMemoToInvoice
    """
    amount: Union[StrictFloat, StrictInt] = Field(..., description="The credit memo amount to be applied to the invoice. ")
    invoice_id: StrictStr = Field(..., alias="invoiceId", description="The unique ID of the invoice that the credit memo is applied to. ")
    items: Optional[conlist(ApplyCreditMemoItemToInvoiceItem)] = Field(None, description="Container for items. The maximum number of items is 1,000.  If `creditMemoItemId` is the source, then it should be accompanied by a target `invoiceItemId`.  If `creditTaxItemId` is the source, then it should be accompanied by a target `taxItemId`. ")
    __properties = ["amount", "invoiceId", "items"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ApplyCreditMemoToInvoice:
        """Create an instance of ApplyCreditMemoToInvoice from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in items (list)
        _items = []
        if self.items:
            for _item in self.items:
                if _item:
                    _items.append(_item.to_dict())
            _dict['items'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ApplyCreditMemoToInvoice:
        """Create an instance of ApplyCreditMemoToInvoice from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return ApplyCreditMemoToInvoice.parse_obj(obj)

        _obj = ApplyCreditMemoToInvoice.parse_obj({
            "amount": obj.get("amount"),
            "invoice_id": obj.get("invoiceId"),
            "items": [ApplyCreditMemoItemToInvoiceItem.from_dict(_item) for _item in obj.get("items")] if obj.get("items") is not None else None
        })
        return _obj


