# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr, validator

class BookingDateJob(BaseModel):
    """
    BookingDateJob
    """
    id: Optional[StrictStr] = Field(None, description="Job id")
    created_on: Optional[StrictInt] = Field(None, alias="createdOn")
    created_on_readable: Optional[StrictStr] = Field(None, alias="createdOnReadable")
    updated_on: Optional[StrictInt] = Field(None, alias="updatedOn")
    updated_on_readable: Optional[StrictStr] = Field(None, alias="updatedOnReadable")
    updated_by_username: Optional[StrictStr] = Field(None, alias="updatedByUsername")
    status: Optional[StrictStr] = Field(None, description="Data Backfill job type")
    batch_sent_count: Optional[StrictInt] = Field(None, alias="batchSentCount")
    batch_finished_count: Optional[StrictInt] = Field(None, alias="batchFinishedCount")
    error_count: Optional[StrictInt] = Field(None, alias="errorCount")
    progress: Optional[StrictStr] = None
    __properties = ["id", "createdOn", "createdOnReadable", "updatedOn", "updatedOnReadable", "updatedByUsername", "status", "batchSentCount", "batchFinishedCount", "errorCount", "progress"]

    @validator('status')
    def status_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('ACCEPTED', 'PROCESSING', 'COMPLETED', 'FAILED', 'STOPPED'):
            raise ValueError("must be one of enum values ('ACCEPTED', 'PROCESSING', 'COMPLETED', 'FAILED', 'STOPPED')")
        return value

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> BookingDateJob:
        """Create an instance of BookingDateJob from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> BookingDateJob:
        """Create an instance of BookingDateJob from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return BookingDateJob.parse_obj(obj)

        _obj = BookingDateJob.parse_obj({
            "id": obj.get("id"),
            "created_on": obj.get("createdOn"),
            "created_on_readable": obj.get("createdOnReadable"),
            "updated_on": obj.get("updatedOn"),
            "updated_on_readable": obj.get("updatedOnReadable"),
            "updated_by_username": obj.get("updatedByUsername"),
            "status": obj.get("status"),
            "batch_sent_count": obj.get("batchSentCount"),
            "batch_finished_count": obj.get("batchFinishedCount"),
            "error_count": obj.get("errorCount"),
            "progress": obj.get("progress")
        })
        return _obj


