# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
from inspect import getfullargspec
import json
import pprint
import re  # noqa: F401

from typing import Any, List, Optional
from pydantic import BaseModel, Field, StrictStr, ValidationError, validator
from com.zuora.models.bulk_create_credit_memos_from_charge_request import BulkCreateCreditMemosFromChargeRequest
from com.zuora.models.bulk_create_credit_memos_from_invoice_request import BulkCreateCreditMemosFromInvoiceRequest
from typing import Union, Any, List, TYPE_CHECKING
from pydantic import StrictStr, Field

BULKCREATECREDITMEMOSREQUEST_ONE_OF_SCHEMAS = ["BulkCreateCreditMemosFromChargeRequest", "BulkCreateCreditMemosFromInvoiceRequest"]

class BulkCreateCreditMemosRequest(BaseModel):
    """
    BulkCreateCreditMemosRequest
    """
    # data type: BulkCreateCreditMemosFromInvoiceRequest
    oneof_schema_1_validator: Optional[BulkCreateCreditMemosFromInvoiceRequest] = None
    # data type: BulkCreateCreditMemosFromChargeRequest
    oneof_schema_2_validator: Optional[BulkCreateCreditMemosFromChargeRequest] = None
    if TYPE_CHECKING:
        actual_instance: Union[BulkCreateCreditMemosFromChargeRequest, BulkCreateCreditMemosFromInvoiceRequest]
    else:
        actual_instance: Any
    one_of_schemas: List[str] = Field(BULKCREATECREDITMEMOSREQUEST_ONE_OF_SCHEMAS, const=True)

    class Config:
        validate_assignment = True

    discriminator_value_class_map = {
    }

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = BulkCreateCreditMemosRequest.construct()
        error_messages = []
        match = 0
        # validate data type: BulkCreateCreditMemosFromInvoiceRequest
        if not isinstance(v, BulkCreateCreditMemosFromInvoiceRequest):
            error_messages.append(f"Error! Input type `{type(v)}` is not `BulkCreateCreditMemosFromInvoiceRequest`")
        else:
            match += 1
        # validate data type: BulkCreateCreditMemosFromChargeRequest
        if not isinstance(v, BulkCreateCreditMemosFromChargeRequest):
            error_messages.append(f"Error! Input type `{type(v)}` is not `BulkCreateCreditMemosFromChargeRequest`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in BulkCreateCreditMemosRequest with oneOf schemas: BulkCreateCreditMemosFromChargeRequest, BulkCreateCreditMemosFromInvoiceRequest. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in BulkCreateCreditMemosRequest with oneOf schemas: BulkCreateCreditMemosFromChargeRequest, BulkCreateCreditMemosFromInvoiceRequest. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: dict) -> BulkCreateCreditMemosRequest:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> BulkCreateCreditMemosRequest:
        """Returns the object represented by the json string"""
        instance = BulkCreateCreditMemosRequest.construct()
        error_messages = []
        match = 0

        # deserialize data into BulkCreateCreditMemosFromInvoiceRequest
        try:
            instance.actual_instance = BulkCreateCreditMemosFromInvoiceRequest.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into BulkCreateCreditMemosFromChargeRequest
        try:
            instance.actual_instance = BulkCreateCreditMemosFromChargeRequest.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into BulkCreateCreditMemosRequest with oneOf schemas: BulkCreateCreditMemosFromChargeRequest, BulkCreateCreditMemosFromInvoiceRequest. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into BulkCreateCreditMemosRequest with oneOf schemas: BulkCreateCreditMemosFromChargeRequest, BulkCreateCreditMemosFromInvoiceRequest. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        to_json = getattr(self.actual_instance, "to_json", None)
        if callable(to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> dict:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        to_dict = getattr(self.actual_instance, "to_dict", None)
        if callable(to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.dict())


