# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictBool, conlist
from com.zuora.models.create_invoice_request import CreateInvoiceRequest

class BulkCreateInvoicesRequest(BaseModel):
    """
    BulkCreateInvoicesRequest
    """
    invoices: Optional[conlist(CreateInvoiceRequest)] = Field(None, description="Container for standalone invoices. ")
    use_single_transaction: Optional[StrictBool] = Field(None, alias="useSingleTransaction", description="Whether a batch request is handled with a single transaction.  - `true` indicates that a batch request will be handled with a single transaction. - `false`  indicates that the standalone invoices to be created in a batch request will be handled with separated transactions.  If the field is set to `false`, a failure in the batch request will not cause the whole request to fail, so you have to retry the whole batch request. ")
    __properties = ["invoices", "useSingleTransaction"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> BulkCreateInvoicesRequest:
        """Create an instance of BulkCreateInvoicesRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in invoices (list)
        _items = []
        if self.invoices:
            for _item in self.invoices:
                if _item:
                    _items.append(_item.to_dict())
            _dict['invoices'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> BulkCreateInvoicesRequest:
        """Create an instance of BulkCreateInvoicesRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return BulkCreateInvoicesRequest.parse_obj(obj)

        _obj = BulkCreateInvoicesRequest.parse_obj({
            "invoices": [CreateInvoiceRequest.from_dict(_item) for _item in obj.get("invoices")] if obj.get("invoices") is not None else None,
            "use_single_transaction": obj.get("useSingleTransaction")
        })
        return _obj


