# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional, Union
from pydantic import BaseModel, Field, StrictFloat, StrictInt, StrictStr

class CatalogGroupProductRatePlan(BaseModel):
    """
    CatalogGroupProductRatePlan
    """
    description: Optional[StrictStr] = Field(None, description="The description of the product rate plan. ")
    effective_end_date: Optional[StrictStr] = Field(None, alias="effectiveEndDate", description="The effective end Date of the product rate plan. ")
    effective_start_date: Optional[StrictStr] = Field(None, alias="effectiveStartDate", description="The effective start date of the product rate plan. ")
    grade: Optional[Union[StrictFloat, StrictInt]] = Field(None, description="The grade of the product rate plan. ")
    id: Optional[StrictStr] = Field(None, description="The ID of the product rate plan. ")
    name: Optional[StrictStr] = Field(None, description="The name of the product rate plan. ")
    status: Optional[StrictStr] = None
    __properties = ["description", "effectiveEndDate", "effectiveStartDate", "grade", "id", "name", "status"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> CatalogGroupProductRatePlan:
        """Create an instance of CatalogGroupProductRatePlan from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> CatalogGroupProductRatePlan:
        """Create an instance of CatalogGroupProductRatePlan from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return CatalogGroupProductRatePlan.parse_obj(obj)

        _obj = CatalogGroupProductRatePlan.parse_obj({
            "description": obj.get("description"),
            "effective_end_date": obj.get("effectiveEndDate"),
            "effective_start_date": obj.get("effectiveStartDate"),
            "grade": obj.get("grade"),
            "id": obj.get("id"),
            "name": obj.get("name"),
            "status": obj.get("status")
        })
        return _obj


