# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional, Union
from pydantic import BaseModel, Field, StrictFloat, StrictInt, StrictStr

class ChargeMetrics(BaseModel):
    """
    Container for charge metrics.   # noqa: E501
    """
    dmrr: Optional[Union[StrictFloat, StrictInt]] = Field(None, description="Change in monthly recurring revenue. ")
    dtcv: Optional[Union[StrictFloat, StrictInt]] = Field(None, description="Change in total contract value. ")
    mrr: Optional[Union[StrictFloat, StrictInt]] = Field(None, description="Monthly recurring revenue. ")
    number: Optional[StrictStr] = Field(None, description="The charge number of the subscription. Only available for update subscription. ")
    origin_rate_plan_id: Optional[StrictStr] = Field(None, alias="originRatePlanId", description="The origin rate plan ID. Only available for update subscription. ")
    original_id: Optional[StrictStr] = Field(None, alias="originalId", description="The original rate plan charge ID. Only available for update subscription. ")
    product_rate_plan_charge_id: Optional[StrictStr] = Field(None, alias="productRatePlanChargeId", description="The product rate plan charge ID. ")
    product_rate_plan_id: Optional[StrictStr] = Field(None, alias="productRatePlanId", description="The product rate plan ID. ")
    tcv: Optional[Union[StrictFloat, StrictInt]] = Field(None, description="Total contract value. ")
    __properties = ["dmrr", "dtcv", "mrr", "number", "originRatePlanId", "originalId", "productRatePlanChargeId", "productRatePlanId", "tcv"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ChargeMetrics:
        """Create an instance of ChargeMetrics from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ChargeMetrics:
        """Create an instance of ChargeMetrics from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return ChargeMetrics.parse_obj(obj)

        _obj = ChargeMetrics.parse_obj({
            "dmrr": obj.get("dmrr"),
            "dtcv": obj.get("dtcv"),
            "mrr": obj.get("mrr"),
            "number": obj.get("number"),
            "origin_rate_plan_id": obj.get("originRatePlanId"),
            "original_id": obj.get("originalId"),
            "product_rate_plan_charge_id": obj.get("productRatePlanChargeId"),
            "product_rate_plan_id": obj.get("productRatePlanId"),
            "tcv": obj.get("tcv")
        })
        return _obj


