# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictStr

class ChargeModelConfigurationForSubscription(BaseModel):
    """
    Container for charge model configuration data.  **Note**: This field is only available if you have the High Water Mark, Pre-Rated Pricing, or Multi-Attribute Pricing charge models enabled. These charge models are available for customers with Enterprise and Nine editions by default. If you are a Growth customer, see [Zuora Editions](https://knowledgecenter.zuora.com/BB_Introducing_Z_Business/C_Zuora_Editions) for pricing information.   # noqa: E501
    """
    custom_field_per_unit_rate: Optional[StrictStr] = Field(None, alias="customFieldPerUnitRate", description="The custom field that carries the per-unit rate for each usage record. For example, `perUnitAmount__c`.      This field is only available for the usage-based charges that use the Pre-Rated Per Unit Pricing charge model. The charge model is available for customers with Enterprise and Nine editions by default. If you are a Growth customer, see [Zuora Editions](https://knowledgecenter.zuora.com/BB_Introducing_Z_Business/C_Zuora_Editions) for pricing information. ")
    custom_field_total_amount: Optional[StrictStr] = Field(None, alias="customFieldTotalAmount", description="The custom field that carries the total amount to charge for a usage record. For example, `totalAmount__c`.       This field is only available for the usage-based charges that use the Pre-Rated Pricing charge model. The charge model is available for customers with Enterprise and Nine editions by default. If you are a Growth customer, see [Zuora Editions](https://knowledgecenter.zuora.com/BB_Introducing_Z_Business/C_Zuora_Editions) for pricing information. ")
    formula: Optional[StrictStr] = Field(None, description="The pricing formula to calculate actual rating amount for each usage record.  This field is only available for the usage-based charges that use the Multi-Attribute Pricing charge model. The charge model is available for customers with Enterprise and Nine editions by default. If you are a Growth customer, see [Zuora Editions](https://knowledgecenter.zuora.com/BB_Introducing_Z_Business/C_Zuora_Editions) for pricing information. ")
    __properties = ["customFieldPerUnitRate", "customFieldTotalAmount", "formula"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ChargeModelConfigurationForSubscription:
        """Create an instance of ChargeModelConfigurationForSubscription from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ChargeModelConfigurationForSubscription:
        """Create an instance of ChargeModelConfigurationForSubscription from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return ChargeModelConfigurationForSubscription.parse_obj(obj)

        _obj = ChargeModelConfigurationForSubscription.parse_obj({
            "custom_field_per_unit_rate": obj.get("customFieldPerUnitRate"),
            "custom_field_total_amount": obj.get("customFieldTotalAmount"),
            "formula": obj.get("formula")
        })
        return _obj


