# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional, Union
from pydantic import BaseModel, Field, StrictFloat, StrictInt, StrictStr

class CollectDebitMemoResponseAppliedCreditMemos(BaseModel):
    """
    CollectDebitMemoResponseAppliedCreditMemos
    """
    applied_amount: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="appliedAmount", description="The applied amount of the credit memo to the debit memo. ")
    id: Optional[StrictStr] = Field(None, description="The unique ID of the credit memo. ")
    number: Optional[StrictStr] = Field(None, description="The unique identification number of the credit memo. ")
    unapplied_amount: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="unappliedAmount", description="The unapplied amount of the credit memo after applied to the debit memo. ")
    __properties = ["appliedAmount", "id", "number", "unappliedAmount"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> CollectDebitMemoResponseAppliedCreditMemos:
        """Create an instance of CollectDebitMemoResponseAppliedCreditMemos from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> CollectDebitMemoResponseAppliedCreditMemos:
        """Create an instance of CollectDebitMemoResponseAppliedCreditMemos from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return CollectDebitMemoResponseAppliedCreditMemos.parse_obj(obj)

        _obj = CollectDebitMemoResponseAppliedCreditMemos.parse_obj({
            "applied_amount": obj.get("appliedAmount"),
            "id": obj.get("id"),
            "number": obj.get("number"),
            "unapplied_amount": obj.get("unappliedAmount")
        })
        return _obj


