# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictStr
from com.zuora.models.create_account_credit_card_holder_info import CreateAccountCreditCardHolderInfo

class CreateAccountCreditCard(BaseModel):
    """
    **Note:** This field has been deprecated, and is currently available only for backward compatibility. Use the `paymentMethod` field instead to create a payment method associated with this account.  Container for information on a credit card to associate with this account.  If the `autoPay` field is set to `true`, you must provide one of the `paymentMethod`, `creditCard`, or `hpmCreditCardPaymentMethodId` field, but not multiple.   # noqa: E501
    """
    card_holder_info: CreateAccountCreditCardHolderInfo = Field(..., alias="cardHolderInfo")
    card_number: StrictStr = Field(..., alias="cardNumber", description="Card number, up to 16 characters. Once created, this field can't be updated or queried, and is only available in masked format (e.g., XXXX-XXXX-XXXX-1234). ")
    card_type: StrictStr = Field(..., alias="cardType", description="The type of the credit card.  Possible values  include `Visa`, `MasterCard`, `AmericanExpress`, `Discover`, `JCB`, and `Diners`. For more information about credit card types supported by different payment gateways, see [Supported Payment Gateways](https://knowledgecenter.zuora.com/CB_Billing/M_Payment_Gateways/Supported_Payment_Gateways). ")
    expiration_month: StrictStr = Field(..., alias="expirationMonth", description="Two-digit expiration month (01-12). ")
    expiration_year: StrictStr = Field(..., alias="expirationYear", description="Four-digit expiration year. ")
    security_code: Optional[StrictStr] = Field(None, alias="securityCode", description="The CVV or CVV2 security code of the card. To ensure PCI compliance, this value is not stored and cannot be queried. ")
    __properties = ["cardHolderInfo", "cardNumber", "cardType", "expirationMonth", "expirationYear", "securityCode"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> CreateAccountCreditCard:
        """Create an instance of CreateAccountCreditCard from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of card_holder_info
        if self.card_holder_info:
            _dict['cardHolderInfo'] = self.card_holder_info.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> CreateAccountCreditCard:
        """Create an instance of CreateAccountCreditCard from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return CreateAccountCreditCard.parse_obj(obj)

        _obj = CreateAccountCreditCard.parse_obj({
            "card_holder_info": CreateAccountCreditCardHolderInfo.from_dict(obj.get("cardHolderInfo")) if obj.get("cardHolderInfo") is not None else None,
            "card_number": obj.get("cardNumber"),
            "card_type": obj.get("cardType"),
            "expiration_month": obj.get("expirationMonth"),
            "expiration_year": obj.get("expirationYear"),
            "security_code": obj.get("securityCode")
        })
        return _obj


