# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictBool, StrictStr
from com.zuora.models.deleted_record import DeletedRecord

class CreateBatchQueryResponse(BaseModel):
    """
    CreateBatchQueryResponse
    """
    api_version: Optional[StrictStr] = Field(None, alias="apiVersion", description="The API version for the query. If an API version is not specified, the latest version is used by default. Using the latest WSDL version is most useful for reporting use cases. For integration purposes, specify the WSDL version to ensure consistent query behavior, that is, what is supported and included in the response returned by the API.  **Note**: As of API version 69 and later, Zuora changed the format of certain fields. See <a href=\"https://knowledgecenter.zuora.com/Zuora_Central_Platform/API/G_SOAP_API/AB_Getting_started_with_the__SOAP_API/C_Date_Field_Changes_in_the_SOAP_API\" target=\"_blank\">Date Field Changes in the SOAP API</a> for more information and a list of affected fields. ")
    batch_id: Optional[StrictStr] = Field(None, alias="batchId", description="A 32-character ID of the query batch. ")
    batch_type: Optional[StrictStr] = Field(None, alias="batchType")
    deleted: Optional[DeletedRecord] = None
    full: Optional[StrictBool] = Field(None, description="This field indicates a full or incremental load. `True` = Full and `False` = Incremental.           ")
    name: Optional[StrictStr] = Field(None, description="Name of the query supplied in the request. ")
    query: Optional[StrictStr] = Field(None, description="The requested query string. ")
    record_count: Optional[StrictStr] = Field(None, alias="recordCount", description="The number of records included in the query output file. ")
    localized_status: Optional[StrictStr] = Field(None, alias="localizedStatus")
    status: Optional[StrictStr] = None
    __properties = ["apiVersion", "batchId", "batchType", "deleted", "full", "name", "query", "recordCount", "localizedStatus", "status"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> CreateBatchQueryResponse:
        """Create an instance of CreateBatchQueryResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of deleted
        if self.deleted:
            _dict['deleted'] = self.deleted.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> CreateBatchQueryResponse:
        """Create an instance of CreateBatchQueryResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return CreateBatchQueryResponse.parse_obj(obj)

        _obj = CreateBatchQueryResponse.parse_obj({
            "api_version": obj.get("apiVersion"),
            "batch_id": obj.get("batchId"),
            "batch_type": obj.get("batchType"),
            "deleted": DeletedRecord.from_dict(obj.get("deleted")) if obj.get("deleted") is not None else None,
            "full": obj.get("full"),
            "name": obj.get("name"),
            "query": obj.get("query"),
            "record_count": obj.get("recordCount"),
            "localized_status": obj.get("localizedStatus"),
            "status": obj.get("status")
        })
        return _obj


