# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from typing import Optional
from pydantic import BaseModel, Field, StrictStr

class CreateBillingPreviewInvoiceItem(BaseModel):
    """
    CreateBillingPreviewInvoiceItem
    """
    applied_to_item_id: Optional[StrictStr] = Field(None, alias="appliedToItemId", description="The unique ID of the invoice item that the discount charge is applied to. ")
    charge_amount: Optional[StrictStr] = Field(None, alias="chargeAmount", description="The amount of the charge. This amount doesn't include taxes regardless if the charge's tax mode is inclusive or exclusive. ")
    charge_date: Optional[StrictStr] = Field(None, alias="chargeDate", description="The date when the invoice item was created. ")
    charge_description: Optional[StrictStr] = Field(None, alias="chargeDescription", description="Description of the charge. ")
    charge_id: Optional[StrictStr] = Field(None, alias="chargeId", description="Id of the charge. ")
    charge_name: Optional[StrictStr] = Field(None, alias="chargeName", description="Name of the charge. ")
    charge_number: Optional[StrictStr] = Field(None, alias="chargeNumber", description="Number of the charge. ")
    charge_type: Optional[StrictStr] = Field(None, alias="chargeType", description="The type of charge.   Possible values are `OneTime`, `Recurring`, and `Usage`. ")
    id: Optional[StrictStr] = Field(None, description="Invoice item ID. ")
    number_of_deliveries: Optional[StrictStr] = Field(None, alias="numberOfDeliveries", description="The number of delivery for charge.  **Note**: This field is available only if you have the Delivery Pricing feature enabled. ")
    processing_type: Optional[StrictStr] = Field(None, alias="processingType", description="Identifies the kind of charge.   Possible values: * charge * discount * prepayment * tax ")
    product_name: Optional[StrictStr] = Field(None, alias="productName", description="Name of the product associated with this item. ")
    quantity: Optional[StrictStr] = Field(None, description="Quantity of this item, in the configured unit of measure for the charge. ")
    service_end_date: Optional[date] = Field(None, alias="serviceEndDate", description="End date of the service period for this item, i.e., the last day of the service period, in `yyyy-mm-dd` format. ")
    service_start_date: Optional[date] = Field(None, alias="serviceStartDate", description="Start date of the service period for this item, in `yyyy-mm-dd` format. If the charge is a one-time fee, this is the date of that charge. ")
    subscription_id: Optional[StrictStr] = Field(None, alias="subscriptionId", description="ID of the subscription associated with this item. ")
    subscription_name: Optional[StrictStr] = Field(None, alias="subscriptionName", description="Name of the subscription associated with this item. ")
    subscription_number: Optional[StrictStr] = Field(None, alias="subscriptionNumber", description="Number of the subscription associated with this item. ")
    tax_amount: Optional[StrictStr] = Field(None, alias="taxAmount", description="If you use [Zuora Tax](https://knowledgecenter.zuora.com/Billing/Taxes/A_Zuora_Tax) and the product rate plan charge associated with the invoice item is of [tax inclusive mode](https://knowledgecenter.zuora.com/Billing/Taxes/A_Zuora_Tax/D_Associate_tax_codes_with_product_charges_and_set_the_tax_mode), the value of this field is the amount of tax applied to the charge. Otherwise, the value of this field is `0`.  ")
    unit_of_measure: Optional[StrictStr] = Field(None, alias="unitOfMeasure", description="Unit used to measure consumption. ")
    __properties = ["appliedToItemId", "chargeAmount", "chargeDate", "chargeDescription", "chargeId", "chargeName", "chargeNumber", "chargeType", "id", "numberOfDeliveries", "processingType", "productName", "quantity", "serviceEndDate", "serviceStartDate", "subscriptionId", "subscriptionName", "subscriptionNumber", "taxAmount", "unitOfMeasure"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> CreateBillingPreviewInvoiceItem:
        """Create an instance of CreateBillingPreviewInvoiceItem from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> CreateBillingPreviewInvoiceItem:
        """Create an instance of CreateBillingPreviewInvoiceItem from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return CreateBillingPreviewInvoiceItem.parse_obj(obj)

        _obj = CreateBillingPreviewInvoiceItem.parse_obj({
            "applied_to_item_id": obj.get("appliedToItemId"),
            "charge_amount": obj.get("chargeAmount"),
            "charge_date": obj.get("chargeDate"),
            "charge_description": obj.get("chargeDescription"),
            "charge_id": obj.get("chargeId"),
            "charge_name": obj.get("chargeName"),
            "charge_number": obj.get("chargeNumber"),
            "charge_type": obj.get("chargeType"),
            "id": obj.get("id"),
            "number_of_deliveries": obj.get("numberOfDeliveries"),
            "processing_type": obj.get("processingType"),
            "product_name": obj.get("productName"),
            "quantity": obj.get("quantity"),
            "service_end_date": obj.get("serviceEndDate"),
            "service_start_date": obj.get("serviceStartDate"),
            "subscription_id": obj.get("subscriptionId"),
            "subscription_name": obj.get("subscriptionName"),
            "subscription_number": obj.get("subscriptionNumber"),
            "tax_amount": obj.get("taxAmount"),
            "unit_of_measure": obj.get("unitOfMeasure")
        })
        return _obj


