# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictStr

class CreateInvoiceCollectCreditMemos(BaseModel):
    """
    CreateInvoiceCollectCreditMemos
    """
    id: Optional[StrictStr] = Field(None, description="The ID of the credit memo. ")
    total_amount: Optional[StrictStr] = Field(None, alias="totalAmount", description="The amount of the credit memo. ")
    memo_number: Optional[StrictStr] = Field(None, alias="memoNumber", description="The unique identification number of the credit memo. ")
    __properties = ["id", "totalAmount", "memoNumber"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> CreateInvoiceCollectCreditMemos:
        """Create an instance of CreateInvoiceCollectCreditMemos from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> CreateInvoiceCollectCreditMemos:
        """Create an instance of CreateInvoiceCollectCreditMemos from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return CreateInvoiceCollectCreditMemos.parse_obj(obj)

        _obj = CreateInvoiceCollectCreditMemos.parse_obj({
            "id": obj.get("id"),
            "total_amount": obj.get("totalAmount"),
            "memo_number": obj.get("memoNumber")
        })
        return _obj


