# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictBool, StrictStr, conlist
from com.zuora.models.create_invoice_collect_credit_memos import CreateInvoiceCollectCreditMemos
from com.zuora.models.create_invoice_collect_invoices import CreateInvoiceCollectInvoices

class CreateInvoiceCollectResponse(BaseModel):
    """
    CreateInvoiceCollectResponse
    """
    amount_collected: Optional[StrictStr] = Field(None, alias="amountCollected", description="Payment amount applied. ")
    credit_memos: Optional[conlist(CreateInvoiceCollectCreditMemos)] = Field(None, alias="creditMemos", description="Information on one or more credit memos associated with this operation. ")
    invoices: Optional[conlist(CreateInvoiceCollectInvoices)] = Field(None, description="Information on one or more invoices associated with this operation. ")
    payment_id: Optional[StrictStr] = Field(None, alias="paymentId", description="Payment ID. ")
    success: Optional[StrictBool] = Field(None, description="Returns `true` if the request was processed successfully. ")
    __properties = ["amountCollected", "creditMemos", "invoices", "paymentId", "success"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> CreateInvoiceCollectResponse:
        """Create an instance of CreateInvoiceCollectResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in credit_memos (list)
        _items = []
        if self.credit_memos:
            for _item in self.credit_memos:
                if _item:
                    _items.append(_item.to_dict())
            _dict['creditMemos'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in invoices (list)
        _items = []
        if self.invoices:
            for _item in self.invoices:
                if _item:
                    _items.append(_item.to_dict())
            _dict['invoices'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> CreateInvoiceCollectResponse:
        """Create an instance of CreateInvoiceCollectResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return CreateInvoiceCollectResponse.parse_obj(obj)

        _obj = CreateInvoiceCollectResponse.parse_obj({
            "amount_collected": obj.get("amountCollected"),
            "credit_memos": [CreateInvoiceCollectCreditMemos.from_dict(_item) for _item in obj.get("creditMemos")] if obj.get("creditMemos") is not None else None,
            "invoices": [CreateInvoiceCollectInvoices.from_dict(_item) for _item in obj.get("invoices")] if obj.get("invoices") is not None else None,
            "payment_id": obj.get("paymentId"),
            "success": obj.get("success")
        })
        return _obj


