# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional, Union
from pydantic import BaseModel, Field, StrictFloat, StrictInt, StrictStr

class CreateOrUpdateCatalogGroupProductRatePlan(BaseModel):
    """
    CreateOrUpdateCatalogGroupProductRatePlan
    """
    grade: Optional[Union[StrictFloat, StrictInt]] = Field(None, description="The grade that is assigned for the product rate plan. The value of this field must be a positive integer. The greater the value, the higher the grade.  A product rate plan to be added to a Grading catalog group must have one grade. You can specify a grade for a product rate plan in this request or update the product rate plan individually. ")
    id: Optional[StrictStr] = Field(None, description="The unique ID of the product rate plan. ")
    __properties = ["grade", "id"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> CreateOrUpdateCatalogGroupProductRatePlan:
        """Create an instance of CreateOrUpdateCatalogGroupProductRatePlan from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> CreateOrUpdateCatalogGroupProductRatePlan:
        """Create an instance of CreateOrUpdateCatalogGroupProductRatePlan from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return CreateOrUpdateCatalogGroupProductRatePlan.parse_obj(obj)

        _obj = CreateOrUpdateCatalogGroupProductRatePlan.parse_obj({
            "grade": obj.get("grade"),
            "id": obj.get("id")
        })
        return _obj


