# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from typing import Any, Dict, Optional, Union
from pydantic import BaseModel, Field, StrictBool, StrictFloat, StrictInt, StrictStr, constr

class CreateOrderOrderLineItem(BaseModel):
    """
    CreateOrderOrderLineItem
    """
    uom: Optional[StrictStr] = Field(None, alias="UOM", description="Specifies the units to measure usage. ")
    accounting_code: Optional[StrictStr] = Field(None, alias="accountingCode", description="The accounting code for the Order Line Item. ")
    adjustment_liability_accounting_code: Optional[StrictStr] = Field(None, alias="adjustmentLiabilityAccountingCode", description="The accounting code on the Order Line Item object for customers using [Zuora Billing - Revenue Integration](https://knowledgecenter.zuora.com/Zuora_Revenue/Zuora_Billing_-_Revenue_Integration). ")
    adjustment_revenue_accounting_code: Optional[StrictStr] = Field(None, alias="adjustmentRevenueAccountingCode", description="The accounting code on the Order Line Item object for customers using [Zuora Billing - Revenue Integration](https://knowledgecenter.zuora.com/Zuora_Revenue/Zuora_Billing_-_Revenue_Integration). ")
    currency: Optional[StrictStr] = Field(None, description="The currency for the Order Line Item.")
    amount_per_unit: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="amountPerUnit", description="The actual charged amount per unit for the Order Line Item.  If you set the `inlineDiscountType`, `inlineDiscountPerUnit`, and `listPricePerUnit` fields, the system will automatically generate the `amountPerUnit` field. You shall not set the `amountPerUnit` field by yourself. ")
    bill_target_date: Optional[date] = Field(None, alias="billTargetDate", description="The target date for the Order Line Item to be picked up by bill run for billing. ")
    bill_to: Optional[StrictStr] = Field(None, alias="billTo", description="The ID of a contact that belongs to the billing account of the order line item. Use this field to assign an existing account as the bill-to contact of an order line item. ")
    billing_rule: Optional[StrictStr] = Field(None, alias="billingRule")
    contract_asset_accounting_code: Optional[StrictStr] = Field(None, alias="contractAssetAccountingCode", description="The accounting code on the Order Line Item object for customers using [Zuora Billing - Revenue Integration](https://knowledgecenter.zuora.com/Zuora_Revenue/Zuora_Billing_-_Revenue_Integration). ")
    contract_liability_accounting_code: Optional[StrictStr] = Field(None, alias="contractLiabilityAccountingCode", description="The accounting code on the Order Line Item object for customers using [Zuora Billing - Revenue Integration](https://knowledgecenter.zuora.com/Zuora_Revenue/Zuora_Billing_-_Revenue_Integration). ")
    contract_recognized_revenue_accounting_code: Optional[StrictStr] = Field(None, alias="contractRecognizedRevenueAccountingCode", description="The accounting code on the Order Line Item object for customers using [Zuora Billing - Revenue Integration](https://knowledgecenter.zuora.com/Zuora_Revenue/Zuora_Billing_-_Revenue_Integration). ")
    custom_fields: Optional[Dict[str, Dict[str, Any]]] = Field(None, alias="customFields", description="Container for custom fields of an Order Line Item object. ")
    deferred_revenue_accounting_code: Optional[StrictStr] = Field(None, alias="deferredRevenueAccountingCode", description="The deferred revenue accounting code for the Order Line Item. ")
    description: Optional[StrictStr] = Field(None, description="The description of the Order Line Item. ")
    exclude_item_billing_from_revenue_accounting: Optional[StrictBool] = Field(None, alias="excludeItemBillingFromRevenueAccounting", description="The flag to exclude Order Line Item related invoice items, invoice item adjustments, credit memo items, and debit memo items from revenue accounting.  **Note**: This field is only available if you have the Billing - Revenue Integration feature enabled.  ")
    exclude_item_booking_from_revenue_accounting: Optional[StrictBool] = Field(None, alias="excludeItemBookingFromRevenueAccounting", description="The flag to exclude Order Line Item from revenue accounting.  **Note**: This field is only available if you have the Billing - Revenue Integration feature enabled. ")
    inline_discount_per_unit: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="inlineDiscountPerUnit", description="Use this field in accordance with the `inlineDiscountType` field, in the following manner: * If the `inlineDiscountType` field is set as `Percentage`, this field specifies the discount percentage for each unit of the order line item. For exmaple, if you specify `5` in this field, the discount percentage is 5%. * If the `inlineDiscountType` field is set as `FixedAmount`, this field specifies the discount amount on each unit of the order line item. For exmaple, if you specify `10` in this field, the discount amount on each unit of the order line item is 10.  Once you set the `inlineDiscountType`, `inlineDiscountPerUnit`, and `listPricePerUnit` fields, the system will automatically generate the `amountPerUnit` field. You shall not set the `amountPerUnit` field by yourself. ")
    inline_discount_type: Optional[StrictStr] = Field(None, alias="inlineDiscountType")
    invoice_group_number: Optional[constr(strict=True, max_length=255)] = Field(None, alias="invoiceGroupNumber", description="The invoice group number associated with the order line item. ")
    is_allocation_eligible: Optional[StrictBool] = Field(None, alias="isAllocationEligible", description="This field is used to identify if the charge segment is allocation eligible in revenue recognition.  **Note**: This feature is in the **Early Adopter** phase. If you want to use the feature, submit a request at <a href=\"https://support.zuora.com/\" target=\"_blank\">Zuora Global Support</a>, and we will evaluate whether the feature is suitable for your use cases. ")
    is_unbilled: Optional[StrictBool] = Field(None, alias="isUnbilled", description="This field is used to dictate how to perform the accounting during revenue recognition.  **Note**: This feature is in the **Early Adopter** phase. If you want to use the feature, submit a request at <a href=\"https://support.zuora.com/\" target=\"_blank\">Zuora Global Support</a>, and we will evaluate whether the feature is suitable for your use cases. ")
    item_category: Optional[StrictStr] = Field(None, alias="itemCategory")
    item_name: Optional[StrictStr] = Field(None, alias="itemName", description="The name of the Order Line Item. ")
    item_number: Optional[StrictStr] = Field(None, alias="itemNumber", description="The number of the Order Line Item. Use this field to specify a custom item number for your Order Line Item. If you are to use this field,  you must set all the item numbers in an order when there are several order line items in the order. ")
    item_state: Optional[StrictStr] = Field(None, alias="itemState")
    item_type: Optional[StrictStr] = Field(None, alias="itemType")
    list_price_per_unit: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="listPricePerUnit", description="The list price per unit for the Order Line Item. ")
    original_order_line_item_number: Optional[StrictStr] = Field(None, alias="originalOrderLineItemNumber", description="The number of the original sale order line item for a return order line item.  ")
    original_order_number: Optional[StrictStr] = Field(None, alias="originalOrderNumber", description="The number of the original sale order for a return order line item.  ")
    owner_account_number: Optional[StrictStr] = Field(None, alias="ownerAccountNumber", description="Use this field to assign an existing account as the owner of an order line item. ")
    product_code: Optional[StrictStr] = Field(None, alias="productCode", description="The product code for the Order Line Item. ")
    product_rate_plan_charge_id: Optional[StrictStr] = Field(None, alias="productRatePlanChargeId", description="Id of a Product Rate Plan Charge. Only one-time charges are supported. ")
    purchase_order_number: Optional[StrictStr] = Field(None, alias="purchaseOrderNumber", description="Used by customers to specify the Purchase Order Number provided by the buyer. ")
    quantity: Optional[Union[StrictFloat, StrictInt]] = Field(None, description="The quantity of units, such as the number of authors in a hosted wiki service. ")
    recognized_revenue_accounting_code: Optional[StrictStr] = Field(None, alias="recognizedRevenueAccountingCode", description="The recognized revenue accounting code for the Order Line Item. ")
    related_subscription_number: Optional[StrictStr] = Field(None, alias="relatedSubscriptionNumber", description="Use this field to relate an order line item to a subscription when you create the order line item.  * To relate an order line item to a new subscription which is yet to create in the same \"Create an order\" call, use this field in combination with the `subscriptions` > `subscriptionNumber` field in the \"Create an order\" operation. Specify this field to the same value as that of the `subscriptions` > `subscriptionNumber` field when you make the \"Create an order\" call. * To relate an order line item to an existing subscription, specify this field to the subscription number of the existing subscription. ")
    revenue_recognition_rule: Optional[StrictStr] = Field(None, alias="revenueRecognitionRule", description="The Revenue Recognition rule for the Order Line Item. ")
    sequence_set_id: Optional[StrictStr] = Field(None, alias="sequenceSetId", description="The ID of the sequence set associated with the OrderLineItem. ")
    sold_to: Optional[StrictStr] = Field(None, alias="soldTo", description="Use this field to assign an existing account as the sold-to contact of an order line item, by the following rules:  * If the `ownerAccountNumber` field is set, then this field must be the ID of a contact that belongs to the owner account of the order line item.  * If the `ownerAccountNumber` field is not set, then this field must be the ID of a contact that belongs to the billing account of the order line item. ")
    tax_code: Optional[StrictStr] = Field(None, alias="taxCode", description="The tax code for the Order Line Item. ")
    tax_mode: Optional[StrictStr] = Field(None, alias="taxMode")
    transaction_end_date: Optional[date] = Field(None, alias="transactionEndDate", description="The date a transaction is completed. The default value of this field is the transaction start date. Also, the value of this field should always equal or be later than the value of the `transactionStartDate` field. ")
    transaction_start_date: Optional[date] = Field(None, alias="transactionStartDate", description="The date a transaction starts. The default value of this field is the order date. ")
    unbilled_receivables_accounting_code: Optional[StrictStr] = Field(None, alias="unbilledReceivablesAccountingCode", description="The accounting code on the Order Line Item object for customers using [Zuora Billing - Revenue Integration](https://knowledgecenter.zuora.com/Zuora_Revenue/Zuora_Billing_-_Revenue_Integration). ")
    __properties = ["UOM", "accountingCode", "adjustmentLiabilityAccountingCode", "adjustmentRevenueAccountingCode", "currency", "amountPerUnit", "billTargetDate", "billTo", "billingRule", "contractAssetAccountingCode", "contractLiabilityAccountingCode", "contractRecognizedRevenueAccountingCode", "customFields", "deferredRevenueAccountingCode", "description", "excludeItemBillingFromRevenueAccounting", "excludeItemBookingFromRevenueAccounting", "inlineDiscountPerUnit", "inlineDiscountType", "invoiceGroupNumber", "isAllocationEligible", "isUnbilled", "itemCategory", "itemName", "itemNumber", "itemState", "itemType", "listPricePerUnit", "originalOrderLineItemNumber", "originalOrderNumber", "ownerAccountNumber", "productCode", "productRatePlanChargeId", "purchaseOrderNumber", "quantity", "recognizedRevenueAccountingCode", "relatedSubscriptionNumber", "revenueRecognitionRule", "sequenceSetId", "soldTo", "taxCode", "taxMode", "transactionEndDate", "transactionStartDate", "unbilledReceivablesAccountingCode"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> CreateOrderOrderLineItem:
        """Create an instance of CreateOrderOrderLineItem from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> CreateOrderOrderLineItem:
        """Create an instance of CreateOrderOrderLineItem from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return CreateOrderOrderLineItem.parse_obj(obj)

        _obj = CreateOrderOrderLineItem.parse_obj({
            "uom": obj.get("UOM"),
            "accounting_code": obj.get("accountingCode"),
            "adjustment_liability_accounting_code": obj.get("adjustmentLiabilityAccountingCode"),
            "adjustment_revenue_accounting_code": obj.get("adjustmentRevenueAccountingCode"),
            "currency": obj.get("currency"),
            "amount_per_unit": obj.get("amountPerUnit"),
            "bill_target_date": obj.get("billTargetDate"),
            "bill_to": obj.get("billTo"),
            "billing_rule": obj.get("billingRule"),
            "contract_asset_accounting_code": obj.get("contractAssetAccountingCode"),
            "contract_liability_accounting_code": obj.get("contractLiabilityAccountingCode"),
            "contract_recognized_revenue_accounting_code": obj.get("contractRecognizedRevenueAccountingCode"),
            "custom_fields": obj.get("customFields"),
            "deferred_revenue_accounting_code": obj.get("deferredRevenueAccountingCode"),
            "description": obj.get("description"),
            "exclude_item_billing_from_revenue_accounting": obj.get("excludeItemBillingFromRevenueAccounting"),
            "exclude_item_booking_from_revenue_accounting": obj.get("excludeItemBookingFromRevenueAccounting"),
            "inline_discount_per_unit": obj.get("inlineDiscountPerUnit"),
            "inline_discount_type": obj.get("inlineDiscountType"),
            "invoice_group_number": obj.get("invoiceGroupNumber"),
            "is_allocation_eligible": obj.get("isAllocationEligible"),
            "is_unbilled": obj.get("isUnbilled"),
            "item_category": obj.get("itemCategory"),
            "item_name": obj.get("itemName"),
            "item_number": obj.get("itemNumber"),
            "item_state": obj.get("itemState"),
            "item_type": obj.get("itemType"),
            "list_price_per_unit": obj.get("listPricePerUnit"),
            "original_order_line_item_number": obj.get("originalOrderLineItemNumber"),
            "original_order_number": obj.get("originalOrderNumber"),
            "owner_account_number": obj.get("ownerAccountNumber"),
            "product_code": obj.get("productCode"),
            "product_rate_plan_charge_id": obj.get("productRatePlanChargeId"),
            "purchase_order_number": obj.get("purchaseOrderNumber"),
            "quantity": obj.get("quantity"),
            "recognized_revenue_accounting_code": obj.get("recognizedRevenueAccountingCode"),
            "related_subscription_number": obj.get("relatedSubscriptionNumber"),
            "revenue_recognition_rule": obj.get("revenueRecognitionRule"),
            "sequence_set_id": obj.get("sequenceSetId"),
            "sold_to": obj.get("soldTo"),
            "tax_code": obj.get("taxCode"),
            "tax_mode": obj.get("taxMode"),
            "transaction_end_date": obj.get("transactionEndDate"),
            "transaction_start_date": obj.get("transactionStartDate"),
            "unbilled_receivables_accounting_code": obj.get("unbilledReceivablesAccountingCode")
        })
        return _obj


