# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictStr, conlist
from com.zuora.models.time_sliced_metrics import TimeSlicedMetrics
from com.zuora.models.time_sliced_net_metrics import TimeSlicedNetMetrics
from com.zuora.models.time_sliced_tcb_net_metrics import TimeSlicedTcbNetMetrics

class CreateOrderResponseOrderMetric(BaseModel):
    """
    The order metrics in create order response.  # noqa: E501
    """
    charge_number: Optional[StrictStr] = Field(None, alias="chargeNumber")
    mrr: Optional[conlist(TimeSlicedNetMetrics)] = None
    quantity: Optional[conlist(TimeSlicedMetrics)] = None
    tcb: Optional[conlist(TimeSlicedTcbNetMetrics)] = Field(None, description="Total contracted billing which is the forecast value for the total invoice amount.")
    tcv: Optional[conlist(TimeSlicedNetMetrics)] = Field(None, description="Total contracted value.")
    __properties = ["chargeNumber", "mrr", "quantity", "tcb", "tcv"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> CreateOrderResponseOrderMetric:
        """Create an instance of CreateOrderResponseOrderMetric from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in mrr (list)
        _items = []
        if self.mrr:
            for _item in self.mrr:
                if _item:
                    _items.append(_item.to_dict())
            _dict['mrr'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in quantity (list)
        _items = []
        if self.quantity:
            for _item in self.quantity:
                if _item:
                    _items.append(_item.to_dict())
            _dict['quantity'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in tcb (list)
        _items = []
        if self.tcb:
            for _item in self.tcb:
                if _item:
                    _items.append(_item.to_dict())
            _dict['tcb'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in tcv (list)
        _items = []
        if self.tcv:
            for _item in self.tcv:
                if _item:
                    _items.append(_item.to_dict())
            _dict['tcv'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> CreateOrderResponseOrderMetric:
        """Create an instance of CreateOrderResponseOrderMetric from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return CreateOrderResponseOrderMetric.parse_obj(obj)

        _obj = CreateOrderResponseOrderMetric.parse_obj({
            "charge_number": obj.get("chargeNumber"),
            "mrr": [TimeSlicedNetMetrics.from_dict(_item) for _item in obj.get("mrr")] if obj.get("mrr") is not None else None,
            "quantity": [TimeSlicedMetrics.from_dict(_item) for _item in obj.get("quantity")] if obj.get("quantity") is not None else None,
            "tcb": [TimeSlicedTcbNetMetrics.from_dict(_item) for _item in obj.get("tcb")] if obj.get("tcb") is not None else None,
            "tcv": [TimeSlicedNetMetrics.from_dict(_item) for _item in obj.get("tcv")] if obj.get("tcv") is not None else None
        })
        return _obj


