# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictStr, conlist
from com.zuora.models.create_order_response_order_action import CreateOrderResponseOrderAction

class CreateOrderResponseSubscriptions(BaseModel):
    """
    CreateOrderResponseSubscriptions
    """
    status: Optional[StrictStr] = None
    subscription_id: Optional[StrictStr] = Field(None, alias="subscriptionId", description="Subscription ID of the subscription included in this order. This field is returned instead of the `subscriptionNumber` field if the `returnIds` query parameter is set to `true`.")
    subscription_number: Optional[StrictStr] = Field(None, alias="subscriptionNumber", description="Subscription number of the subscription included in this order.")
    subscription_owner_id: Optional[StrictStr] = Field(None, alias="subscriptionOwnerId", description="subscription owner account id of the subscription")
    subscription_owner_number: Optional[StrictStr] = Field(None, alias="subscriptionOwnerNumber", description="subscription owner account number of the subscription")
    order_actions: Optional[conlist(CreateOrderResponseOrderAction)] = Field(None, alias="OrderActions", description="subscription order action metrics")
    __properties = ["status", "subscriptionId", "subscriptionNumber", "subscriptionOwnerId", "subscriptionOwnerNumber", "OrderActions"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> CreateOrderResponseSubscriptions:
        """Create an instance of CreateOrderResponseSubscriptions from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in order_actions (list)
        _items = []
        if self.order_actions:
            for _item in self.order_actions:
                if _item:
                    _items.append(_item.to_dict())
            _dict['OrderActions'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> CreateOrderResponseSubscriptions:
        """Create an instance of CreateOrderResponseSubscriptions from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return CreateOrderResponseSubscriptions.parse_obj(obj)

        _obj = CreateOrderResponseSubscriptions.parse_obj({
            "status": obj.get("status"),
            "subscription_id": obj.get("subscriptionId"),
            "subscription_number": obj.get("subscriptionNumber"),
            "subscription_owner_id": obj.get("subscriptionOwnerId"),
            "subscription_owner_number": obj.get("subscriptionOwnerNumber"),
            "order_actions": [CreateOrderResponseOrderAction.from_dict(_item) for _item in obj.get("OrderActions")] if obj.get("OrderActions") is not None else None
        })
        return _obj


