# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional, Union
from pydantic import BaseModel, Field, StrictFloat, StrictInt, StrictStr

class CreateOrderResponseWriteOff(BaseModel):
    """
    CreateOrderResponseWriteOff
    """
    amount: Optional[Union[StrictFloat, StrictInt]] = Field(None, description="The amount written off from the invoice balance.")
    failed_reason: Optional[StrictStr] = Field(None, alias="failedReason", description="The reason of write-off failure.")
    invoice_number: Optional[StrictStr] = Field(None, alias="invoiceNumber", description="The number of the invoice that is written off. For example, `INV00051208`.")
    status: Optional[StrictStr] = None
    write_off_credit_memo_number: Optional[StrictStr] = Field(None, alias="writeOffCreditMemoNumber", description="The number of the credit memo that is written off.")
    __properties = ["amount", "failedReason", "invoiceNumber", "status", "writeOffCreditMemoNumber"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> CreateOrderResponseWriteOff:
        """Create an instance of CreateOrderResponseWriteOff from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> CreateOrderResponseWriteOff:
        """Create an instance of CreateOrderResponseWriteOff from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return CreateOrderResponseWriteOff.parse_obj(obj)

        _obj = CreateOrderResponseWriteOff.parse_obj({
            "amount": obj.get("amount"),
            "failed_reason": obj.get("failedReason"),
            "invoice_number": obj.get("invoiceNumber"),
            "status": obj.get("status"),
            "write_off_credit_memo_number": obj.get("writeOffCreditMemoNumber")
        })
        return _obj


