# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from typing import Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr

class CreateOrderSuspend(BaseModel):
    """
    Information about an order action of type `Suspend`.   # noqa: E501
    """
    suspend_periods: Optional[StrictInt] = Field(None, alias="suspendPeriods", description="This field is applicable only when the `suspendPolicy` field is set to `FixedPeriodsFromToday`. It must be used together with the `suspendPeriodsType` field.   The total number of the periods used to specify when a subscription suspension takes effect. The subscription suspension will take place after the specified time frame (`suspendPeriods` multiplied by `suspendPeriodsType`) from today's date.  ")
    suspend_periods_type: Optional[StrictStr] = Field(None, alias="suspendPeriodsType")
    suspend_policy: StrictStr = Field(..., alias="suspendPolicy")
    suspend_specific_date: Optional[date] = Field(None, alias="suspendSpecificDate", description="This field is applicable only when the `suspendPolicy` field is set to `SpecificDate`.  A specific date when the subscription suspension takes effect, in YYYY-MM-DD format. The value should not be earlier than the subscription's contract effective date or later than the subscription's term end date. ")
    __properties = ["suspendPeriods", "suspendPeriodsType", "suspendPolicy", "suspendSpecificDate"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> CreateOrderSuspend:
        """Create an instance of CreateOrderSuspend from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> CreateOrderSuspend:
        """Create an instance of CreateOrderSuspend from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return CreateOrderSuspend.parse_obj(obj)

        _obj = CreateOrderSuspend.parse_obj({
            "suspend_periods": obj.get("suspendPeriods"),
            "suspend_periods_type": obj.get("suspendPeriodsType"),
            "suspend_policy": obj.get("suspendPolicy"),
            "suspend_specific_date": obj.get("suspendSpecificDate")
        })
        return _obj


