# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional, Union
from pydantic import BaseModel, Field, StrictFloat, StrictInt, StrictStr

class CreatePaymentDebitMemoApplicationItem(BaseModel):
    """
    CreatePaymentDebitMemoApplicationItem
    """
    amount: Union[StrictFloat, StrictInt] = Field(..., description="The amount of the payment associated with the specific debit memo or taxation item. ")
    debit_memo_item_id: Optional[StrictStr] = Field(None, alias="debitMemoItemId", description="The ID of the specific debit memo item. ")
    tax_item_id: Optional[StrictStr] = Field(None, alias="taxItemId", description="The ID of the specific taxation item. ")
    __properties = ["amount", "debitMemoItemId", "taxItemId"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> CreatePaymentDebitMemoApplicationItem:
        """Create an instance of CreatePaymentDebitMemoApplicationItem from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> CreatePaymentDebitMemoApplicationItem:
        """Create an instance of CreatePaymentDebitMemoApplicationItem from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return CreatePaymentDebitMemoApplicationItem.parse_obj(obj)

        _obj = CreatePaymentDebitMemoApplicationItem.parse_obj({
            "amount": obj.get("amount"),
            "debit_memo_item_id": obj.get("debitMemoItemId"),
            "tax_item_id": obj.get("taxItemId")
        })
        return _obj


