# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictStr
from com.zuora.models.create_payment_method_bank_transfer_account_holder_info import CreatePaymentMethodBankTransferAccountHolderInfo

class CreatePaymentMethodBankTransfer(BaseModel):
    """
    CreatePaymentMethodBankTransfer
    """
    iban: Optional[StrictStr] = Field(None, alias="IBAN", description="The International Bank Account Number. This field is required if the `type` field is set to `SEPA`. ")
    account_holder_info: Optional[CreatePaymentMethodBankTransferAccountHolderInfo] = Field(None, alias="accountHolderInfo")
    account_number: Optional[StrictStr] = Field(None, alias="accountNumber", description="The number of the customer's bank account. This field is required for the following bank transfer payment methods:   - Direct Entry AU (`Becs`)   - Direct Debit NZ (`Becsnz`)   - Direct Debit UK (`Bacs`)   - Denmark Direct Debit (`Betalingsservice`)   - Sweden Direct Debit (`Autogiro`)   - Canadian Pre-Authorized Debit (`PAD`) ")
    bank_code: Optional[StrictStr] = Field(None, alias="bankCode", description="The sort code or number that identifies the bank. This is also known as the sort code. This field is required for the following bank transfer payment methods:   - Direct Debit UK (`Bacs`)   - Denmark Direct Debit (`Betalingsservice`)   - Direct Debit NZ (`Becsnz`)   - Canadian Pre-Authorized Debit (`PAD`) ")
    branch_code: Optional[StrictStr] = Field(None, alias="branchCode", description="The branch code of the bank used for direct debit. This field is required for the following bank transfer payment methods:   - Sweden Direct Debit (`Autogiro`)   - Direct Entry AU (`Becs`)   - Direct Debit NZ (`Becsnz`)   - Canadian Pre-Authorized Debit (`PAD`) ")
    business_identification_code: Optional[StrictStr] = Field(None, alias="businessIdentificationCode", description="The BIC code used for SEPA. ")
    currency_code: Optional[StrictStr] = Field(None, alias="currencyCode", description="The currency used for payment method authorization.  If this field is not specified, `currency` specified for the account is used for payment method authorization. If no currency is specified for the account, the default currency of the account is then used. ")
    identity_number: Optional[StrictStr] = Field(None, alias="identityNumber", description="The identity number of the customer. This field is required for the following bank transfer payment methods:   - Denmark Direct Debit (`Betalingsservice`)   - Sweden Direct Debit (`Autogiro`) ")
    __properties = ["IBAN", "accountHolderInfo", "accountNumber", "bankCode", "branchCode", "businessIdentificationCode", "currencyCode", "identityNumber"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> CreatePaymentMethodBankTransfer:
        """Create an instance of CreatePaymentMethodBankTransfer from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of account_holder_info
        if self.account_holder_info:
            _dict['accountHolderInfo'] = self.account_holder_info.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> CreatePaymentMethodBankTransfer:
        """Create an instance of CreatePaymentMethodBankTransfer from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return CreatePaymentMethodBankTransfer.parse_obj(obj)

        _obj = CreatePaymentMethodBankTransfer.parse_obj({
            "iban": obj.get("IBAN"),
            "account_holder_info": CreatePaymentMethodBankTransferAccountHolderInfo.from_dict(obj.get("accountHolderInfo")) if obj.get("accountHolderInfo") is not None else None,
            "account_number": obj.get("accountNumber"),
            "bank_code": obj.get("bankCode"),
            "branch_code": obj.get("branchCode"),
            "business_identification_code": obj.get("businessIdentificationCode"),
            "currency_code": obj.get("currencyCode"),
            "identity_number": obj.get("identityNumber")
        })
        return _obj


