# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictBool, StrictStr

class CreatePaymentMethodDecryptionResponse(BaseModel):
    """
    CreatePaymentMethodDecryptionResponse
    """
    amount: Optional[StrictStr] = Field(None, description="The payment amount contained within the encrypted token. ")
    payment_id: Optional[StrictStr] = Field(None, alias="paymentId", description="The ID of newly processed payment, ")
    payment_method_id: Optional[StrictStr] = Field(None, alias="paymentMethodId", description="ID of the newly-created payment method. ")
    success: Optional[StrictBool] = Field(None, description="Returns `true` if the request was processed successfully. ")
    __properties = ["amount", "paymentId", "paymentMethodId", "success"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> CreatePaymentMethodDecryptionResponse:
        """Create an instance of CreatePaymentMethodDecryptionResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> CreatePaymentMethodDecryptionResponse:
        """Create an instance of CreatePaymentMethodDecryptionResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return CreatePaymentMethodDecryptionResponse.parse_obj(obj)

        _obj = CreatePaymentMethodDecryptionResponse.parse_obj({
            "amount": obj.get("amount"),
            "payment_id": obj.get("paymentId"),
            "payment_method_id": obj.get("paymentMethodId"),
            "success": obj.get("success")
        })
        return _obj


