# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictStr

class CreatePaymentMethodPayPalECPayPalNativeECPayPalCP(BaseModel):
    """
    CreatePaymentMethodPayPalECPayPalNativeECPayPalCP
    """
    baid: Optional[StrictStr] = Field(None, alias="BAID", description="ID of a PayPal billing agreement. For example, I-1TJ3GAGG82Y9. ")
    email: Optional[StrictStr] = Field(None, description="Email address associated with the payment method. This field is supported for the following payment methods:   - PayPal payment methods. This field is required for creating any of the following PayPal payment methods.     - PayPal Express Checkout     - PayPal Adaptive     - PayPal Commerce Platform   - Apple Pay and Google Pay payment methods on Adyen v2.0. This field will be passed to Adyen as `shopperEmail`. ")
    __properties = ["BAID", "email"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> CreatePaymentMethodPayPalECPayPalNativeECPayPalCP:
        """Create an instance of CreatePaymentMethodPayPalECPayPalNativeECPayPalCP from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> CreatePaymentMethodPayPalECPayPalNativeECPayPalCP:
        """Create an instance of CreatePaymentMethodPayPalECPayPalNativeECPayPalCP from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return CreatePaymentMethodPayPalECPayPalNativeECPayPalCP.parse_obj(obj)

        _obj = CreatePaymentMethodPayPalECPayPalNativeECPayPalCP.parse_obj({
            "baid": obj.get("BAID"),
            "email": obj.get("email")
        })
        return _obj


