# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictBool, StrictStr, conlist
from com.zuora.models.create_payment_method_updater_batch_response_reasons import CreatePaymentMethodUpdaterBatchResponseReasons

class CreatePaymentMethodUpdaterBatchResponse(BaseModel):
    """
    CreatePaymentMethodUpdaterBatchResponse
    """
    process_id: Optional[StrictStr] = Field(None, alias="processId", description="The ID of the running process when the exception occurs. This field is available only if the `success` field is `false`. ")
    reasons: Optional[conlist(CreatePaymentMethodUpdaterBatchResponseReasons)] = Field(None, description="The container of the error code and message. This field is available only if the `success` field is `false`. ")
    request_id: Optional[StrictStr] = Field(None, alias="requestId", description="The ID of the request. This field is available only if the `success` field is `false` ")
    success: Optional[StrictBool] = Field(None, description="Indicates whether the request to create a PMU batch is sent successfully. ")
    __properties = ["processId", "reasons", "requestId", "success"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> CreatePaymentMethodUpdaterBatchResponse:
        """Create an instance of CreatePaymentMethodUpdaterBatchResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in reasons (list)
        _items = []
        if self.reasons:
            for _item in self.reasons:
                if _item:
                    _items.append(_item.to_dict())
            _dict['reasons'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> CreatePaymentMethodUpdaterBatchResponse:
        """Create an instance of CreatePaymentMethodUpdaterBatchResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return CreatePaymentMethodUpdaterBatchResponse.parse_obj(obj)

        _obj = CreatePaymentMethodUpdaterBatchResponse.parse_obj({
            "process_id": obj.get("processId"),
            "reasons": [CreatePaymentMethodUpdaterBatchResponseReasons.from_dict(_item) for _item in obj.get("reasons")] if obj.get("reasons") is not None else None,
            "request_id": obj.get("requestId"),
            "success": obj.get("success")
        })
        return _obj


