# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictBool, conlist
from com.zuora.models.create_payment_schedules_response_items import CreatePaymentSchedulesResponseItems

class CreatePaymentSchedulesResponse(BaseModel):
    """
    Container of the payment schedules that are created.   # noqa: E501
    """
    payment_schedules: Optional[conlist(CreatePaymentSchedulesResponseItems)] = Field(None, alias="paymentSchedules", description="Container for payment parts. ")
    success: Optional[StrictBool] = Field(None, description="Returns `true` if the request was processed successfully.")
    __properties = ["paymentSchedules", "success"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> CreatePaymentSchedulesResponse:
        """Create an instance of CreatePaymentSchedulesResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in payment_schedules (list)
        _items = []
        if self.payment_schedules:
            for _item in self.payment_schedules:
                if _item:
                    _items.append(_item.to_dict())
            _dict['paymentSchedules'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> CreatePaymentSchedulesResponse:
        """Create an instance of CreatePaymentSchedulesResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return CreatePaymentSchedulesResponse.parse_obj(obj)

        _obj = CreatePaymentSchedulesResponse.parse_obj({
            "payment_schedules": [CreatePaymentSchedulesResponseItems.from_dict(_item) for _item in obj.get("paymentSchedules")] if obj.get("paymentSchedules") is not None else None,
            "success": obj.get("success")
        })
        return _obj


