# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional, Union
from pydantic import BaseModel, Field, StrictBool, StrictFloat, StrictInt, StrictStr

class CreateSubscriptionResponse(BaseModel):
    """
    CreateSubscriptionResponse
    """
    contracted_mrr: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="contractedMrr", description="Monthly recurring revenue of the subscription. ")
    credit_memo_id: Optional[StrictStr] = Field(None, alias="creditMemoId", description="The credit memo ID, if a credit memo is generated during the subscription process.  **Note:** This container is only available if you set the Zuora REST API minor version to 207.0 or later in the request header, and you have  [Invoice Settlement](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/Invoice_Settlement) enabled. The Invoice Settlement feature is generally available as of Zuora Billing Release 296 (March 2021). This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement, see [Invoice Settlement Enablement and Checklist Guide](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/Invoice_Settlement/Invoice_Settlement_Migration_Checklist_and_Guide) for more information. ")
    invoice_id: Optional[StrictStr] = Field(None, alias="invoiceId", description="Invoice ID, if an invoice is generated during the subscription process. ")
    paid_amount: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="paidAmount", description="Payment amount, if a payment is collected. ")
    payment_id: Optional[StrictStr] = Field(None, alias="paymentId", description="Payment ID, if a payment is collected. ")
    subscription_id: Optional[StrictStr] = Field(None, alias="subscriptionId")
    subscription_number: Optional[StrictStr] = Field(None, alias="subscriptionNumber")
    success: Optional[StrictBool] = Field(None, description="Returns `true` if the request was processed successfully. ")
    total_contracted_value: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="totalContractedValue", description="Total contracted value of the subscription. ")
    __properties = ["contractedMrr", "creditMemoId", "invoiceId", "paidAmount", "paymentId", "subscriptionId", "subscriptionNumber", "success", "totalContractedValue"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> CreateSubscriptionResponse:
        """Create an instance of CreateSubscriptionResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> CreateSubscriptionResponse:
        """Create an instance of CreateSubscriptionResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return CreateSubscriptionResponse.parse_obj(obj)

        _obj = CreateSubscriptionResponse.parse_obj({
            "contracted_mrr": obj.get("contractedMrr"),
            "credit_memo_id": obj.get("creditMemoId"),
            "invoice_id": obj.get("invoiceId"),
            "paid_amount": obj.get("paidAmount"),
            "payment_id": obj.get("paymentId"),
            "subscription_id": obj.get("subscriptionId"),
            "subscription_number": obj.get("subscriptionNumber"),
            "success": obj.get("success"),
            "total_contracted_value": obj.get("totalContractedValue")
        })
        return _obj


