# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from typing import Optional, Union
from pydantic import BaseModel, Field, StrictFloat, StrictInt, StrictStr, condecimal

class CreateTaxationItem(BaseModel):
    """
    CreateTaxationItem
    """
    exempt_amount: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="exemptAmount", description="The calculated tax amount excluded due to the exemption.")
    jurisdiction: Optional[StrictStr] = Field(None, description="The jurisdiction that applies the tax or VAT. This value is typically a state, province, county, or city.")
    location_code: Optional[StrictStr] = Field(None, alias="locationCode", description="The identifier for the location based on the value of the `taxCode` field.")
    name: StrictStr = Field(..., description="The name of taxation.")
    tax_amount: Union[StrictFloat, StrictInt] = Field(..., alias="taxAmount", description="The amount of the taxation item in the invoice item.")
    tax_code: StrictStr = Field(..., alias="taxCode", description="The tax code identifies which tax rules and tax rates to apply to a specific invoice item.")
    tax_code_description: Optional[StrictStr] = Field(None, alias="taxCodeDescription", description="The description of the tax code.")
    tax_date: date = Field(..., alias="taxDate", description="The date that the tax is applied to the invoice item, in `yyyy-mm-dd` format.")
    tax_mode: StrictStr = Field(..., alias="taxMode")
    tax_rate: condecimal() = Field(..., alias="taxRate", description="The tax rate applied to the invoice item.")
    tax_rate_description: Optional[StrictStr] = Field(None, alias="taxRateDescription", description="The description of the tax rate.")
    tax_rate_type: StrictStr = Field(..., alias="taxRateType")
    additional_properties: Dict[str, Any] = {}
    __properties = ["exemptAmount", "jurisdiction", "locationCode", "name", "taxAmount", "taxCode", "taxCodeDescription", "taxDate", "taxMode", "taxRate", "taxRateDescription", "taxRateType"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> CreateTaxationItem:
        """Create an instance of CreateTaxationItem from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                            "additional_properties"
                          },
                          exclude_none=True)
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> CreateTaxationItem:
        """Create an instance of CreateTaxationItem from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return CreateTaxationItem.parse_obj(obj)

        _obj = CreateTaxationItem.parse_obj({
            "exempt_amount": obj.get("exemptAmount"),
            "jurisdiction": obj.get("jurisdiction"),
            "location_code": obj.get("locationCode"),
            "name": obj.get("name"),
            "tax_amount": obj.get("taxAmount"),
            "tax_code": obj.get("taxCode"),
            "tax_code_description": obj.get("taxCodeDescription"),
            "tax_date": obj.get("taxDate"),
            "tax_mode": obj.get("taxMode"),
            "tax_rate": obj.get("taxRate"),
            "tax_rate_description": obj.get("taxRateDescription"),
            "tax_rate_type": obj.get("taxRateType")
        })
        # store additional fields in additional_properties
        for _key in obj.keys():
            if _key not in cls.__properties:
                _obj.additional_properties[_key] = obj.get(_key)

        return _obj


