# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json



from pydantic import BaseModel, Field, StrictStr, constr

class CreateTokenRequest(BaseModel):
    """
    CreateTokenRequest
    """
    client_id: constr(strict=True, max_length=36, min_length=36) = Field(..., description="The Client ID of the OAuth client. ")
    client_secret: constr(strict=True, max_length=42) = Field(..., description="The Client Secret that was displayed when the OAuth client was created. ")
    grant_type: StrictStr = Field(...)
    __properties = ["client_id", "client_secret", "grant_type"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> CreateTokenRequest:
        """Create an instance of CreateTokenRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> CreateTokenRequest:
        """Create an instance of CreateTokenRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return CreateTokenRequest.parse_obj(obj)

        _obj = CreateTokenRequest.parse_obj({
            "client_id": obj.get("client_id"),
            "client_secret": obj.get("client_secret"),
            "grant_type": obj.get("grant_type")
        })
        return _obj


