# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictBool, StrictInt, StrictStr

class CreateUpdateStoredCredentialProfileResponse(BaseModel):
    """
    CreateUpdateStoredCredentialProfileResponse
    """
    number: Optional[StrictInt] = Field(None, description="The number that identifies the stored credential profile within the payment method. ")
    payment_method_id: Optional[StrictStr] = Field(None, alias="paymentMethodId", description="ID of the payment method. ")
    success: Optional[StrictBool] = None
    __properties = ["number", "paymentMethodId", "success"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> CreateUpdateStoredCredentialProfileResponse:
        """Create an instance of CreateUpdateStoredCredentialProfileResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> CreateUpdateStoredCredentialProfileResponse:
        """Create an instance of CreateUpdateStoredCredentialProfileResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return CreateUpdateStoredCredentialProfileResponse.parse_obj(obj)

        _obj = CreateUpdateStoredCredentialProfileResponse.parse_obj({
            "number": obj.get("number"),
            "payment_method_id": obj.get("paymentMethodId"),
            "success": obj.get("success")
        })
        return _obj


