# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List
from pydantic import BaseModel, Field, conlist
from com.zuora.models.custom_object_bulk_delete_filter_condition import CustomObjectBulkDeleteFilterCondition

class CustomObjectBulkDeleteFilter(BaseModel):
    """
    Filters to determine which records to be deleted in the bulk delete operation.  # noqa: E501
    """
    conditions: conlist(CustomObjectBulkDeleteFilterCondition) = Field(..., description="Group of field filter conditions that are evaluated in conjunction with each other using the AND operator. The minimum number of conditions is 1 and the maximum is 2.")
    __properties = ["conditions"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> CustomObjectBulkDeleteFilter:
        """Create an instance of CustomObjectBulkDeleteFilter from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in conditions (list)
        _items = []
        if self.conditions:
            for _item in self.conditions:
                if _item:
                    _items.append(_item.to_dict())
            _dict['conditions'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> CustomObjectBulkDeleteFilter:
        """Create an instance of CustomObjectBulkDeleteFilter from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return CustomObjectBulkDeleteFilter.parse_obj(obj)

        _obj = CustomObjectBulkDeleteFilter.parse_obj({
            "conditions": [CustomObjectBulkDeleteFilterCondition.from_dict(_item) for _item in obj.get("conditions")] if obj.get("conditions") is not None else None
        })
        return _obj


