# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictStr
from com.zuora.models.custom_object_bulk_delete_filter import CustomObjectBulkDeleteFilter

class CustomObjectBulkJobRequest(BaseModel):
    """
    CustomObjectBulkJobRequest
    """
    filter: Optional[CustomObjectBulkDeleteFilter] = None
    namespace: StrictStr = Field(...)
    object: StrictStr = Field(..., description="The object that the bulk operation performs on.")
    operation: StrictStr = Field(...)
    __properties = ["filter", "namespace", "object", "operation"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> CustomObjectBulkJobRequest:
        """Create an instance of CustomObjectBulkJobRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of filter
        if self.filter:
            _dict['filter'] = self.filter.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> CustomObjectBulkJobRequest:
        """Create an instance of CustomObjectBulkJobRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return CustomObjectBulkJobRequest.parse_obj(obj)

        _obj = CustomObjectBulkJobRequest.parse_obj({
            "filter": CustomObjectBulkDeleteFilter.from_dict(obj.get("filter")) if obj.get("filter") is not None else None,
            "namespace": obj.get("namespace"),
            "object": obj.get("object"),
            "operation": obj.get("operation")
        })
        return _obj


