# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr, conlist
from com.zuora.models.custom_object_bulk_job_response import CustomObjectBulkJobResponse

class CustomObjectBulkJobResponseCollection(BaseModel):
    """
    CustomObjectBulkJobResponseCollection
    """
    count: Optional[StrictInt] = Field(None, description="The number of custom object bulk jobs returned in the result page set.")
    cursor: Optional[StrictStr] = Field(None, description="The `cursor` points to the last job record of the current page.")
    jobs: conlist(CustomObjectBulkJobResponse) = Field(..., description="All custom object bulk jobs returned in the result page set.")
    __properties = ["count", "cursor", "jobs"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> CustomObjectBulkJobResponseCollection:
        """Create an instance of CustomObjectBulkJobResponseCollection from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in jobs (list)
        _items = []
        if self.jobs:
            for _item in self.jobs:
                if _item:
                    _items.append(_item.to_dict())
            _dict['jobs'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> CustomObjectBulkJobResponseCollection:
        """Create an instance of CustomObjectBulkJobResponseCollection from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return CustomObjectBulkJobResponseCollection.parse_obj(obj)

        _obj = CustomObjectBulkJobResponseCollection.parse_obj({
            "count": obj.get("count"),
            "cursor": obj.get("cursor"),
            "jobs": [CustomObjectBulkJobResponse.from_dict(_item) for _item in obj.get("jobs")] if obj.get("jobs") is not None else None
        })
        return _obj


