# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict, List, Optional
from pydantic import BaseModel, Field, StrictBool, StrictStr, conlist

class CustomObjectRecordBatchAction(BaseModel):
    """
    The batch action on custom object records  # noqa: E501
    """
    allow_partial_success: Optional[StrictBool] = Field(False, alias="allowPartialSuccess", description="Indicates whether the records that pass the schema validation should be updated when not all records in the request pass the schema validation.  Only applicable when `type` is `update`. ")
    ids: Optional[conlist(StrictStr)] = Field(None, description="Ids of the custom object records that you want to delete. Each ID must be a string of 36 characters. Only applicable when `type` is `delete`.")
    records: Optional[Dict[str, Dict[str, Any]]] = Field(None, description="Object records that you want to update. Only applicable when `type` is `update`.")
    type: StrictStr = Field(...)
    __properties = ["allowPartialSuccess", "ids", "records", "type"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> CustomObjectRecordBatchAction:
        """Create an instance of CustomObjectRecordBatchAction from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> CustomObjectRecordBatchAction:
        """Create an instance of CustomObjectRecordBatchAction from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return CustomObjectRecordBatchAction.parse_obj(obj)

        _obj = CustomObjectRecordBatchAction.parse_obj({
            "allow_partial_success": obj.get("allowPartialSuccess") if obj.get("allowPartialSuccess") is not None else False,
            "ids": obj.get("ids"),
            "records": obj.get("records"),
            "type": obj.get("type")
        })
        return _obj


