# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json



from pydantic import BaseModel, Field
from com.zuora.models.custom_object_record_batch_action import CustomObjectRecordBatchAction

class CustomObjectRecordBatchRequest(BaseModel):
    """
    Request of processing custom object records in batch.  # noqa: E501
    """
    action: CustomObjectRecordBatchAction = Field(...)
    __properties = ["action"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> CustomObjectRecordBatchRequest:
        """Create an instance of CustomObjectRecordBatchRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of action
        if self.action:
            _dict['action'] = self.action.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> CustomObjectRecordBatchRequest:
        """Create an instance of CustomObjectRecordBatchRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return CustomObjectRecordBatchRequest.parse_obj(obj)

        _obj = CustomObjectRecordBatchRequest.parse_obj({
            "action": CustomObjectRecordBatchAction.from_dict(obj.get("action")) if obj.get("action") is not None else None
        })
        return _obj


