# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import Optional
from pydantic import BaseModel, Field, StrictStr, constr

class CustomObjectRecordWithAllFields(BaseModel):
    """
    Record data from an object  # noqa: E501
    """
    created_by_id: Optional[StrictStr] = Field(None, alias="CreatedById", description="The creator's Id")
    created_date: Optional[datetime] = Field(None, alias="CreatedDate", description="The record creation time in the date-time format")
    id: Optional[constr(strict=True, max_length=36, min_length=36)] = Field(None, alias="Id", description="The unique Id of the custom object record")
    updated_by_id: Optional[StrictStr] = Field(None, alias="UpdatedById", description="The modifier's Id")
    updated_date: Optional[datetime] = Field(None, alias="UpdatedDate", description="The record modification time in the date-time format")
    type: Optional[StrictStr] = Field(None, description="The type of the custom object record. It is the API name of the custom object definition.")
    __properties = ["CreatedById", "CreatedDate", "Id", "UpdatedById", "UpdatedDate", "type"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> CustomObjectRecordWithAllFields:
        """Create an instance of CustomObjectRecordWithAllFields from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> CustomObjectRecordWithAllFields:
        """Create an instance of CustomObjectRecordWithAllFields from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return CustomObjectRecordWithAllFields.parse_obj(obj)

        _obj = CustomObjectRecordWithAllFields.parse_obj({
            "created_by_id": obj.get("CreatedById"),
            "created_date": obj.get("CreatedDate"),
            "id": obj.get("Id"),
            "updated_by_id": obj.get("UpdatedById"),
            "updated_date": obj.get("UpdatedDate"),
            "type": obj.get("type")
        })
        return _obj


