# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr
from com.zuora.models.custom_object_record_with_all_fields import CustomObjectRecordWithAllFields

class CustomObjectRecordsWithError(BaseModel):
    """
    CustomObjectRecordsWithError
    """
    code: Optional[StrictInt] = Field(None, description="See [Custom Objects API error code](https://knowledgecenter.zuora.com/Central_Platform/Custom_Objects/Z_Custom_Objects_API#Custom_Objects_API_error_code) for details. ")
    message: Optional[StrictStr] = None
    record: Optional[CustomObjectRecordWithAllFields] = None
    __properties = ["code", "message", "record"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> CustomObjectRecordsWithError:
        """Create an instance of CustomObjectRecordsWithError from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of record
        if self.record:
            _dict['record'] = self.record.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> CustomObjectRecordsWithError:
        """Create an instance of CustomObjectRecordsWithError from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return CustomObjectRecordsWithError.parse_obj(obj)

        _obj = CustomObjectRecordsWithError.parse_obj({
            "code": obj.get("code"),
            "message": obj.get("message"),
            "record": CustomObjectRecordWithAllFields.from_dict(obj.get("record")) if obj.get("record") is not None else None
        })
        return _obj


