# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr, constr

class DataQueryJobCommon(BaseModel):
    """
    DataQueryJobCommon
    """
    created_by: Optional[constr(strict=True, max_length=64, min_length=64)] = Field(None, alias="createdBy", description="The query job creator's Id. ")
    id: Optional[constr(strict=True, max_length=64, min_length=64)] = Field(None, description="Internal identifier of the query job. ")
    query: Optional[StrictStr] = Field(None, description="The query that was submitted. ")
    remaining_retries: Optional[StrictInt] = Field(None, alias="remainingRetries", description="The number of times that Zuora will retry the query if Zuora is unable to perform the query. ")
    updated_on: Optional[datetime] = Field(None, alias="updatedOn", description="Date and time when the query job was last updated, in ISO 8601 format. ")
    __properties = ["createdBy", "id", "query", "remainingRetries", "updatedOn"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> DataQueryJobCommon:
        """Create an instance of DataQueryJobCommon from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> DataQueryJobCommon:
        """Create an instance of DataQueryJobCommon from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return DataQueryJobCommon.parse_obj(obj)

        _obj = DataQueryJobCommon.parse_obj({
            "created_by": obj.get("createdBy"),
            "id": obj.get("id"),
            "query": obj.get("query"),
            "remaining_retries": obj.get("remainingRetries"),
            "updated_on": obj.get("updatedOn")
        })
        return _obj


