# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from typing import Optional
from pydantic import BaseModel, Field, StrictStr

class DebitMemoDueDate(BaseModel):
    """
    DebitMemoDueDate
    """
    due_date: Optional[date] = Field(None, alias="dueDate", description="The date by which the payment for the debit memo is due, in `yyyy-mm-dd` format. ")
    id: Optional[StrictStr] = Field(None, description="The unique ID or number of the debit memo to be updated. For example, 402890555a87d7f5015a892f2ba10057 or or DM00000001. ")
    memo_key: Optional[StrictStr] = Field(None, alias="memoKey", description="The unique ID or number of the debit memo to be updated. For example, 402890555a87d7f5015a892f2ba10057 or or DM00000001. If `memoKey` is set, `id` will be ignored. ")
    __properties = ["dueDate", "id", "memoKey"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> DebitMemoDueDate:
        """Create an instance of DebitMemoDueDate from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> DebitMemoDueDate:
        """Create an instance of DebitMemoDueDate from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return DebitMemoDueDate.parse_obj(obj)

        _obj = DebitMemoDueDate.parse_obj({
            "due_date": obj.get("dueDate"),
            "id": obj.get("id"),
            "memo_key": obj.get("memoKey")
        })
        return _obj


