# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, constr

class DebitMemoItemFromChargeDetailFinanceInformation(BaseModel):
    """
    Container for the finance information related to the product rate plan charge associated with the debit memo.   # noqa: E501
    """
    deferred_revenue_accounting_code: Optional[constr(strict=True, max_length=100, min_length=0)] = Field(None, alias="deferredRevenueAccountingCode", description="The accounting code for the deferred revenue, such as Monthly Recurring Liability. ")
    recognized_revenue_accounting_code: Optional[constr(strict=True, max_length=100, min_length=0)] = Field(None, alias="recognizedRevenueAccountingCode", description="The accounting code for the recognized revenue, such as Monthly Recurring Charges or Overage Charges. ")
    revenue_recognition_rule_name: Optional[constr(strict=True, max_length=100, min_length=0)] = Field(None, alias="revenueRecognitionRuleName", description="The name of the revenue recognition rule governing the revenue schedule. ")
    __properties = ["deferredRevenueAccountingCode", "recognizedRevenueAccountingCode", "revenueRecognitionRuleName"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> DebitMemoItemFromChargeDetailFinanceInformation:
        """Create an instance of DebitMemoItemFromChargeDetailFinanceInformation from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> DebitMemoItemFromChargeDetailFinanceInformation:
        """Create an instance of DebitMemoItemFromChargeDetailFinanceInformation from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return DebitMemoItemFromChargeDetailFinanceInformation.parse_obj(obj)

        _obj = DebitMemoItemFromChargeDetailFinanceInformation.parse_obj({
            "deferred_revenue_accounting_code": obj.get("deferredRevenueAccountingCode"),
            "recognized_revenue_accounting_code": obj.get("recognizedRevenueAccountingCode"),
            "revenue_recognition_rule_name": obj.get("revenueRecognitionRuleName")
        })
        return _obj


