# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json



from pydantic import BaseModel, Field, StrictStr

class DecryptRSASignatureRequest(BaseModel):
    """
    DecryptRSASignatureRequest
    """
    method: StrictStr = Field(..., description="The type of the request. Set it to Post. ")
    public_key: StrictStr = Field(..., alias="publicKey", description="The public key generated by Zuora. ")
    signature: StrictStr = Field(..., description="The signature generated by Zuora. ")
    __properties = ["method", "publicKey", "signature"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> DecryptRSASignatureRequest:
        """Create an instance of DecryptRSASignatureRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> DecryptRSASignatureRequest:
        """Create an instance of DecryptRSASignatureRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return DecryptRSASignatureRequest.parse_obj(obj)

        _obj = DecryptRSASignatureRequest.parse_obj({
            "method": obj.get("method"),
            "public_key": obj.get("publicKey"),
            "signature": obj.get("signature")
        })
        return _obj


