# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictStr, conlist

class DeleteBatchQueryResponse(BaseModel):
    """
    DeleteBatchQueryResponse
    """
    batch_id: Optional[StrictStr] = Field(None, alias="batchId", description="A 32-character ID of the query batch. ")
    batch_type: Optional[StrictStr] = Field(None, alias="batchType")
    file_id: Optional[StrictStr] = Field(None, alias="fileId", description="The ID of the query results file.  Use Get Results Files to download the query results file. The query results file is formatted as requested in the batch job. Supported formats are CSV, GZIP, and ZIP. ")
    message: Optional[StrictStr] = Field(None, description="The error message. ")
    name: Optional[StrictStr] = Field(None, description="Name of the query supplied in the request. ")
    query: Optional[StrictStr] = Field(None, description="The requested query string. ")
    record_count: Optional[StrictStr] = Field(None, alias="recordCount", description="The number of records included in the query output file. ")
    segments: Optional[conlist(StrictStr)] = Field(None, description="Array of IDs of query results files. Replaces fileId for full data loads in stateful mode if <a href = \"https://knowledgecenter.zuora.com/Zuora_Central_Platform/API/AB_Aggregate_Query_API/G_File_Segmentation\" target=\"_blank\">File Segmentation</a> is enabled.  Use Get Results Files to download each query results file. Each query results file contains at most 500,000 records and is formatted as requested in the batch job. Supported formats are CSV, GZIP, and ZIP. ")
    status: Optional[StrictStr] = None
    __properties = ["batchId", "batchType", "fileId", "message", "name", "query", "recordCount", "segments", "status"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> DeleteBatchQueryResponse:
        """Create an instance of DeleteBatchQueryResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> DeleteBatchQueryResponse:
        """Create an instance of DeleteBatchQueryResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return DeleteBatchQueryResponse.parse_obj(obj)

        _obj = DeleteBatchQueryResponse.parse_obj({
            "batch_id": obj.get("batchId"),
            "batch_type": obj.get("batchType"),
            "file_id": obj.get("fileId"),
            "message": obj.get("message"),
            "name": obj.get("name"),
            "query": obj.get("query"),
            "record_count": obj.get("recordCount"),
            "segments": obj.get("segments"),
            "status": obj.get("status")
        })
        return _obj


