# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictStr

class DiscountApplyDetail(BaseModel):
    """
    DiscountApplyDetail
    """
    applied_product_rate_plan_id: Optional[StrictStr] = Field(None, alias="appliedProductRatePlanId", description="The ID of the product rate plan that the discount rate plan charge applies to. ")
    applied_product_rate_plan_charge_id: Optional[StrictStr] = Field(None, alias="appliedProductRatePlanChargeId", description="The ID of the product rate plan charge that the discount rate plan charge applies to. ")
    applied_product_name: Optional[StrictStr] = Field(None, alias="appliedProductName", description="The name of the product that the discount rate plan charge applies to. ")
    applied_product_rate_plan_name: Optional[StrictStr] = Field(None, alias="appliedProductRatePlanName", description="The name of the product rate plan that the discount rate plan charge applies to. ")
    applied_product_rate_plan_charge_name: Optional[StrictStr] = Field(None, alias="appliedProductRatePlanChargeName", description="The name of the product rate plan charge that the discount rate plan charge applies to. ")
    __properties = ["appliedProductRatePlanId", "appliedProductRatePlanChargeId", "appliedProductName", "appliedProductRatePlanName", "appliedProductRatePlanChargeName"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> DiscountApplyDetail:
        """Create an instance of DiscountApplyDetail from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> DiscountApplyDetail:
        """Create an instance of DiscountApplyDetail from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return DiscountApplyDetail.parse_obj(obj)

        _obj = DiscountApplyDetail.parse_obj({
            "applied_product_rate_plan_id": obj.get("appliedProductRatePlanId"),
            "applied_product_rate_plan_charge_id": obj.get("appliedProductRatePlanChargeId"),
            "applied_product_name": obj.get("appliedProductName"),
            "applied_product_rate_plan_name": obj.get("appliedProductRatePlanName"),
            "applied_product_rate_plan_charge_name": obj.get("appliedProductRatePlanChargeName")
        })
        return _obj


