# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional, Union
from pydantic import BaseModel, Field, StrictFloat, StrictInt, StrictStr

class DiscountPricingUpdate(BaseModel):
    """
    DiscountPricingUpdate
    """
    apply_discount_to: Optional[StrictStr] = Field(None, alias="applyDiscountTo")
    discount_level: Optional[StrictStr] = Field(None, alias="discountLevel")
    discount_percentage: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="discountPercentage", description="The amount of the discount as a percentage. This field is only used for percentage discounts. ")
    price_change_option: Optional[StrictStr] = Field(None, alias="priceChangeOption")
    __properties = ["applyDiscountTo", "discountLevel", "discountPercentage", "priceChangeOption"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> DiscountPricingUpdate:
        """Create an instance of DiscountPricingUpdate from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> DiscountPricingUpdate:
        """Create an instance of DiscountPricingUpdate from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return DiscountPricingUpdate.parse_obj(obj)

        _obj = DiscountPricingUpdate.parse_obj({
            "apply_discount_to": obj.get("applyDiscountTo"),
            "discount_level": obj.get("discountLevel"),
            "discount_percentage": obj.get("discountPercentage"),
            "price_change_option": obj.get("priceChangeOption")
        })
        return _obj


