# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictBool, conlist
from com.zuora.models.generate_billing_document_response_credit_memo import GenerateBillingDocumentResponseCreditMemo
from com.zuora.models.generate_billing_document_response_invoice import GenerateBillingDocumentResponseInvoice

class GenerateBillingDocumentResponse(BaseModel):
    """
    GenerateBillingDocumentResponse
    """
    credit_memos: Optional[conlist(GenerateBillingDocumentResponseCreditMemo)] = Field(None, alias="creditMemos", description="Container for generated credit memos.  **Note:** This container is only available if you have [Invoice Settlement](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/Invoice_Settlement) enabled. The Invoice Settlement feature is generally available as of Zuora Billing Release 296 (March 2021). This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement, see [Invoice Settlement Enablement and Checklist Guide](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/Invoice_Settlement/Invoice_Settlement_Migration_Checklist_and_Guide) for more information. ")
    invoices: Optional[conlist(GenerateBillingDocumentResponseInvoice)] = Field(None, description="Container for generated invoices. ")
    success: Optional[StrictBool] = Field(None, description="Returns `true` if the request was processed successfully.")
    __properties = ["creditMemos", "invoices", "success"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> GenerateBillingDocumentResponse:
        """Create an instance of GenerateBillingDocumentResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in credit_memos (list)
        _items = []
        if self.credit_memos:
            for _item in self.credit_memos:
                if _item:
                    _items.append(_item.to_dict())
            _dict['creditMemos'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in invoices (list)
        _items = []
        if self.invoices:
            for _item in self.invoices:
                if _item:
                    _items.append(_item.to_dict())
            _dict['invoices'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> GenerateBillingDocumentResponse:
        """Create an instance of GenerateBillingDocumentResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return GenerateBillingDocumentResponse.parse_obj(obj)

        _obj = GenerateBillingDocumentResponse.parse_obj({
            "credit_memos": [GenerateBillingDocumentResponseCreditMemo.from_dict(_item) for _item in obj.get("creditMemos")] if obj.get("creditMemos") is not None else None,
            "invoices": [GenerateBillingDocumentResponseInvoice.from_dict(_item) for _item in obj.get("invoices")] if obj.get("invoices") is not None else None,
            "success": obj.get("success")
        })
        return _obj


