# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictBool, StrictStr, conlist
from com.zuora.models.get_payment_method_for_account_response import GetPaymentMethodForAccountResponse

class GetAccountPaymentMethodResponse(BaseModel):
    """
    GetAccountPaymentMethodResponse
    """
    default_payment_method_id: Optional[StrictStr] = Field(None, alias="defaultPaymentMethodId", description="ID of the default payment method for the account. ")
    payment_gateway: Optional[StrictStr] = Field(None, alias="paymentGateway", description="The name of the payment gateway instance. If null or left unassigned, the Account will use the Default Gateway. ")
    returned_payment_method_type: Optional[conlist(GetPaymentMethodForAccountResponse)] = Field(None, alias="returnedPaymentMethodType", description="Container for a specific type of payment method on the customer account. For example, `creditcard`, `debitcard`, `creditcardreferencetransaction`, `ach`, etc. Each `returnedPaymentMethodType` array contains one or more payment methods of that payment method type.  **Note:** The response could return more than one payment method type arrays. See **Response samples** as an example. ")
    success: Optional[StrictBool] = Field(None, description="Returns `true` if the request was processed successfully. ")
    __properties = ["defaultPaymentMethodId", "paymentGateway", "returnedPaymentMethodType", "success"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> GetAccountPaymentMethodResponse:
        """Create an instance of GetAccountPaymentMethodResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in returned_payment_method_type (list)
        _items = []
        if self.returned_payment_method_type:
            for _item in self.returned_payment_method_type:
                if _item:
                    _items.append(_item.to_dict())
            _dict['returnedPaymentMethodType'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> GetAccountPaymentMethodResponse:
        """Create an instance of GetAccountPaymentMethodResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return GetAccountPaymentMethodResponse.parse_obj(obj)

        _obj = GetAccountPaymentMethodResponse.parse_obj({
            "default_payment_method_id": obj.get("defaultPaymentMethodId"),
            "payment_gateway": obj.get("paymentGateway"),
            "returned_payment_method_type": [GetPaymentMethodForAccountResponse.from_dict(_item) for _item in obj.get("returnedPaymentMethodType")] if obj.get("returnedPaymentMethodType") is not None else None,
            "success": obj.get("success")
        })
        return _obj


