# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Dict, Optional
from pydantic import BaseModel, Field, StrictInt
from com.zuora.models.custom_object_definition import CustomObjectDefinition

class GetAllCustomObjectDefinitionsInNamespaceResponse(BaseModel):
    """
    GetAllCustomObjectDefinitionsInNamespaceResponse
    """
    count: Optional[StrictInt] = Field(None, description="The number of objects in the `definitions` object. The value of this field is the number of custom object definitions in the namespace.")
    definitions: Optional[Dict[str, CustomObjectDefinition]] = Field(None, description="The custom object definitions. This object maps types to custom object definitions.")
    __properties = ["count", "definitions"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> GetAllCustomObjectDefinitionsInNamespaceResponse:
        """Create an instance of GetAllCustomObjectDefinitionsInNamespaceResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each value in definitions (dict)
        _field_dict = {}
        if self.definitions:
            for _key in self.definitions:
                if self.definitions[_key]:
                    _field_dict[_key] = self.definitions[_key].to_dict()
            _dict['definitions'] = _field_dict
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> GetAllCustomObjectDefinitionsInNamespaceResponse:
        """Create an instance of GetAllCustomObjectDefinitionsInNamespaceResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return GetAllCustomObjectDefinitionsInNamespaceResponse.parse_obj(obj)

        _obj = GetAllCustomObjectDefinitionsInNamespaceResponse.parse_obj({
            "count": obj.get("count"),
            "definitions": dict(
                (_k, CustomObjectDefinition.from_dict(_v))
                for _k, _v in obj.get("definitions").items()
            )
            if obj.get("definitions") is not None
            else None
        })
        return _obj


