# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictBool, StrictStr, conlist
from com.zuora.models.failed_reason import FailedReason

class GetAttachmentResponse(BaseModel):
    """
    GetAttachmentResponse
    """
    process_id: Optional[StrictStr] = Field(None, alias="processId", description="The Id of the process that handle the operation. ")
    request_id: Optional[StrictStr] = Field(None, alias="requestId", description="The request ID of this process. ")
    reasons: Optional[conlist(FailedReason)] = None
    success: Optional[StrictBool] = Field(None, description="Returns `true` if the request was processed successfully. ")
    created_by: Optional[StrictStr] = Field(None, alias="createdBy", description="Zuora user id who added this attachment to the object. ")
    created_on: Optional[StrictStr] = Field(None, alias="createdOn", description="Date and time when the attachment was added to the object. ")
    description: Optional[StrictStr] = Field(None, description="Description of the attachment. ")
    file_content_type: Optional[StrictStr] = Field(None, alias="fileContentType", description="File type. ")
    file_id: Optional[StrictStr] = Field(None, alias="fileId", description="File ID of the attached file. Use this file ID with [Get files](https://www.zuora.com/developer/api-references/api/operation/Get_Files) to download the file. ")
    file_name: Optional[StrictStr] = Field(None, alias="fileName", description="Attachment file name. ")
    id: Optional[StrictStr] = Field(None, description="Id of this attachment. ")
    updated_by: Optional[StrictStr] = Field(None, alias="updatedBy", description="Zuora user id who last updated the attachment. ")
    updated_on: Optional[StrictStr] = Field(None, alias="updatedOn", description="Date and time when the attachment was last updated. ")
    __properties = ["processId", "requestId", "reasons", "success", "createdBy", "createdOn", "description", "fileContentType", "fileId", "fileName", "id", "updatedBy", "updatedOn"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> GetAttachmentResponse:
        """Create an instance of GetAttachmentResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in reasons (list)
        _items = []
        if self.reasons:
            for _item in self.reasons:
                if _item:
                    _items.append(_item.to_dict())
            _dict['reasons'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> GetAttachmentResponse:
        """Create an instance of GetAttachmentResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return GetAttachmentResponse.parse_obj(obj)

        _obj = GetAttachmentResponse.parse_obj({
            "process_id": obj.get("processId"),
            "request_id": obj.get("requestId"),
            "reasons": [FailedReason.from_dict(_item) for _item in obj.get("reasons")] if obj.get("reasons") is not None else None,
            "success": obj.get("success"),
            "created_by": obj.get("createdBy"),
            "created_on": obj.get("createdOn"),
            "description": obj.get("description"),
            "file_content_type": obj.get("fileContentType"),
            "file_id": obj.get("fileId"),
            "file_name": obj.get("fileName"),
            "id": obj.get("id"),
            "updated_by": obj.get("updatedBy"),
            "updated_on": obj.get("updatedOn")
        })
        return _obj


