# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictBool, StrictStr, condecimal, conlist
from com.zuora.models.billing_adjustment import BillingAdjustment
from com.zuora.models.failed_reason import FailedReason
from com.zuora.models.ineligible_billing_adjustment import IneligibleBillingAdjustment

class GetBillingAdjustmentsResponse(BaseModel):
    """
    GetBillingAdjustmentsResponse
    """
    process_id: Optional[StrictStr] = Field(None, alias="processId", description="The Id of the process that handle the operation. ")
    request_id: Optional[StrictStr] = Field(None, alias="requestId", description="Unique request identifier. If you need to contact us about a specific request, providing the request identifier will ensure the fastest possible resolution. ")
    reasons: Optional[conlist(FailedReason)] = None
    success: Optional[StrictBool] = Field(None, description="Indicates whether the call succeeded. ")
    adjustments: Optional[conlist(BillingAdjustment)] = Field(None, description="Container for adjustments of a subscription. ")
    ineligible_adjustments: Optional[conlist(IneligibleBillingAdjustment)] = Field(None, alias="ineligibleAdjustments", description="Container for ineligible adjustments of a subscription. ")
    total_amount: Optional[condecimal()] = Field(None, alias="totalAmount", description="The total amount of all the adjustments. ")
    total_quantity: Optional[condecimal()] = Field(None, alias="totalQuantity", description="The total quantity of all the adjustments. ")
    total_number_of_deliveries: Optional[condecimal()] = Field(None, alias="totalNumberOfDeliveries")
    __properties = ["processId", "requestId", "reasons", "success", "adjustments", "ineligibleAdjustments", "totalAmount", "totalQuantity", "totalNumberOfDeliveries"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> GetBillingAdjustmentsResponse:
        """Create an instance of GetBillingAdjustmentsResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in reasons (list)
        _items = []
        if self.reasons:
            for _item in self.reasons:
                if _item:
                    _items.append(_item.to_dict())
            _dict['reasons'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in adjustments (list)
        _items = []
        if self.adjustments:
            for _item in self.adjustments:
                if _item:
                    _items.append(_item.to_dict())
            _dict['adjustments'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in ineligible_adjustments (list)
        _items = []
        if self.ineligible_adjustments:
            for _item in self.ineligible_adjustments:
                if _item:
                    _items.append(_item.to_dict())
            _dict['ineligibleAdjustments'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> GetBillingAdjustmentsResponse:
        """Create an instance of GetBillingAdjustmentsResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return GetBillingAdjustmentsResponse.parse_obj(obj)

        _obj = GetBillingAdjustmentsResponse.parse_obj({
            "process_id": obj.get("processId"),
            "request_id": obj.get("requestId"),
            "reasons": [FailedReason.from_dict(_item) for _item in obj.get("reasons")] if obj.get("reasons") is not None else None,
            "success": obj.get("success"),
            "adjustments": [BillingAdjustment.from_dict(_item) for _item in obj.get("adjustments")] if obj.get("adjustments") is not None else None,
            "ineligible_adjustments": [IneligibleBillingAdjustment.from_dict(_item) for _item in obj.get("ineligibleAdjustments")] if obj.get("ineligibleAdjustments") is not None else None,
            "total_amount": obj.get("totalAmount"),
            "total_quantity": obj.get("totalQuantity"),
            "total_number_of_deliveries": obj.get("totalNumberOfDeliveries")
        })
        return _obj


