# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictBool, StrictStr, conlist
from com.zuora.models.credit_memo_item_part import CreditMemoItemPart

class GetCreditMemoItemPartsResponse(BaseModel):
    """
    GetCreditMemoItemPartsResponse
    """
    item_parts: Optional[conlist(CreditMemoItemPart)] = Field(None, alias="itemParts", description="Container for credit memo part items. ")
    next_page: Optional[StrictStr] = Field(None, alias="nextPage", description="URL to retrieve the next page of the response if it exists; otherwise absent. ")
    success: Optional[StrictBool] = Field(None, description="Returns `true` if the request was processed successfully.")
    __properties = ["itemParts", "nextPage", "success"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> GetCreditMemoItemPartsResponse:
        """Create an instance of GetCreditMemoItemPartsResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in item_parts (list)
        _items = []
        if self.item_parts:
            for _item in self.item_parts:
                if _item:
                    _items.append(_item.to_dict())
            _dict['itemParts'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> GetCreditMemoItemPartsResponse:
        """Create an instance of GetCreditMemoItemPartsResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return GetCreditMemoItemPartsResponse.parse_obj(obj)

        _obj = GetCreditMemoItemPartsResponse.parse_obj({
            "item_parts": [CreditMemoItemPart.from_dict(_item) for _item in obj.get("itemParts")] if obj.get("itemParts") is not None else None,
            "next_page": obj.get("nextPage"),
            "success": obj.get("success")
        })
        return _obj


