# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictBool, conlist
from com.zuora.models.get_custom_exchange_rates_data_type import GetCustomExchangeRatesDataType

class GetCustomExchangeRatesType(BaseModel):
    """
    GetCustomExchangeRatesType
    """
    inverse: Optional[StrictBool] = Field(None, description="- If `true`, the exchange rate in the response is an inverse exchange rate. - If `false`, the exchange rate in the response is not an inverse exchange rate. The value is determined by the **Use inverse rate** checkbox in your Zuora Finance Manage Currency Conversion settings. ")
    rates: Optional[conlist(GetCustomExchangeRatesDataType)] = Field(None, description="Container for exchange rate data. Contains a set of fields that provide exchange rate data for each day between the specified `startDate` and `endDate` (inclusive).  ")
    success: Optional[StrictBool] = Field(None, description="Returns `true` if the request was processed successfully. ")
    __properties = ["inverse", "rates", "success"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> GetCustomExchangeRatesType:
        """Create an instance of GetCustomExchangeRatesType from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in rates (list)
        _items = []
        if self.rates:
            for _item in self.rates:
                if _item:
                    _items.append(_item.to_dict())
            _dict['rates'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> GetCustomExchangeRatesType:
        """Create an instance of GetCustomExchangeRatesType from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return GetCustomExchangeRatesType.parse_obj(obj)

        _obj = GetCustomExchangeRatesType.parse_obj({
            "inverse": obj.get("inverse"),
            "rates": [GetCustomExchangeRatesDataType.from_dict(_item) for _item in obj.get("rates")] if obj.get("rates") is not None else None,
            "success": obj.get("success")
        })
        return _obj


