# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictStr

class GetDebitMemoTaxItemFinanceInformation(BaseModel):
    """
    Container for the finance information related to the taxation item.   # noqa: E501
    """
    sales_tax_payable_accounting_code: Optional[StrictStr] = Field(None, alias="salesTaxPayableAccountingCode", description="The accounting code for the sales taxes payable. ")
    sales_tax_payable_accounting_code_type: Optional[StrictStr] = Field(None, alias="salesTaxPayableAccountingCodeType", description="The type of the accounting code for the sales taxes payable. ")
    __properties = ["salesTaxPayableAccountingCode", "salesTaxPayableAccountingCodeType"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> GetDebitMemoTaxItemFinanceInformation:
        """Create an instance of GetDebitMemoTaxItemFinanceInformation from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> GetDebitMemoTaxItemFinanceInformation:
        """Create an instance of GetDebitMemoTaxItemFinanceInformation from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return GetDebitMemoTaxItemFinanceInformation.parse_obj(obj)

        _obj = GetDebitMemoTaxItemFinanceInformation.parse_obj({
            "sales_tax_payable_accounting_code": obj.get("salesTaxPayableAccountingCode"),
            "sales_tax_payable_accounting_code_type": obj.get("salesTaxPayableAccountingCodeType")
        })
        return _obj


