# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictBool, conlist
from com.zuora.models.get_invoice_pdf_status_response import GetInvoicePdfStatusResponse

class GetInvoicePdfStatusBatchResponse(BaseModel):
    """
      # noqa: E501
    """
    invoice_files: Optional[conlist(GetInvoicePdfStatusResponse)] = Field(None, alias="invoiceFiles", description="Array of invoice PDF statuses requested. ")
    success: Optional[StrictBool] = Field(None, description="Indicates whether the call succeeded. ")
    __properties = ["invoiceFiles", "success"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> GetInvoicePdfStatusBatchResponse:
        """Create an instance of GetInvoicePdfStatusBatchResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in invoice_files (list)
        _items = []
        if self.invoice_files:
            for _item in self.invoice_files:
                if _item:
                    _items.append(_item.to_dict())
            _dict['invoiceFiles'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> GetInvoicePdfStatusBatchResponse:
        """Create an instance of GetInvoicePdfStatusBatchResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return GetInvoicePdfStatusBatchResponse.parse_obj(obj)

        _obj = GetInvoicePdfStatusBatchResponse.parse_obj({
            "invoice_files": [GetInvoicePdfStatusResponse.from_dict(_item) for _item in obj.get("invoiceFiles")] if obj.get("invoiceFiles") is not None else None,
            "success": obj.get("success")
        })
        return _obj


