# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictStr
from com.zuora.models.accounting_code_type import AccountingCodeType
from com.zuora.models.journal_entry_item_type import JournalEntryItemType

class GetJournalEntryItemResponse(BaseModel):
    """
    GetJournalEntryItemResponse
    """
    accounting_code_name: Optional[StrictStr] = Field(None, alias="accountingCodeName", description="Name of the accounting code. ")
    accounting_code_type: Optional[AccountingCodeType] = Field(None, alias="accountingCodeType")
    amount: Optional[StrictStr] = Field(None, description="Journal entry item amount in transaction currency. ")
    gl_account_name: Optional[StrictStr] = Field(None, alias="glAccountName", description="The account number in the general ledger (GL) that corresponds to the accounting code. ")
    gl_account_number: Optional[StrictStr] = Field(None, alias="glAccountNumber", description="The account name in the general ledger (GL) that corresponds to the accounting code. ")
    home_currency_amount: Optional[StrictStr] = Field(None, alias="homeCurrencyAmount", description="Journal entry item amount in home currency. ")
    type: Optional[JournalEntryItemType] = None
    additional_properties: Dict[str, Any] = {}
    __properties = ["accountingCodeName", "accountingCodeType", "amount", "glAccountName", "glAccountNumber", "homeCurrencyAmount", "type"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> GetJournalEntryItemResponse:
        """Create an instance of GetJournalEntryItemResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                            "additional_properties"
                          },
                          exclude_none=True)
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> GetJournalEntryItemResponse:
        """Create an instance of GetJournalEntryItemResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return GetJournalEntryItemResponse.parse_obj(obj)

        _obj = GetJournalEntryItemResponse.parse_obj({
            "accounting_code_name": obj.get("accountingCodeName"),
            "accounting_code_type": obj.get("accountingCodeType"),
            "amount": obj.get("amount"),
            "gl_account_name": obj.get("glAccountName"),
            "gl_account_number": obj.get("glAccountNumber"),
            "home_currency_amount": obj.get("homeCurrencyAmount"),
            "type": obj.get("type")
        })
        # store additional fields in additional_properties
        for _key in obj.keys():
            if _key not in cls.__properties:
                _obj.additional_properties[_key] = obj.get(_key)

        return _obj


