# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from typing import List, Optional
from pydantic import BaseModel, Field, StrictBool, StrictInt, StrictStr, conlist
from com.zuora.models.get_journal_run_transaction_response import GetJournalRunTransactionResponse
from com.zuora.models.journal_run_status import JournalRunStatus
from com.zuora.models.organization_label import OrganizationLabel

class GetJournalRunResponse(BaseModel):
    """
    GetJournalRunResponse
    """
    aggregate_currency: Optional[StrictBool] = Field(None, alias="aggregateCurrency")
    executed_on: Optional[StrictStr] = Field(None, alias="executedOn", description="Date and time the journal run was executed. ")
    journal_entry_date: Optional[date] = Field(None, alias="journalEntryDate", description="Date of the journal entry. ")
    number: Optional[StrictStr] = Field(None, description="Journal run number. ")
    segmentation_rule_name: Optional[StrictStr] = Field(None, alias="segmentationRuleName", description="Name of GL segmentation rule used in the journal run. ")
    status: Optional[JournalRunStatus] = None
    success: Optional[StrictBool] = Field(None, description="Returns `true` if the request was processed successfully. ")
    target_end_date: Optional[date] = Field(None, alias="targetEndDate", description="The target end date of the journal run. ")
    target_start_date: Optional[date] = Field(None, alias="targetStartDate", description="The target start date of the journal run. ")
    total_journal_entry_count: Optional[StrictInt] = Field(None, alias="totalJournalEntryCount", description="Total number of journal entries in the journal run. ")
    organization_labels: Optional[conlist(OrganizationLabel)] = Field(None, alias="organizationLabels", description="Organization Labels. ")
    transaction_types: Optional[conlist(GetJournalRunTransactionResponse)] = Field(None, alias="transactionTypes", description="Transaction types included in the journal run. ")
    __properties = ["aggregateCurrency", "executedOn", "journalEntryDate", "number", "segmentationRuleName", "status", "success", "targetEndDate", "targetStartDate", "totalJournalEntryCount", "organizationLabels", "transactionTypes"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> GetJournalRunResponse:
        """Create an instance of GetJournalRunResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in organization_labels (list)
        _items = []
        if self.organization_labels:
            for _item in self.organization_labels:
                if _item:
                    _items.append(_item.to_dict())
            _dict['organizationLabels'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in transaction_types (list)
        _items = []
        if self.transaction_types:
            for _item in self.transaction_types:
                if _item:
                    _items.append(_item.to_dict())
            _dict['transactionTypes'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> GetJournalRunResponse:
        """Create an instance of GetJournalRunResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return GetJournalRunResponse.parse_obj(obj)

        _obj = GetJournalRunResponse.parse_obj({
            "aggregate_currency": obj.get("aggregateCurrency"),
            "executed_on": obj.get("executedOn"),
            "journal_entry_date": obj.get("journalEntryDate"),
            "number": obj.get("number"),
            "segmentation_rule_name": obj.get("segmentationRuleName"),
            "status": obj.get("status"),
            "success": obj.get("success"),
            "target_end_date": obj.get("targetEndDate"),
            "target_start_date": obj.get("targetStartDate"),
            "total_journal_entry_count": obj.get("totalJournalEntryCount"),
            "organization_labels": [OrganizationLabel.from_dict(_item) for _item in obj.get("organizationLabels")] if obj.get("organizationLabels") is not None else None,
            "transaction_types": [GetJournalRunTransactionResponse.from_dict(_item) for _item in obj.get("transactionTypes")] if obj.get("transactionTypes") is not None else None
        })
        return _obj


