# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictBool, StrictInt, StrictStr

class GetMassUpdateResponse(BaseModel):
    """
    GetMassUpdateResponse
    """
    action_type: Optional[StrictStr] = Field(None, alias="actionType", description="Type of mass action. ")
    ended_on: Optional[StrictStr] = Field(None, alias="endedOn", description="Date and time that the mass action was completed. The format is `yyyy-MM-dd hh:mm:ss`. ")
    error_count: Optional[StrictStr] = Field(None, alias="errorCount", description="Total number of failed records.  This field is updated in real time. When the mass action **status** is Processing, this field returns the number of records that have failed so far. When the mass action **status** is Pending, this field is null. ")
    input_size: Optional[StrictInt] = Field(None, alias="inputSize", description="Size of the input file in bytes. ")
    output_size: Optional[StrictInt] = Field(None, alias="outputSize", description="Size of the response file in bytes. ")
    output_type: Optional[StrictStr] = Field(None, alias="outputType", description="Type of output for the response file. The following table describes the output type.  | Output Type    | Description                         | |----------------|-------------------------------------| | (url:.csv.zip) | URL pointing to a zipped .csv file. | ")
    output_url: Optional[StrictStr] = Field(None, alias="outputURL", description="URL to download the response file. The response file is a zipped .csv file.  The response file is identical to the file you uploaded to perform the mass action, with additional columns providing information about the outcome of each record.  This field only returns a value when the mass action **status** is Completed or Stopped. Otherwise, this field is null. ")
    processed_count: Optional[StrictStr] = Field(None, alias="processedCount", description="Total number of processed records. This field is equal to the sum of `errorCount` and `successCount`.  This field is updated in real time. When the mass action **status** is Processing, this field returns the number of records that have been processed so far. When the mass action **status** is Pending, this field is null. ")
    started_on: Optional[StrictStr] = Field(None, alias="startedOn", description="Date and time that Zuora started processing the mass action. The format is `yyyy-MM-dd hh:mm:ss`. ")
    status: Optional[StrictStr] = Field(None, description="Status of the mass action. The following table describes the mass action statuses.  | Status     | Description                                                                | |------------|----------------------------------------------------------------------------| | Pending    | Mass action has not yet started being processed.                           | | Processing | Mass action is in progress.                                                | | Stopping   | Mass action is in the process of stopping, but has not yet stopped.        | | Stopped    | Mass action has stopped.                                                   | | Completed  | Mass action was successfully completed. There may still be failed records. | | Failed     | Mass action failed. No records are processed. No response file is created. | ")
    success: Optional[StrictBool] = Field(None, description="Returns `true` if the request was processed successfully. ")
    success_count: Optional[StrictStr] = Field(None, alias="successCount", description="Total number of successful records. This field is updated in real time. When the mass action **status** is Processing, this field returns the number of records that have succeeded so far. When the mass action **status** is Pending, this field is null. ")
    total_count: Optional[StrictStr] = Field(None, alias="totalCount", description="Total number of records in the uploaded mass action file. When the mass action **status** is Pending, this field is null. ")
    uploaded_by: Optional[StrictStr] = Field(None, alias="uploadedBy", description="Email of the person who uploaded the mass action file. ")
    uploaded_on: Optional[StrictStr] = Field(None, alias="uploadedOn", description="Date and time that the mass action file was uploaded. The format is `yyyy-MM-dd hh:mm:ss`. ")
    __properties = ["actionType", "endedOn", "errorCount", "inputSize", "outputSize", "outputType", "outputURL", "processedCount", "startedOn", "status", "success", "successCount", "totalCount", "uploadedBy", "uploadedOn"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> GetMassUpdateResponse:
        """Create an instance of GetMassUpdateResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> GetMassUpdateResponse:
        """Create an instance of GetMassUpdateResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return GetMassUpdateResponse.parse_obj(obj)

        _obj = GetMassUpdateResponse.parse_obj({
            "action_type": obj.get("actionType"),
            "ended_on": obj.get("endedOn"),
            "error_count": obj.get("errorCount"),
            "input_size": obj.get("inputSize"),
            "output_size": obj.get("outputSize"),
            "output_type": obj.get("outputType"),
            "output_url": obj.get("outputURL"),
            "processed_count": obj.get("processedCount"),
            "started_on": obj.get("startedOn"),
            "status": obj.get("status"),
            "success": obj.get("success"),
            "success_count": obj.get("successCount"),
            "total_count": obj.get("totalCount"),
            "uploaded_by": obj.get("uploadedBy"),
            "uploaded_on": obj.get("uploadedOn")
        })
        return _obj


