# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict, List, Optional
from pydantic import BaseModel, Field, StrictBool, StrictStr, conlist
from com.zuora.models.failed_reason import FailedReason
from com.zuora.models.order_action_rate_plan_amendment import OrderActionRatePlanAmendment
from com.zuora.models.order_action_rate_plan_order import OrderActionRatePlanOrder

class GetOrderActionRatePlanResponse(BaseModel):
    """
    GetOrderActionRatePlanResponse
    """
    process_id: Optional[StrictStr] = Field(None, alias="processId", description="The Id of the process that handle the operation. ")
    request_id: Optional[StrictStr] = Field(None, alias="requestId", description="Unique request identifier. If you need to contact us about a specific request, providing the request identifier will ensure the fastest possible resolution. ")
    reasons: Optional[conlist(FailedReason)] = None
    success: Optional[StrictBool] = Field(None, description="Indicates whether the call succeeded. ")
    amendment: Optional[OrderActionRatePlanAmendment] = None
    externally_managed_plan_id: Optional[StrictStr] = Field(None, alias="externallyManagedPlanId", description="The unique identifier for the rate plan purchased on a third-party store. This field is used to represent a subscription rate plan created through third-party stores. ")
    id: Optional[StrictStr] = Field(None, description="Unique subscription rate-plan ID.")
    last_change_type: Optional[StrictStr] = Field(None, alias="lastChangeType", description="Latest change type. Possible values are:  - New - Update - Remove ")
    order: Optional[OrderActionRatePlanOrder] = None
    product_id: Optional[StrictStr] = Field(None, alias="productId", description="Product ID ")
    product_name: Optional[StrictStr] = Field(None, alias="productName", description="The name of the product. ")
    product_rate_plan_id: Optional[StrictStr] = Field(None, alias="productRatePlanId", description="Product rate plan ID ")
    product_sku: Optional[StrictStr] = Field(None, alias="productSku", description="The unique SKU for the product. ")
    rate_plan_name: Optional[StrictStr] = Field(None, alias="ratePlanName", description="The name of the rate plan. ")
    subscription_id: Optional[StrictStr] = Field(None, alias="subscriptionId", description="Subscription ID. ")
    subscription_version: Optional[Dict[str, Any]] = Field(None, alias="subscriptionVersion", description="The version of the subscription. ")
    __properties = ["processId", "requestId", "reasons", "success", "amendment", "externallyManagedPlanId", "id", "lastChangeType", "order", "productId", "productName", "productRatePlanId", "productSku", "ratePlanName", "subscriptionId", "subscriptionVersion"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> GetOrderActionRatePlanResponse:
        """Create an instance of GetOrderActionRatePlanResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in reasons (list)
        _items = []
        if self.reasons:
            for _item in self.reasons:
                if _item:
                    _items.append(_item.to_dict())
            _dict['reasons'] = _items
        # override the default output from pydantic by calling `to_dict()` of amendment
        if self.amendment:
            _dict['amendment'] = self.amendment.to_dict()
        # override the default output from pydantic by calling `to_dict()` of order
        if self.order:
            _dict['order'] = self.order.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> GetOrderActionRatePlanResponse:
        """Create an instance of GetOrderActionRatePlanResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return GetOrderActionRatePlanResponse.parse_obj(obj)

        _obj = GetOrderActionRatePlanResponse.parse_obj({
            "process_id": obj.get("processId"),
            "request_id": obj.get("requestId"),
            "reasons": [FailedReason.from_dict(_item) for _item in obj.get("reasons")] if obj.get("reasons") is not None else None,
            "success": obj.get("success"),
            "amendment": OrderActionRatePlanAmendment.from_dict(obj.get("amendment")) if obj.get("amendment") is not None else None,
            "externally_managed_plan_id": obj.get("externallyManagedPlanId"),
            "id": obj.get("id"),
            "last_change_type": obj.get("lastChangeType"),
            "order": OrderActionRatePlanOrder.from_dict(obj.get("order")) if obj.get("order") is not None else None,
            "product_id": obj.get("productId"),
            "product_name": obj.get("productName"),
            "product_rate_plan_id": obj.get("productRatePlanId"),
            "product_sku": obj.get("productSku"),
            "rate_plan_name": obj.get("ratePlanName"),
            "subscription_id": obj.get("subscriptionId"),
            "subscription_version": obj.get("subscriptionVersion")
        })
        return _obj


