# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictStr

class GetPaymentFinanceInformation(BaseModel):
    """
    Container for the finance information related to the payment.   # noqa: E501
    """
    bank_account_accounting_code: Optional[StrictStr] = Field(None, alias="bankAccountAccountingCode", description="The accounting code that maps to a bank account in your accounting system. ")
    bank_account_accounting_code_type: Optional[StrictStr] = Field(None, alias="bankAccountAccountingCodeType", description="The type of the accounting code that maps to a bank account in your accounting system. ")
    transferred_to_accounting: Optional[StrictStr] = Field(None, alias="transferredToAccounting")
    unapplied_payment_accounting_code: Optional[StrictStr] = Field(None, alias="unappliedPaymentAccountingCode", description="The accounting code for the unapplied payment. ")
    unapplied_payment_accounting_code_type: Optional[StrictStr] = Field(None, alias="unappliedPaymentAccountingCodeType", description="The type of the accounting code for the unapplied payment. ")
    __properties = ["bankAccountAccountingCode", "bankAccountAccountingCodeType", "transferredToAccounting", "unappliedPaymentAccountingCode", "unappliedPaymentAccountingCodeType"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> GetPaymentFinanceInformation:
        """Create an instance of GetPaymentFinanceInformation from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> GetPaymentFinanceInformation:
        """Create an instance of GetPaymentFinanceInformation from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return GetPaymentFinanceInformation.parse_obj(obj)

        _obj = GetPaymentFinanceInformation.parse_obj({
            "bank_account_accounting_code": obj.get("bankAccountAccountingCode"),
            "bank_account_accounting_code_type": obj.get("bankAccountAccountingCodeType"),
            "transferred_to_accounting": obj.get("transferredToAccounting"),
            "unapplied_payment_accounting_code": obj.get("unappliedPaymentAccountingCode"),
            "unapplied_payment_accounting_code_type": obj.get("unappliedPaymentAccountingCodeType")
        })
        return _obj


