# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictStr

class GetPaymentMethodResponseGooglePayForAccount(BaseModel):
    """
    GetPaymentMethodResponseGooglePayForAccount
    """
    google_bin: Optional[StrictStr] = Field(None, alias="googleBIN", description="This field is only available for Google Pay payment methods. ")
    google_card_number: Optional[StrictStr] = Field(None, alias="googleCardNumber", description="This field is only available for Google Pay payment methods. ")
    google_card_type: Optional[StrictStr] = Field(None, alias="googleCardType", description="This field is only available for Google Pay payment methods.  For Google Pay payment methods on Adyen, the first 100 characters of [paymentMethodVariant](https://docs.adyen.com/development-resources/paymentmethodvariant) returned from Adyen are stored in this field. ")
    google_expiry_date: Optional[StrictStr] = Field(None, alias="googleExpiryDate", description="This field is only available for Google Pay payment methods. ")
    google_gateway_token: Optional[StrictStr] = Field(None, alias="googleGatewayToken", description="This field is only available for Google Pay payment methods. ")
    __properties = ["googleBIN", "googleCardNumber", "googleCardType", "googleExpiryDate", "googleGatewayToken"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> GetPaymentMethodResponseGooglePayForAccount:
        """Create an instance of GetPaymentMethodResponseGooglePayForAccount from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> GetPaymentMethodResponseGooglePayForAccount:
        """Create an instance of GetPaymentMethodResponseGooglePayForAccount from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return GetPaymentMethodResponseGooglePayForAccount.parse_obj(obj)

        _obj = GetPaymentMethodResponseGooglePayForAccount.parse_obj({
            "google_bin": obj.get("googleBIN"),
            "google_card_number": obj.get("googleCardNumber"),
            "google_card_type": obj.get("googleCardType"),
            "google_expiry_date": obj.get("googleExpiryDate"),
            "google_gateway_token": obj.get("googleGatewayToken")
        })
        return _obj


