# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictBool
from com.zuora.models.payment_part import PaymentPart

class GetPaymentPartResponse(BaseModel):
    """
    GetPaymentPartResponse
    """
    success: Optional[StrictBool] = Field(None, description="Returns `true` if the request was processed successfully.")
    payment_part: Optional[PaymentPart] = Field(None, alias="paymentPart")
    __properties = ["success", "paymentPart"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> GetPaymentPartResponse:
        """Create an instance of GetPaymentPartResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of payment_part
        if self.payment_part:
            _dict['paymentPart'] = self.payment_part.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> GetPaymentPartResponse:
        """Create an instance of GetPaymentPartResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return GetPaymentPartResponse.parse_obj(obj)

        _obj = GetPaymentPartResponse.parse_obj({
            "success": obj.get("success"),
            "payment_part": PaymentPart.from_dict(obj.get("paymentPart")) if obj.get("paymentPart") is not None else None
        })
        return _obj


