# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictBool, conlist
from com.zuora.models.get_payment_run_data_element_response import GetPaymentRunDataElementResponse

class GetPaymentRunDataArrayResponse(BaseModel):
    """
    GetPaymentRunDataArrayResponse
    """
    data: Optional[conlist(GetPaymentRunDataElementResponse)] = Field(None, description="Container for payment run data. Each element in the array is a record processed by the payment run. ")
    success: Optional[StrictBool] = Field(None, description="Returns `true` if the request was processed successfully. ")
    __properties = ["data", "success"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> GetPaymentRunDataArrayResponse:
        """Create an instance of GetPaymentRunDataArrayResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in data (list)
        _items = []
        if self.data:
            for _item in self.data:
                if _item:
                    _items.append(_item.to_dict())
            _dict['data'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> GetPaymentRunDataArrayResponse:
        """Create an instance of GetPaymentRunDataArrayResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return GetPaymentRunDataArrayResponse.parse_obj(obj)

        _obj = GetPaymentRunDataArrayResponse.parse_obj({
            "data": [GetPaymentRunDataElementResponse.from_dict(_item) for _item in obj.get("data")] if obj.get("data") is not None else None,
            "success": obj.get("success")
        })
        return _obj


