# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional, Union
from pydantic import BaseModel, Field, StrictFloat, StrictInt, StrictStr

class GetPaymentRunDataTransactionElementResponse(BaseModel):
    """
    GetPaymentRunDataTransactionElementResponse
    """
    amount: Optional[Union[StrictFloat, StrictInt]] = Field(None, description="The total amount of the newly generated payment.  **Note:** This field is only available if `type` is `Payment`. ")
    applied_amount: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="appliedAmount", description="The amount allocated to this data record. ")
    error_code: Optional[StrictStr] = Field(None, alias="errorCode", description="The error code of the response.  **Note:** This field is only available if `type` is `Payment`. ")
    error_message: Optional[StrictStr] = Field(None, alias="errorMessage", description="The detailed information of the error response.  **Note:** This field is only available if `type` is `Payment`. ")
    id: Optional[StrictStr] = Field(None, description="The ID of the current transaction. ")
    status: Optional[StrictStr] = None
    type: Optional[StrictStr] = None
    __properties = ["amount", "appliedAmount", "errorCode", "errorMessage", "id", "status", "type"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> GetPaymentRunDataTransactionElementResponse:
        """Create an instance of GetPaymentRunDataTransactionElementResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> GetPaymentRunDataTransactionElementResponse:
        """Create an instance of GetPaymentRunDataTransactionElementResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return GetPaymentRunDataTransactionElementResponse.parse_obj(obj)

        _obj = GetPaymentRunDataTransactionElementResponse.parse_obj({
            "amount": obj.get("amount"),
            "applied_amount": obj.get("appliedAmount"),
            "error_code": obj.get("errorCode"),
            "error_message": obj.get("errorMessage"),
            "id": obj.get("id"),
            "status": obj.get("status"),
            "type": obj.get("type")
        })
        return _obj


