# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr

class GetPaymentRunStatisticResponse(BaseModel):
    """
    Payment run statistic.  # noqa: E501
    """
    completed_on: Optional[datetime] = Field(None, alias="completedOn", description="The date and time the payment run is completed. ")
    executed_on: Optional[datetime] = Field(None, alias="executedOn", description="The date and time the payment run is executed. ")
    number: Optional[StrictStr] = Field(None, description="Payment run number. ")
    number_of_errors: Optional[StrictInt] = Field(None, alias="numberOfErrors", description="Number of errored payments ")
    number_of_payments: Optional[StrictInt] = Field(None, alias="numberOfPayments", description="Number of processed payments. ")
    status: Optional[StrictStr] = Field(None, description="Payment run status. ")
    __properties = ["completedOn", "executedOn", "number", "numberOfErrors", "numberOfPayments", "status"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> GetPaymentRunStatisticResponse:
        """Create an instance of GetPaymentRunStatisticResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> GetPaymentRunStatisticResponse:
        """Create an instance of GetPaymentRunStatisticResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return GetPaymentRunStatisticResponse.parse_obj(obj)

        _obj = GetPaymentRunStatisticResponse.parse_obj({
            "completed_on": obj.get("completedOn"),
            "executed_on": obj.get("executedOn"),
            "number": obj.get("number"),
            "number_of_errors": obj.get("numberOfErrors"),
            "number_of_payments": obj.get("numberOfPayments"),
            "status": obj.get("status")
        })
        return _obj


