# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from typing import List, Optional
from pydantic import BaseModel, Field, StrictBool, conlist
from com.zuora.models.get_payment_run_statistic_response import GetPaymentRunStatisticResponse
from com.zuora.models.get_payment_schedule_statistic_response_payment_schedule_items import GetPaymentScheduleStatisticResponsePaymentScheduleItems

class GetPaymentScheduleStatisticResponse(BaseModel):
    """
    The object that contains the payment schedule statistic of the specified date.   # noqa: E501
    """
    var_date: Optional[date] = Field(None, alias="date", description="The specified date. ")
    payment_runs: Optional[conlist(GetPaymentRunStatisticResponse)] = Field(None, alias="paymentRuns")
    payment_schedule_items: Optional[GetPaymentScheduleStatisticResponsePaymentScheduleItems] = Field(None, alias="paymentScheduleItems")
    success: Optional[StrictBool] = Field(None, description="Returns `true` if the request was processed successfully. ")
    __properties = ["date", "paymentRuns", "paymentScheduleItems", "success"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> GetPaymentScheduleStatisticResponse:
        """Create an instance of GetPaymentScheduleStatisticResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in payment_runs (list)
        _items = []
        if self.payment_runs:
            for _item in self.payment_runs:
                if _item:
                    _items.append(_item.to_dict())
            _dict['paymentRuns'] = _items
        # override the default output from pydantic by calling `to_dict()` of payment_schedule_items
        if self.payment_schedule_items:
            _dict['paymentScheduleItems'] = self.payment_schedule_items.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> GetPaymentScheduleStatisticResponse:
        """Create an instance of GetPaymentScheduleStatisticResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return GetPaymentScheduleStatisticResponse.parse_obj(obj)

        _obj = GetPaymentScheduleStatisticResponse.parse_obj({
            "var_date": obj.get("date"),
            "payment_runs": [GetPaymentRunStatisticResponse.from_dict(_item) for _item in obj.get("paymentRuns")] if obj.get("paymentRuns") is not None else None,
            "payment_schedule_items": GetPaymentScheduleStatisticResponsePaymentScheduleItems.from_dict(obj.get("paymentScheduleItems")) if obj.get("paymentScheduleItems") is not None else None,
            "success": obj.get("success")
        })
        return _obj


