# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictBool, StrictStr, conlist
from com.zuora.models.product_rate_plan import ProductRatePlan

class GetProductRatePlansByProductResponse(BaseModel):
    """
    GetProductRatePlansByProductResponse
    """
    next_page: Optional[StrictStr] = Field(None, alias="nextPage", description="URL to retrieve the next page of the response if it exists; otherwise absent. ")
    product_rate_plans: Optional[conlist(ProductRatePlan)] = Field(None, alias="productRatePlans", description="Container for one or more product rate plans. ")
    success: Optional[StrictBool] = Field(None, description="Returns `true` if the request was processed successfully. ")
    __properties = ["nextPage", "productRatePlans", "success"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> GetProductRatePlansByProductResponse:
        """Create an instance of GetProductRatePlansByProductResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in product_rate_plans (list)
        _items = []
        if self.product_rate_plans:
            for _item in self.product_rate_plans:
                if _item:
                    _items.append(_item.to_dict())
            _dict['productRatePlans'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> GetProductRatePlansByProductResponse:
        """Create an instance of GetProductRatePlansByProductResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return GetProductRatePlansByProductResponse.parse_obj(obj)

        _obj = GetProductRatePlansByProductResponse.parse_obj({
            "next_page": obj.get("nextPage"),
            "product_rate_plans": [ProductRatePlan.from_dict(_item) for _item in obj.get("productRatePlans")] if obj.get("productRatePlans") is not None else None,
            "success": obj.get("success")
        })
        return _obj


