# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Dict, Optional
from pydantic import BaseModel, Field, StrictBool, StrictStr, constr
from com.zuora.models.callout_auth import CalloutAuth

class GetPublicNotificationDefinitionResponseCallout(BaseModel):
    """
    GetPublicNotificationDefinitionResponseCallout
    """
    active: Optional[StrictBool] = Field(True, description="The status of the callout. The default value is `true`.")
    callout_auth: Optional[CalloutAuth] = Field(None, alias="calloutAuth")
    callout_baseurl: Optional[constr(strict=True, min_length=10)] = Field(None, alias="calloutBaseurl", description="The callout URL. It must start with 'https://'")
    callout_params: Optional[Dict[str, StrictStr]] = Field(None, alias="calloutParams", description="A key-value map of merge fields of this callout. ")
    callout_retry: Optional[StrictBool] = Field(True, alias="calloutRetry", description="Specified whether to retry the callout when the callout fails. The default value is `true`.")
    description: Optional[constr(strict=True, max_length=255)] = Field(None, description="Description for the callout.")
    event_type_name: Optional[constr(strict=True, min_length=1)] = Field(None, alias="eventTypeName", description="The name of the custom event type.")
    http_method: Optional[StrictStr] = Field(None, alias="httpMethod")
    id: Optional[StrictStr] = Field(None, description="The ID of the callout. If `calloutActive` is `true`, a callout is required. The eventTypeName of the callout MUST be the same as the eventTypeName.")
    name: Optional[constr(strict=True, max_length=255)] = Field(None, description="The name of the created callout.")
    required_auth: Optional[StrictBool] = Field(None, alias="requiredAuth", description="Specifies whether the callout requires auth.")
    created_by: Optional[StrictStr] = Field(None, alias="createdBy", description="The user who created the notification definition.")
    updated_on: Optional[StrictStr] = Field(None, alias="updatedOn", description="The time when the notification was updated. Specified in the UTC timezone in the ISO860 format (YYYY-MM-DDThh:mm:ss.sTZD). E.g. 1997-07-16T19:20:30.45+00:00")
    additional_properties: Dict[str, Any] = {}
    __properties = ["active", "calloutAuth", "calloutBaseurl", "calloutParams", "calloutRetry", "description", "eventTypeName", "httpMethod", "id", "name", "requiredAuth", "createdBy", "updatedOn"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> GetPublicNotificationDefinitionResponseCallout:
        """Create an instance of GetPublicNotificationDefinitionResponseCallout from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                            "additional_properties"
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of callout_auth
        if self.callout_auth:
            _dict['calloutAuth'] = self.callout_auth.to_dict()
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> GetPublicNotificationDefinitionResponseCallout:
        """Create an instance of GetPublicNotificationDefinitionResponseCallout from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return GetPublicNotificationDefinitionResponseCallout.parse_obj(obj)

        _obj = GetPublicNotificationDefinitionResponseCallout.parse_obj({
            "active": obj.get("active") if obj.get("active") is not None else True,
            "callout_auth": CalloutAuth.from_dict(obj.get("calloutAuth")) if obj.get("calloutAuth") is not None else None,
            "callout_baseurl": obj.get("calloutBaseurl"),
            "callout_params": obj.get("calloutParams"),
            "callout_retry": obj.get("calloutRetry") if obj.get("calloutRetry") is not None else True,
            "description": obj.get("description"),
            "event_type_name": obj.get("eventTypeName"),
            "http_method": obj.get("httpMethod"),
            "id": obj.get("id"),
            "name": obj.get("name"),
            "required_auth": obj.get("requiredAuth"),
            "created_by": obj.get("createdBy"),
            "updated_on": obj.get("updatedOn")
        })
        # store additional fields in additional_properties
        for _key in obj.keys():
            if _key not in cls.__properties:
                _obj.additional_properties[_key] = obj.get(_key)

        return _obj


