# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictStr, conlist
from com.zuora.models.get_public_email_template_response import GetPublicEmailTemplateResponse

class GetQueryEmailTemplates200Response(BaseModel):
    """
    GetQueryEmailTemplates200Response
    """
    next: Optional[StrictStr] = Field(None, description="The URI to query the next page of data, e.g. '/notification-definitions?start=1&limit=10'. The start equals request's start+limit, and the limit equals the request's limit. If the current page is the last page, this value is null.")
    data: Optional[conlist(GetPublicEmailTemplateResponse)] = None
    __properties = ["next", "data"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> GetQueryEmailTemplates200Response:
        """Create an instance of GetQueryEmailTemplates200Response from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in data (list)
        _items = []
        if self.data:
            for _item in self.data:
                if _item:
                    _items.append(_item.to_dict())
            _dict['data'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> GetQueryEmailTemplates200Response:
        """Create an instance of GetQueryEmailTemplates200Response from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return GetQueryEmailTemplates200Response.parse_obj(obj)

        _obj = GetQueryEmailTemplates200Response.parse_obj({
            "next": obj.get("next"),
            "data": [GetPublicEmailTemplateResponse.from_dict(_item) for _item in obj.get("data")] if obj.get("data") is not None else None
        })
        return _obj


