# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictInt

class GetWorkflowResponseTasks(BaseModel):
    """
    An object containing task counts.   # noqa: E501
    """
    error: Optional[StrictInt] = Field(None, description="The number of tasks in **Error** state. ")
    pending: Optional[StrictInt] = Field(None, description="The number of tasks in **Pending** state. ")
    processing: Optional[StrictInt] = Field(None, description="The number of tasks in **Processing** state. ")
    queued: Optional[StrictInt] = Field(None, description="The number of tasks in **Queued** state. ")
    stopped: Optional[StrictInt] = Field(None, description="The number of tasks in **Stopped** state. ")
    success: Optional[StrictInt] = Field(None, description="The number of tasks in **Success** state. ")
    total: Optional[StrictInt] = Field(None, description="The total number of tasks. ")
    __properties = ["error", "pending", "processing", "queued", "stopped", "success", "total"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> GetWorkflowResponseTasks:
        """Create an instance of GetWorkflowResponseTasks from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> GetWorkflowResponseTasks:
        """Create an instance of GetWorkflowResponseTasks from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return GetWorkflowResponseTasks.parse_obj(obj)

        _obj = GetWorkflowResponseTasks.parse_obj({
            "error": obj.get("error"),
            "pending": obj.get("pending"),
            "processing": obj.get("processing"),
            "queued": obj.get("queued"),
            "stopped": obj.get("stopped"),
            "success": obj.get("success"),
            "total": obj.get("total")
        })
        return _obj


