# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictStr

class HostedPageResponse(BaseModel):
    """
    HostedPageResponse
    """
    page_id: Optional[StrictStr] = Field(None, alias="pageId", description="Page ID of the Payment Page that Zuora assigns when it is created. ")
    page_name: Optional[StrictStr] = Field(None, alias="pageName", description="Name of the Payment Page that specified during the page configuration. ")
    page_type: Optional[StrictStr] = Field(None, alias="pageType", description="Payment method type of this Payment Page, e.g. 'Credit Card', 'ACH', or 'Bank Transfer'. ")
    page_version: Optional[StrictStr] = Field(None, alias="pageVersion", description="Version of the Payment Page. 2 for Payment Pages 2.0. ")
    __properties = ["pageId", "pageName", "pageType", "pageVersion"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> HostedPageResponse:
        """Create an instance of HostedPageResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> HostedPageResponse:
        """Create an instance of HostedPageResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return HostedPageResponse.parse_obj(obj)

        _obj = HostedPageResponse.parse_obj({
            "page_id": obj.get("pageId"),
            "page_name": obj.get("pageName"),
            "page_type": obj.get("pageType"),
            "page_version": obj.get("pageVersion")
        })
        return _obj


