# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional, Union
from pydantic import BaseModel, Field, StrictFloat, StrictInt, StrictStr

class InvoiceItemPreviewResultAdditionalInfo(BaseModel):
    """
    InvoiceItemPreviewResultAdditionalInfo
    """
    quantity: Optional[Union[StrictFloat, StrictInt]] = None
    unit_of_measure: Optional[StrictStr] = Field(None, alias="unitOfMeasure")
    number_of_deliveries: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="numberOfDeliveries", description="The number of delivery for charge.  **Note**: This field is available only if you have the Delivery Pricing feature enabled. ")
    __properties = ["quantity", "unitOfMeasure", "numberOfDeliveries"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> InvoiceItemPreviewResultAdditionalInfo:
        """Create an instance of InvoiceItemPreviewResultAdditionalInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> InvoiceItemPreviewResultAdditionalInfo:
        """Create an instance of InvoiceItemPreviewResultAdditionalInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return InvoiceItemPreviewResultAdditionalInfo.parse_obj(obj)

        _obj = InvoiceItemPreviewResultAdditionalInfo.parse_obj({
            "quantity": obj.get("quantity"),
            "unit_of_measure": obj.get("unitOfMeasure"),
            "number_of_deliveries": obj.get("numberOfDeliveries")
        })
        return _obj


