# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional, Union
from pydantic import BaseModel, Field, StrictFloat, StrictInt, StrictStr

class InvoiceItemPreviewResultTaxationItems(BaseModel):
    """
    InvoiceItemPreviewResultTaxationItems
    """
    exempt_amount: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="exemptAmount", description="The calculated tax amount excluded due to the exemption. ")
    id: Optional[StrictStr] = Field(None, description="The ID of the taxation item. ")
    jurisdiction: Optional[StrictStr] = Field(None, description="The jurisdiction that applies the tax or VAT. This value is typically a state, province, county, or city. ")
    location_code: Optional[StrictStr] = Field(None, alias="locationCode", description="The identifier for the location based on the value of the taxCode field. ")
    name: Optional[StrictStr] = Field(None, description="The name of the taxation item. ")
    tax_amount: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="taxAmount", description="The amount of the tax applied to the invoice. ")
    tax_code: Optional[StrictStr] = Field(None, alias="taxCode", description="The tax code identifies which tax rules and tax rates to apply to a specific invoice. ")
    tax_code_description: Optional[StrictStr] = Field(None, alias="taxCodeDescription", description="The description of the tax code. ")
    tax_date: Optional[StrictStr] = Field(None, alias="taxDate", description="The date when the tax is applied to the invoice. ")
    tax_rate: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="taxRate", description="The tax rate applied to the invoice. ")
    tax_rate_description: Optional[StrictStr] = Field(None, alias="taxRateDescription", description="The description of the tax rate. ")
    tax_rate_type: Optional[StrictStr] = Field(None, alias="taxRateType")
    __properties = ["exemptAmount", "id", "jurisdiction", "locationCode", "name", "taxAmount", "taxCode", "taxCodeDescription", "taxDate", "taxRate", "taxRateDescription", "taxRateType"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> InvoiceItemPreviewResultTaxationItems:
        """Create an instance of InvoiceItemPreviewResultTaxationItems from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> InvoiceItemPreviewResultTaxationItems:
        """Create an instance of InvoiceItemPreviewResultTaxationItems from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return InvoiceItemPreviewResultTaxationItems.parse_obj(obj)

        _obj = InvoiceItemPreviewResultTaxationItems.parse_obj({
            "exempt_amount": obj.get("exemptAmount"),
            "id": obj.get("id"),
            "jurisdiction": obj.get("jurisdiction"),
            "location_code": obj.get("locationCode"),
            "name": obj.get("name"),
            "tax_amount": obj.get("taxAmount"),
            "tax_code": obj.get("taxCode"),
            "tax_code_description": obj.get("taxCodeDescription"),
            "tax_date": obj.get("taxDate"),
            "tax_rate": obj.get("taxRate"),
            "tax_rate_description": obj.get("taxRateDescription"),
            "tax_rate_type": obj.get("taxRateType")
        })
        return _obj


