# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictStr, conlist

class InvoiceScheduleSubscription(BaseModel):
    """
    InvoiceScheduleSubscription
    """
    order_key: Optional[StrictStr] = Field(None, alias="orderKey", description="The unique ID or number of the order associated with the invoice schedule. ")
    subscription_key: Optional[StrictStr] = Field(None, alias="subscriptionKey", description="The unique number of the subscription contained in the order associated with the invoice schedule. ")
    charge_numbers: Optional[conlist(StrictStr)] = Field(None, alias="chargeNumbers", description="A list of the numbers of charges contained in the subscription\" ")
    __properties = ["orderKey", "subscriptionKey", "chargeNumbers"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> InvoiceScheduleSubscription:
        """Create an instance of InvoiceScheduleSubscription from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> InvoiceScheduleSubscription:
        """Create an instance of InvoiceScheduleSubscription from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return InvoiceScheduleSubscription.parse_obj(obj)

        _obj = InvoiceScheduleSubscription.parse_obj({
            "order_key": obj.get("orderKey"),
            "subscription_key": obj.get("subscriptionKey"),
            "charge_numbers": obj.get("chargeNumbers")
        })
        return _obj


