# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr

class Linkage(BaseModel):
    """
    Used to represent the relationship between workflow tasks  # noqa: E501
    """
    linkage_type: Optional[StrictStr] = None
    source_task_id: Optional[StrictInt] = Field(None, description="the task that spawned the target task")
    source_workflow_id: Optional[StrictInt] = Field(None, description="the workflow the target task is associated with")
    target_task_id: Optional[StrictInt] = Field(None, description="the task that the source task is linked to.")
    __properties = ["linkage_type", "source_task_id", "source_workflow_id", "target_task_id"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Linkage:
        """Create an instance of Linkage from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> Linkage:
        """Create an instance of Linkage from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return Linkage.parse_obj(obj)

        _obj = Linkage.parse_obj({
            "linkage_type": obj.get("linkage_type"),
            "source_task_id": obj.get("source_task_id"),
            "source_workflow_id": obj.get("source_workflow_id"),
            "target_task_id": obj.get("target_task_id")
        })
        return _obj


