# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictBool, StrictStr, conlist, constr
from com.zuora.models.create_order_subscription_owner_account import CreateOrderSubscriptionOwnerAccount
from com.zuora.models.order_action_create_subscription_terms import OrderActionCreateSubscriptionTerms
from com.zuora.models.rate_plan_override import RatePlanOverride
from com.zuora.models.subscribe_to_product import SubscribeToProduct

class OrderActionCreateSubscription(BaseModel):
    """
    Information about an order action of type `CreateSubscription`.   # noqa: E501
    """
    bill_to_contact_id: Optional[StrictStr] = Field(None, alias="billToContactId", description="The ID of the bill-to contact associated with the subscription.  **Note**:    - If you have the <a href=\"https://knowledgecenter.zuora.com/Zuora_Billing/Bill_your_customers/Bill_customers_at_subscription_level/Flexible_Billing_Attributes\" target=\"_blank\">Flexible Billing Attributes</a> feature disabled, this field is unavailable in the request body and the value of this field is `null` in the response body.    - If you have the Flexible Billing Attributes feature enabled, and you do not specify this field in the request or you select **Default Contact from Account** for this field during subscription creation, the value of this field is automatically set to `null` in the response body. ")
    invoice_group_number: Optional[constr(strict=True, max_length=255)] = Field(None, alias="invoiceGroupNumber", description="The number of invoice group associated with the subscription.  **Note**: This field is available only if you have the <a href=\"https://knowledgecenter.zuora.com/Zuora_Billing/Bill_your_customers/Bill_customers_at_subscription_level/Flexible_Billing_Attributes\" target=\"_blank\">Flexible Billing Attributes</a> feature enabled. ")
    invoice_separately: Optional[StrictBool] = Field(None, alias="invoiceSeparately", description="Specifies whether the subscription appears on a separate invoice when Zuora generates invoices. ")
    invoice_template_id: Optional[StrictStr] = Field(None, alias="invoiceTemplateId", description="The ID of the invoice template associated with the subscription.  **Note**:    - If you have the <a href=\"https://knowledgecenter.zuora.com/Zuora_Billing/Bill_your_customers/Bill_customers_at_subscription_level/Flexible_Billing_Attributes\" target=\"_blank\">Flexible Billing Attributes</a> feature disabled, this field is unavailable in the request body and the value of this field is `null` in the response body.    - If you have the Flexible Billing Attributes feature enabled, and you do not specify this field in the request or you select **Default Template from Account** for this field during subscription creation, the value of this field is automatically set to `null` in the response body. ")
    new_subscription_owner_account: Optional[CreateOrderSubscriptionOwnerAccount] = Field(None, alias="newSubscriptionOwnerAccount")
    notes: Optional[constr(strict=True, max_length=500)] = Field(None, description="Notes about the subscription. These notes are only visible to Zuora users. ")
    payment_term: Optional[StrictStr] = Field(None, alias="paymentTerm", description="The name of the payment term associated with the subscription. For example, `Net 30`. The payment term determines the due dates of invoices.  **Note**:    - If you have the <a href=\"https://knowledgecenter.zuora.com/Zuora_Billing/Bill_your_customers/Bill_customers_at_subscription_level/Flexible_Billing_Attributes\" target=\"_blank\">Flexible Billing Attributes</a> feature disabled, this field is unavailable in the request body and the value of this field is `null` in the response body.    - If you have the Flexible Billing Attributes feature enabled, and you do not specify this field in the request or you select **Default Term from Account** for this field during subscription creation, the value of this field is automatically set to `null` in the response body. ")
    sequence_set_id: Optional[StrictStr] = Field(None, alias="sequenceSetId", description="The ID of the sequence set associated with the subscription.  **Note**:    - If you have the <a href=\"https://knowledgecenter.zuora.com/Zuora_Billing/Bill_your_customers/Bill_customers_at_subscription_level/Flexible_Billing_Attributes\" target=\"_blank\">Flexible Billing Attributes</a> feature disabled, this field is unavailable in the request body and the value of this field is `null` in the response body.    - If you have the Flexible Billing Attributes feature enabled, and you do not specify this field in the request or you select **Default Set from Account** for this field during subscription creation, the value of this field is automatically set to `null` in the response body. ")
    sold_to_contact_id: Optional[StrictStr] = Field(None, alias="soldToContactId", description="The ID of the sold-to contact associated with the subscription.  **Note**:    - If you have the <a href=\"https://knowledgecenter.zuora.com/Zuora_Billing/Bill_your_customers/Bill_customers_at_subscription_level/Flexible_Billing_Attributes\" target=\"_blank\">Flexible Billing Attributes</a> feature disabled, this field is unavailable in the request body and the value of this field is `null` in the response body.    - If you have the Flexible Billing Attributes feature enabled, and you do not specify this field in the request or you select **Default Contact from Account** for this field during subscription creation, the value of this field is automatically set to `null` in the response body. ")
    subscribe_to_products: Optional[conlist(SubscribeToProduct)] = Field(None, alias="subscribeToProducts", description="For a rate plan, the following fields are available:   - `chargeOverrides`   - `clearingExistingFeatures`   - `customFields`   - `externallyManagedPlanId`   - `newRatePlanId`   - `productRatePlanId`   - `subscriptionProductFeatures`   - `uniqueToken`    ")
    subscribe_to_rate_plans: Optional[conlist(RatePlanOverride)] = Field(None, alias="subscribeToRatePlans", description="List of rate plans associated with the subscription.  **Note**: The `subscribeToRatePlans` field has been deprecated, this field is replaced by the `subscribeToProducts` field that supports Rate Plans. In a new order request, you can use either `subscribeToRatePlans` or `subscribeToProducts`, not both. ")
    subscription_number: Optional[constr(strict=True, max_length=100)] = Field(None, alias="subscriptionNumber", description="Subscription number of the subscription. For example, A-S00000001.  If you do not set this field, Zuora will generate the subscription number. ")
    subscription_owner_account_number: Optional[constr(strict=True, max_length=70)] = Field(None, alias="subscriptionOwnerAccountNumber", description="Account number of an existing account that will own the subscription. For example, A00000001.  If you do not set this field or the `newSubscriptionOwnerAccount` field, the account that owns the order will also own the subscription. Zuora will return an error if you set this field and the `newSubscriptionOwnerAccount` field. ")
    terms: Optional[OrderActionCreateSubscriptionTerms] = None
    __properties = ["billToContactId", "invoiceGroupNumber", "invoiceSeparately", "invoiceTemplateId", "newSubscriptionOwnerAccount", "notes", "paymentTerm", "sequenceSetId", "soldToContactId", "subscribeToProducts", "subscribeToRatePlans", "subscriptionNumber", "subscriptionOwnerAccountNumber", "terms"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> OrderActionCreateSubscription:
        """Create an instance of OrderActionCreateSubscription from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of new_subscription_owner_account
        if self.new_subscription_owner_account:
            _dict['newSubscriptionOwnerAccount'] = self.new_subscription_owner_account.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in subscribe_to_products (list)
        _items = []
        if self.subscribe_to_products:
            for _item in self.subscribe_to_products:
                if _item:
                    _items.append(_item.to_dict())
            _dict['subscribeToProducts'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in subscribe_to_rate_plans (list)
        _items = []
        if self.subscribe_to_rate_plans:
            for _item in self.subscribe_to_rate_plans:
                if _item:
                    _items.append(_item.to_dict())
            _dict['subscribeToRatePlans'] = _items
        # override the default output from pydantic by calling `to_dict()` of terms
        if self.terms:
            _dict['terms'] = self.terms.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> OrderActionCreateSubscription:
        """Create an instance of OrderActionCreateSubscription from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return OrderActionCreateSubscription.parse_obj(obj)

        _obj = OrderActionCreateSubscription.parse_obj({
            "bill_to_contact_id": obj.get("billToContactId"),
            "invoice_group_number": obj.get("invoiceGroupNumber"),
            "invoice_separately": obj.get("invoiceSeparately"),
            "invoice_template_id": obj.get("invoiceTemplateId"),
            "new_subscription_owner_account": CreateOrderSubscriptionOwnerAccount.from_dict(obj.get("newSubscriptionOwnerAccount")) if obj.get("newSubscriptionOwnerAccount") is not None else None,
            "notes": obj.get("notes"),
            "payment_term": obj.get("paymentTerm"),
            "sequence_set_id": obj.get("sequenceSetId"),
            "sold_to_contact_id": obj.get("soldToContactId"),
            "subscribe_to_products": [SubscribeToProduct.from_dict(_item) for _item in obj.get("subscribeToProducts")] if obj.get("subscribeToProducts") is not None else None,
            "subscribe_to_rate_plans": [RatePlanOverride.from_dict(_item) for _item in obj.get("subscribeToRatePlans")] if obj.get("subscribeToRatePlans") is not None else None,
            "subscription_number": obj.get("subscriptionNumber"),
            "subscription_owner_account_number": obj.get("subscriptionOwnerAccountNumber"),
            "terms": OrderActionCreateSubscriptionTerms.from_dict(obj.get("terms")) if obj.get("terms") is not None else None
        })
        return _obj


