# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictBool, StrictStr, constr

class OrderActionOwnerTransfer(BaseModel):
    """
    Information about an order action of type `OwnerTransfer`.  **Note:** The Owner Transfer feature is in **Limited Availability**. If you wish to have access to the feature, submit a request at [Zuora Global Support](http://support.zuora.com/).   # noqa: E501
    """
    bill_to_contact_id: Optional[StrictStr] = Field(None, alias="billToContactId", description="The contact id of the bill to contact that the subscription is being transferred to.  **Note**:    - If you have the <a href=\"https://knowledgecenter.zuora.com/Zuora_Billing/Bill_your_customers/Bill_customers_at_subscription_level/Flexible_Billing_Attributes\" target=\"_blank\">Flexible Billing Attributes</a> feature disabled, this field is unavailable in the request body and the value of this field is `null` in the response body.    - If you have the Flexible Billing Attributes feature enabled, and you do not specify this field in the request or you select **Default Contact from Account** for this field during subscription creation, the value of this field is automatically set to `null` in the response body. ")
    clearing_existing_bill_to_contact: Optional[StrictBool] = Field(False, alias="clearingExistingBillToContact", description="Whether to clear the existing bill-to contact ID at the subscription level. This field is mutually exclusive with the `billToContactId` field.  **Note**: If you have the [Flexible Billing Attributes](https://knowledgecenter.zuora.com/Billing/Subscriptions/Flexible_Billing_Attributes) feature disabled, this field is unavailable in the request body and the value of this field is `null` in the response body. ")
    clearing_existing_invoice_group_number: Optional[StrictBool] = Field(False, alias="clearingExistingInvoiceGroupNumber", description="Whether to clear the existing invoice group number at the subscription level. This field is mutually exclusive with the `invoiceGroupNumber` field.  **Note**: If you have the [Flexible Billing Attributes](https://knowledgecenter.zuora.com/Billing/Subscriptions/Flexible_Billing_Attributes) feature disabled, this field is unavailable in the request body and the value of this field is `null` in the response body. ")
    clearing_existing_invoice_template: Optional[StrictBool] = Field(False, alias="clearingExistingInvoiceTemplate", description="Whether to clear the existing invoice template ID at the subscription level. This field is mutually exclusive with the `invoiceTemplateId` field.  **Note**: If you have the [Flexible Billing Attributes](https://knowledgecenter.zuora.com/Billing/Subscriptions/Flexible_Billing_Attributes) feature disabled, this field is unavailable in the request body and the value of this field is `null` in the response body. ")
    clearing_existing_payment_term: Optional[StrictBool] = Field(False, alias="clearingExistingPaymentTerm", description="Whether to clear the existing payment term at the subscription level. This field is mutually exclusive with the `paymentTerm` field.  **Note**: If you have the [Flexible Billing Attributes](https://knowledgecenter.zuora.com/Billing/Subscriptions/Flexible_Billing_Attributes) feature disabled, this field is unavailable in the request body and the value of this field is `null` in the response body. ")
    clearing_existing_sequence_set: Optional[StrictBool] = Field(False, alias="clearingExistingSequenceSet", description="Whether to clear the existing sequence set ID at the subscription level. This field is mutually exclusive with the `sequenceSetId` field.  **Note**: If you have the [Flexible Billing Attributes](https://knowledgecenter.zuora.com/Billing/Subscriptions/Flexible_Billing_Attributes) feature disabled, this field is unavailable in the request body and the value of this field is `null` in the response body. ")
    clearing_existing_sold_to_contact: Optional[StrictBool] = Field(False, alias="clearingExistingSoldToContact", description="Whether to clear the existing sold-to contact ID at the subscription level. This field is mutually exclusive with the `soldToContactId` field.  **Note**: If you have the [Flexible Billing Attributes](https://knowledgecenter.zuora.com/Billing/Subscriptions/Flexible_Billing_Attributes) feature disabled, this field is unavailable in the request body and the value of this field is `null` in the response body. ")
    destination_account_number: Optional[StrictStr] = Field(None, alias="destinationAccountNumber", description="The account number of the account that the subscription is being transferred to. ")
    destination_invoice_account_number: Optional[StrictStr] = Field(None, alias="destinationInvoiceAccountNumber", description="The account number of the invoice owner account that the subscription is being transferred to. ")
    invoice_group_number: Optional[constr(strict=True, max_length=255)] = Field(None, alias="invoiceGroupNumber", description="The number of invoice group associated with the subscription.  **Note**: This field is available only if you have the <a href=\"https://knowledgecenter.zuora.com/Zuora_Billing/Bill_your_customers/Bill_customers_at_subscription_level/Flexible_Billing_Attributes\" target=\"_blank\">Flexible Billing Attributes</a> feature enabled. ")
    invoice_template_id: Optional[StrictStr] = Field(None, alias="invoiceTemplateId", description="The ID of the invoice template associated with the subscription.  **Note**:    - If you have the <a href=\"https://knowledgecenter.zuora.com/Zuora_Billing/Bill_your_customers/Bill_customers_at_subscription_level/Flexible_Billing_Attributes\" target=\"_blank\">Flexible Billing Attributes</a> feature disabled, this field is unavailable in the request body and the value of this field is `null` in the response body.    - If you have the Flexible Billing Attributes feature enabled, and you do not specify this field in the request or you select **Default Template from Account** for this field during subscription creation, the value of this field is automatically set to `null` in the response body. ")
    payment_term: Optional[StrictStr] = Field(None, alias="paymentTerm", description="Name of the payment term associated with the account. For example, \"Net 30\". The payment term determines the due dates of invoices.  **Note**:    - If you have the <a href=\"https://knowledgecenter.zuora.com/Zuora_Billing/Bill_your_customers/Bill_customers_at_subscription_level/Flexible_Billing_Attributes\" target=\"_blank\">Flexible Billing Attributes</a> feature disabled, this field is unavailable in the request body and the value of this field is `null` in the response body.    - If you have the Flexible Billing Attributes feature enabled, and you do not specify this field in the request or you select **Default Term from Account** for this field during subscription creation, the value of this field is automatically set to `null` in the response body. ")
    sequence_set_id: Optional[StrictStr] = Field(None, alias="sequenceSetId", description="The ID of the sequence set associated with the subscription.  **Note**:    - If you have the <a href=\"https://knowledgecenter.zuora.com/Zuora_Billing/Bill_your_customers/Bill_customers_at_subscription_level/Flexible_Billing_Attributes\" target=\"_blank\">Flexible Billing Attributes</a> feature disabled, this field is unavailable in the request body and the value of this field is `null` in the response body.    - If you have the Flexible Billing Attributes feature enabled, and you do not specify this field in the request or you select **Default Set from Account** for this field during subscription creation, the value of this field is automatically set to `null` in the response body. ")
    sold_to_contact_id: Optional[StrictStr] = Field(None, alias="soldToContactId", description="The ID of the sold-to contact associated with the subscription.  **Note**:    - If you have the <a href=\"https://knowledgecenter.zuora.com/Zuora_Billing/Bill_your_customers/Bill_customers_at_subscription_level/Flexible_Billing_Attributes\" target=\"_blank\">Flexible Billing Attributes</a> feature disabled, this field is unavailable in the request body and the value of this field is `null` in the response body.    - If you have the Flexible Billing Attributes feature enabled, and you do not specify this field in the request or you select **Default Contact from Account** for this field during subscription creation, the value of this field is automatically set to `null` in the response body. ")
    __properties = ["billToContactId", "clearingExistingBillToContact", "clearingExistingInvoiceGroupNumber", "clearingExistingInvoiceTemplate", "clearingExistingPaymentTerm", "clearingExistingSequenceSet", "clearingExistingSoldToContact", "destinationAccountNumber", "destinationInvoiceAccountNumber", "invoiceGroupNumber", "invoiceTemplateId", "paymentTerm", "sequenceSetId", "soldToContactId"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> OrderActionOwnerTransfer:
        """Create an instance of OrderActionOwnerTransfer from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> OrderActionOwnerTransfer:
        """Create an instance of OrderActionOwnerTransfer from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return OrderActionOwnerTransfer.parse_obj(obj)

        _obj = OrderActionOwnerTransfer.parse_obj({
            "bill_to_contact_id": obj.get("billToContactId"),
            "clearing_existing_bill_to_contact": obj.get("clearingExistingBillToContact") if obj.get("clearingExistingBillToContact") is not None else False,
            "clearing_existing_invoice_group_number": obj.get("clearingExistingInvoiceGroupNumber") if obj.get("clearingExistingInvoiceGroupNumber") is not None else False,
            "clearing_existing_invoice_template": obj.get("clearingExistingInvoiceTemplate") if obj.get("clearingExistingInvoiceTemplate") is not None else False,
            "clearing_existing_payment_term": obj.get("clearingExistingPaymentTerm") if obj.get("clearingExistingPaymentTerm") is not None else False,
            "clearing_existing_sequence_set": obj.get("clearingExistingSequenceSet") if obj.get("clearingExistingSequenceSet") is not None else False,
            "clearing_existing_sold_to_contact": obj.get("clearingExistingSoldToContact") if obj.get("clearingExistingSoldToContact") is not None else False,
            "destination_account_number": obj.get("destinationAccountNumber"),
            "destination_invoice_account_number": obj.get("destinationInvoiceAccountNumber"),
            "invoice_group_number": obj.get("invoiceGroupNumber"),
            "invoice_template_id": obj.get("invoiceTemplateId"),
            "payment_term": obj.get("paymentTerm"),
            "sequence_set_id": obj.get("sequenceSetId"),
            "sold_to_contact_id": obj.get("soldToContactId")
        })
        return _obj


