# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictStr, conlist
from com.zuora.models.order_action_rate_plan_order_action import OrderActionRatePlanOrderAction

class OrderActionRatePlanOrder(BaseModel):
    """
    The order that is related to the subscription rate plan.   # noqa: E501
    """
    id: Optional[StrictStr] = Field(None, description="The order ID.")
    order_actions: Optional[conlist(OrderActionRatePlanOrderAction)] = Field(None, alias="orderActions")
    order_number: Optional[StrictStr] = Field(None, alias="orderNumber", description="The order number of the order.")
    __properties = ["id", "orderActions", "orderNumber"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> OrderActionRatePlanOrder:
        """Create an instance of OrderActionRatePlanOrder from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in order_actions (list)
        _items = []
        if self.order_actions:
            for _item in self.order_actions:
                if _item:
                    _items.append(_item.to_dict())
            _dict['orderActions'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> OrderActionRatePlanOrder:
        """Create an instance of OrderActionRatePlanOrder from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return OrderActionRatePlanOrder.parse_obj(obj)

        _obj = OrderActionRatePlanOrder.parse_obj({
            "id": obj.get("id"),
            "order_actions": [OrderActionRatePlanOrderAction.from_dict(_item) for _item in obj.get("orderActions")] if obj.get("orderActions") is not None else None,
            "order_number": obj.get("orderNumber")
        })
        return _obj


