# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional, Union
from pydantic import BaseModel, Field, StrictFloat, StrictInt, StrictStr, confloat, conint
from com.zuora.models.delivery_schedule_params import DeliveryScheduleParams
from com.zuora.models.price_change_option import PriceChangeOption

class OrderActionRatePlanRecurringDeliveryPricingUpdate(BaseModel):
    """
    OrderActionRatePlanRecurringDeliveryPricingUpdate
    """
    price_change_option: Optional[StrictStr] = Field(None, alias="priceChangeOption")
    price_increase_percentage: Optional[Union[confloat(ge=-100, strict=True), conint(ge=-100, strict=True)]] = Field(None, alias="priceIncreasePercentage", description="Specifies the percentage by which the price of the charge should change each time the subscription renews. Only applicable if the value of the `priceChangeOption` field is `SpecificPercentageValue`. ")
    delivery_schedule: Optional[DeliveryScheduleParams] = Field(None, alias="deliverySchedule")
    list_price: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="listPrice")
    __properties = ["priceChangeOption", "priceIncreasePercentage", "deliverySchedule", "listPrice"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> OrderActionRatePlanRecurringDeliveryPricingUpdate:
        """Create an instance of OrderActionRatePlanRecurringDeliveryPricingUpdate from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of delivery_schedule
        if self.delivery_schedule:
            _dict['deliverySchedule'] = self.delivery_schedule.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> OrderActionRatePlanRecurringDeliveryPricingUpdate:
        """Create an instance of OrderActionRatePlanRecurringDeliveryPricingUpdate from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return OrderActionRatePlanRecurringDeliveryPricingUpdate.parse_obj(obj)

        _obj = OrderActionRatePlanRecurringDeliveryPricingUpdate.parse_obj({
            "price_change_option": obj.get("priceChangeOption"),
            "price_increase_percentage": obj.get("priceIncreasePercentage"),
            "delivery_schedule": DeliveryScheduleParams.from_dict(obj.get("deliverySchedule")) if obj.get("deliverySchedule") is not None else None,
            "list_price": obj.get("listPrice")
        })
        return _obj


