# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from typing import Any, Dict, List, Optional
from pydantic import BaseModel, Field, StrictStr, conlist
from com.zuora.models.order_action_rate_plan_charge_update import OrderActionRatePlanChargeUpdate

class OrderActionRatePlanUpdate(BaseModel):
    """
    Information about an order action of type `UpdateProduct`.   # noqa: E501
    """
    charge_updates: Optional[conlist(OrderActionRatePlanChargeUpdate)] = Field(None, alias="chargeUpdates")
    custom_fields: Optional[Dict[str, Dict[str, Any]]] = Field(None, alias="customFields", description="Container for custom fields of a Rate Plan object. ")
    new_rate_plan_id: Optional[StrictStr] = Field(None, alias="newRatePlanId", description="Internal identifier of the updated rate plan in the new subscription version. ")
    rate_plan_id: Optional[StrictStr] = Field(None, alias="ratePlanId", description="Internal identifier of the rate plan that was updated. ")
    specific_update_date: Optional[date] = Field(None, alias="specificUpdateDate", description=" The date when the Update Product order action takes effect. This field is only applicable if there is already a future-dated Update Product order action on the subscription. The format of the date is yyyy-mm-dd.  See [Update a Product on Subscription with Future-dated Updates](https://knowledgecenter.zuora.com/BC_Subscription_Management/Orders/AC_Orders_Tutorials/C_Update_a_Product_in_a_Subscription/Update_a_Product_on_Subscription_with_Future-dated_Updates) for more information about this feature. ")
    unique_token: Optional[StrictStr] = Field(None, alias="uniqueToken", description="A unique string to represent the rate plan charge in the order. The unique token is used to perform multiple actions against a newly added rate plan. For example, if you want to add and update a product in the same order, you would assign a unique token to the product rate plan when added and use that token in future order actions. ")
    __properties = ["chargeUpdates", "customFields", "newRatePlanId", "ratePlanId", "specificUpdateDate", "uniqueToken"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> OrderActionRatePlanUpdate:
        """Create an instance of OrderActionRatePlanUpdate from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in charge_updates (list)
        _items = []
        if self.charge_updates:
            for _item in self.charge_updates:
                if _item:
                    _items.append(_item.to_dict())
            _dict['chargeUpdates'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> OrderActionRatePlanUpdate:
        """Create an instance of OrderActionRatePlanUpdate from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return OrderActionRatePlanUpdate.parse_obj(obj)

        _obj = OrderActionRatePlanUpdate.parse_obj({
            "charge_updates": [OrderActionRatePlanChargeUpdate.from_dict(_item) for _item in obj.get("chargeUpdates")] if obj.get("chargeUpdates") is not None else None,
            "custom_fields": obj.get("customFields"),
            "new_rate_plan_id": obj.get("newRatePlanId"),
            "rate_plan_id": obj.get("ratePlanId"),
            "specific_update_date": obj.get("specificUpdateDate"),
            "unique_token": obj.get("uniqueToken")
        })
        return _obj


