# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from typing import Optional
from pydantic import BaseModel, Field, StrictBool, StrictInt, StrictStr

class OrderActionResume(BaseModel):
    """
    Information about an order action of type `Resume`.   # noqa: E501
    """
    extends_term: Optional[StrictBool] = Field(None, alias="extendsTerm", description="Specifies whether to extend the subscription term by the length of time the suspension is in effect. Note this field is not applicable in a Resume order action auto-created by the Order Metrics migration. ")
    resume_date: Optional[date] = Field(None, alias="resumeDate", description="The resume date when the resumption takes effect. ")
    resume_periods: Optional[StrictInt] = Field(None, alias="resumePeriods", description="This field is applicable only when the `resumePolicy` field is set to `FixedPeriodsFromToday` or `FixedPeriodsFromSuspendDate`. It must be used together with the `resumePeriodsType` field. Note this field is not applicable in a Resume order action auto-created by the Order Metrics migration.  The total number of the periods used to specify when a subscription resumption takes effect. The subscription resumption will take place after the specified time frame (`suspendPeriods` multiplied by `suspendPeriodsType`) from today's date.  ")
    resume_periods_type: Optional[StrictStr] = Field(None, alias="resumePeriodsType")
    resume_policy: Optional[StrictStr] = Field(None, alias="resumePolicy")
    resume_specific_date: Optional[date] = Field(None, alias="resumeSpecificDate", description="This field is applicable only when the `resumePolicy` field is set to `SpecificDate`. Note this field is not applicable in a Resume order action auto-created by the Order Metrics migration.  A specific date when the subscription resumption takes effect, in YYYY-MM-DD format. The value should not be earlier than the subscription suspension date. ")
    __properties = ["extendsTerm", "resumeDate", "resumePeriods", "resumePeriodsType", "resumePolicy", "resumeSpecificDate"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> OrderActionResume:
        """Create an instance of OrderActionResume from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> OrderActionResume:
        """Create an instance of OrderActionResume from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return OrderActionResume.parse_obj(obj)

        _obj = OrderActionResume.parse_obj({
            "extends_term": obj.get("extendsTerm"),
            "resume_date": obj.get("resumeDate"),
            "resume_periods": obj.get("resumePeriods"),
            "resume_periods_type": obj.get("resumePeriodsType"),
            "resume_policy": obj.get("resumePolicy"),
            "resume_specific_date": obj.get("resumeSpecificDate")
        })
        return _obj


