# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictBool, StrictStr, conlist, constr
from com.zuora.models.initial_term import InitialTerm
from com.zuora.models.renewal_term import RenewalTerm

class OrderActionTermsAndConditions(BaseModel):
    """
    Information about an order action of type `TermsAndConditions`.   # noqa: E501
    """
    auto_renew: Optional[StrictBool] = Field(None, alias="autoRenew")
    bill_to_contact_id: Optional[StrictStr] = Field(None, alias="billToContactId", description="The ID of the bill-to contact associated with the subscription.  **Note**:    - If you have the <a href=\"https://knowledgecenter.zuora.com/Zuora_Billing/Bill_your_customers/Bill_customers_at_subscription_level/Flexible_Billing_Attributes\" target=\"_blank\">Flexible Billing Attributes</a> feature disabled, this field is unavailable in the request body and the value of this field is `null` in the response body.    - If you have the Flexible Billing Attributes feature enabled, and you do not specify this field in the request or you select **Default Contact from Account** for this field during subscription creation, the value of this field is automatically set to `null` in the response body. ")
    clearing_existing_bill_to_contact: Optional[StrictBool] = Field(False, alias="clearingExistingBillToContact", description="Whether to clear the existing bill-to contact ID at the subscription level. This field is mutually exclusive with the `billToContactId` field.  **Note**: If you have the [Flexible Billing Attributes](https://knowledgecenter.zuora.com/Billing/Subscriptions/Flexible_Billing_Attributes) feature disabled, this field is unavailable in the request body and the value of this field is `null` in the response body. ")
    clearing_existing_invoice_group_number: Optional[StrictBool] = Field(False, alias="clearingExistingInvoiceGroupNumber", description="Whether to clear the existing invoice group number at the subscription level. This field is mutually exclusive with the `invoiceGroupNumber` field.  **Note**: If you have the [Flexible Billing Attributes](https://knowledgecenter.zuora.com/Billing/Subscriptions/Flexible_Billing_Attributes) feature disabled, this field is unavailable in the request body and the value of this field is `null` in the response body. ")
    clearing_existing_invoice_template: Optional[StrictBool] = Field(False, alias="clearingExistingInvoiceTemplate", description="Whether to clear the existing invoice template ID at the subscription level. This field is mutually exclusive with the `invoiceTemplateId` field.  **Note**: If you have the [Flexible Billing Attributes](https://knowledgecenter.zuora.com/Billing/Subscriptions/Flexible_Billing_Attributes) feature disabled, this field is unavailable in the request body and the value of this field is `null` in the response body. ")
    clearing_existing_payment_term: Optional[StrictBool] = Field(False, alias="clearingExistingPaymentTerm", description="Whether to clear the existing payment term at the subscription level. This field is mutually exclusive with the `paymentTerm` field.  **Note**: If you have the [Flexible Billing Attributes](https://knowledgecenter.zuora.com/Billing/Subscriptions/Flexible_Billing_Attributes) feature disabled, this field is unavailable in the request body and the value of this field is `null` in the response body. ")
    clearing_existing_sequence_set: Optional[StrictBool] = Field(False, alias="clearingExistingSequenceSet", description="Whether to clear the existing sequence set ID at the subscription level. This field is mutually exclusive with the `sequenceSetId` field.  **Note**: If you have the [Flexible Billing Attributes](https://knowledgecenter.zuora.com/Billing/Subscriptions/Flexible_Billing_Attributes) feature disabled, this field is unavailable in the request body and the value of this field is `null` in the response body. ")
    clearing_existing_sold_to_contact: Optional[StrictBool] = Field(False, alias="clearingExistingSoldToContact", description="Whether to clear the existing sold-to contact ID at the subscription level. This field is mutually exclusive with the `soldToContactId` field.  **Note**: If you have the [Flexible Billing Attributes](https://knowledgecenter.zuora.com/Billing/Subscriptions/Flexible_Billing_Attributes) feature disabled, this field is unavailable in the request body and the value of this field is `null` in the response body. ")
    initial_term: Optional[InitialTerm] = Field(None, alias="initialTerm")
    invoice_separately: Optional[StrictBool] = Field(None, alias="invoiceSeparately", description="Specifies whether the subscription appears on a separate invoice when Zuora generates invoices.")
    invoice_group_number: Optional[constr(strict=True, max_length=255)] = Field(None, alias="invoiceGroupNumber", description="The number of invoice group associated with the subscription.  **Note**: This field is available only if you have the <a href=\"https://knowledgecenter.zuora.com/Zuora_Billing/Bill_your_customers/Bill_customers_at_subscription_level/Flexible_Billing_Attributes\" target=\"_blank\">Flexible Billing Attributes</a> feature enabled. ")
    invoice_template_id: Optional[StrictStr] = Field(None, alias="invoiceTemplateId", description="The ID of the invoice template associated with the subscription.  **Note**:    - If you have the <a href=\"https://knowledgecenter.zuora.com/Zuora_Billing/Bill_your_customers/Bill_customers_at_subscription_level/Flexible_Billing_Attributes\" target=\"_blank\">Flexible Billing Attributes</a> feature disabled, this field is unavailable in the request body and the value of this field is `null` in the response body.    - If you have the Flexible Billing Attributes feature enabled, and you do not specify this field in the request or you select **Default Template from Account** for this field during subscription creation, the value of this field is automatically set to `null` in the response body. ")
    payment_term: Optional[StrictStr] = Field(None, alias="paymentTerm", description="The name of the payment term associated with the subscription. For example, `Net 30`. The payment term determines the due dates of invoices.  **Note**:    - If you have the <a href=\"https://knowledgecenter.zuora.com/Zuora_Billing/Bill_your_customers/Bill_customers_at_subscription_level/Flexible_Billing_Attributes\" target=\"_blank\">Flexible Billing Attributes</a> feature disabled, this field is unavailable in the request body and the value of this field is `null` in the response body.    - If you have the Flexible Billing Attributes feature enabled, and you do not specify this field in the request or you select **Default Term from Account** for this field during subscription creation, the value of this field is automatically set to `null` in the response body. ")
    renewal_setting: Optional[StrictStr] = Field(None, alias="renewalSetting")
    renewal_terms: Optional[conlist(RenewalTerm)] = Field(None, alias="renewalTerms")
    sequence_set_id: Optional[StrictStr] = Field(None, alias="sequenceSetId", description="The ID of the sequence set associated with the subscription.    **Note**:    - If you have the <a href=\"https://knowledgecenter.zuora.com/Zuora_Billing/Bill_your_customers/Bill_customers_at_subscription_level/Flexible_Billing_Attributes\" target=\"_blank\">Flexible Billing Attributes</a> feature disabled, this field is unavailable in the request body and the value of this field is `null` in the response body.    - If you have the Flexible Billing Attributes feature enabled, and you do not specify this field in the request or you select **Default Set from Account** for this field during subscription creation, the value of this field is automatically set to `null` in the response body. ")
    sold_to_contact_id: Optional[StrictStr] = Field(None, alias="soldToContactId", description="The ID of the sold-to contact associated with the subscription.  **Note**:    - If you have the <a href=\"https://knowledgecenter.zuora.com/Zuora_Billing/Bill_your_customers/Bill_customers_at_subscription_level/Flexible_Billing_Attributes\" target=\"_blank\">Flexible Billing Attributes</a> feature disabled, this field is unavailable in the request body and the value of this field is `null` in the response body.    - If you have the Flexible Billing Attributes feature enabled, and you do not specify this field in the request or you select **Default Contact from Account** for this field during subscription creation, the value of this field is automatically set to `null` in the response body. ")
    __properties = ["autoRenew", "billToContactId", "clearingExistingBillToContact", "clearingExistingInvoiceGroupNumber", "clearingExistingInvoiceTemplate", "clearingExistingPaymentTerm", "clearingExistingSequenceSet", "clearingExistingSoldToContact", "initialTerm", "invoiceSeparately", "invoiceGroupNumber", "invoiceTemplateId", "paymentTerm", "renewalSetting", "renewalTerms", "sequenceSetId", "soldToContactId"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> OrderActionTermsAndConditions:
        """Create an instance of OrderActionTermsAndConditions from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of initial_term
        if self.initial_term:
            _dict['initialTerm'] = self.initial_term.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in renewal_terms (list)
        _items = []
        if self.renewal_terms:
            for _item in self.renewal_terms:
                if _item:
                    _items.append(_item.to_dict())
            _dict['renewalTerms'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> OrderActionTermsAndConditions:
        """Create an instance of OrderActionTermsAndConditions from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return OrderActionTermsAndConditions.parse_obj(obj)

        _obj = OrderActionTermsAndConditions.parse_obj({
            "auto_renew": obj.get("autoRenew"),
            "bill_to_contact_id": obj.get("billToContactId"),
            "clearing_existing_bill_to_contact": obj.get("clearingExistingBillToContact") if obj.get("clearingExistingBillToContact") is not None else False,
            "clearing_existing_invoice_group_number": obj.get("clearingExistingInvoiceGroupNumber") if obj.get("clearingExistingInvoiceGroupNumber") is not None else False,
            "clearing_existing_invoice_template": obj.get("clearingExistingInvoiceTemplate") if obj.get("clearingExistingInvoiceTemplate") is not None else False,
            "clearing_existing_payment_term": obj.get("clearingExistingPaymentTerm") if obj.get("clearingExistingPaymentTerm") is not None else False,
            "clearing_existing_sequence_set": obj.get("clearingExistingSequenceSet") if obj.get("clearingExistingSequenceSet") is not None else False,
            "clearing_existing_sold_to_contact": obj.get("clearingExistingSoldToContact") if obj.get("clearingExistingSoldToContact") is not None else False,
            "initial_term": InitialTerm.from_dict(obj.get("initialTerm")) if obj.get("initialTerm") is not None else None,
            "invoice_separately": obj.get("invoiceSeparately"),
            "invoice_group_number": obj.get("invoiceGroupNumber"),
            "invoice_template_id": obj.get("invoiceTemplateId"),
            "payment_term": obj.get("paymentTerm"),
            "renewal_setting": obj.get("renewalSetting"),
            "renewal_terms": [RenewalTerm.from_dict(_item) for _item in obj.get("renewalTerms")] if obj.get("renewalTerms") is not None else None,
            "sequence_set_id": obj.get("sequenceSetId"),
            "sold_to_contact_id": obj.get("soldToContactId")
        })
        return _obj


