# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional, Union
from pydantic import BaseModel, Field, StrictFloat, StrictInt, StrictStr, conlist
from com.zuora.models.order_ramp_interval_metrics import OrderRampIntervalMetrics

class OrderRampMetrics(BaseModel):
    """
    OrderRampMetrics
    """
    description: Optional[StrictStr] = Field(None, description="The short description of the ramp.")
    discount_tcb: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="discountTcb", description="The discount amount for the TCB.")
    discount_tcv: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="discountTcv", description="The discount amount for the TCV.")
    gross_tcb: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="grossTcb", description="The gross TCB value before discount charges are applied.")
    gross_tcv: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="grossTcv", description="The gross TCV value before discount charges are applied.")
    intervals: Optional[conlist(OrderRampIntervalMetrics)] = Field(None, description="The ramp metrics for each ramp intervals in its timeline.")
    name: Optional[StrictStr] = Field(None, description="The name of the ramp.")
    net_tcb: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="netTcb", description="The net TCB value after discount charges are applied.")
    net_tcv: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="netTcv", description="The net TCV value after discount charges are applied.")
    number: Optional[StrictStr] = Field(None, description="The number of the ramp. It is automaticcally generated by the billing system.")
    __properties = ["description", "discountTcb", "discountTcv", "grossTcb", "grossTcv", "intervals", "name", "netTcb", "netTcv", "number"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> OrderRampMetrics:
        """Create an instance of OrderRampMetrics from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in intervals (list)
        _items = []
        if self.intervals:
            for _item in self.intervals:
                if _item:
                    _items.append(_item.to_dict())
            _dict['intervals'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> OrderRampMetrics:
        """Create an instance of OrderRampMetrics from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return OrderRampMetrics.parse_obj(obj)

        _obj = OrderRampMetrics.parse_obj({
            "description": obj.get("description"),
            "discount_tcb": obj.get("discountTcb"),
            "discount_tcv": obj.get("discountTcv"),
            "gross_tcb": obj.get("grossTcb"),
            "gross_tcv": obj.get("grossTcv"),
            "intervals": [OrderRampIntervalMetrics.from_dict(_item) for _item in obj.get("intervals")] if obj.get("intervals") is not None else None,
            "name": obj.get("name"),
            "net_tcb": obj.get("netTcb"),
            "net_tcv": obj.get("netTcv"),
            "number": obj.get("number")
        })
        return _obj


