# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from typing import Optional
from pydantic import BaseModel, Field, StrictStr

class OrderSchedulingOptions(BaseModel):
    """
    Information of scheduled order.  **Note**: The Scheduled Orders feature is in the Early Adopter phase. We are actively soliciting feedback from a small set of early adopters before releasing it as generally available. If you want to join this early adopter program, submit a request at <a href=\"https://support.zuora.com/hc/en-us\" target=\"_blank\">Zuora Global Support</a>.   # noqa: E501
    """
    scheduled_date: Optional[date] = Field(None, alias="scheduledDate", description="The date for the order scheduled. ")
    scheduled_date_policy: Optional[StrictStr] = Field(None, alias="scheduledDatePolicy")
    __properties = ["scheduledDate", "scheduledDatePolicy"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> OrderSchedulingOptions:
        """Create an instance of OrderSchedulingOptions from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> OrderSchedulingOptions:
        """Create an instance of OrderSchedulingOptions from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return OrderSchedulingOptions.parse_obj(obj)

        _obj = OrderSchedulingOptions.parse_obj({
            "scheduled_date": obj.get("scheduledDate"),
            "scheduled_date_policy": obj.get("scheduledDatePolicy")
        })
        return _obj


