# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictBool, StrictStr

class OrganizationLabel(BaseModel):
    """
    OrganizationLabel
    """
    organization_id: Optional[StrictStr] = Field(None, alias="organizationId", description="Organization ID ")
    organization_name: Optional[StrictStr] = Field(None, alias="organizationName", description="Organization Name ")
    cascading_down: Optional[StrictBool] = Field(None, alias="cascadingDown", description="Cascading down ")
    excluded: Optional[StrictBool] = Field(None, description="Excluded ")
    __properties = ["organizationId", "organizationName", "cascadingDown", "excluded"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> OrganizationLabel:
        """Create an instance of OrganizationLabel from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> OrganizationLabel:
        """Create an instance of OrganizationLabel from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return OrganizationLabel.parse_obj(obj)

        _obj = OrganizationLabel.parse_obj({
            "organization_id": obj.get("organizationId"),
            "organization_name": obj.get("organizationName"),
            "cascading_down": obj.get("cascadingDown"),
            "excluded": obj.get("excluded")
        })
        return _obj


