# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional, Union
from pydantic import BaseModel, Field, StrictFloat, StrictInt, StrictStr

class PaymentData(BaseModel):
    """
    PaymentData
    """
    auth_transaction_id: Optional[StrictStr] = Field(None, alias="authTransactionId", description="The authorization transaction ID from the payment gateway. ")
    authorized_amount: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="authorizedAmount", description="The amount that is authorized before this API call. Only used for the Delay Capture function. ")
    authorized_currency: Optional[StrictStr] = Field(None, alias="authorizedCurrency", description="The authorization of currency code that occurs before this API call. We will verify whether it is same as the account's currency.")
    __properties = ["authTransactionId", "authorizedAmount", "authorizedCurrency"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> PaymentData:
        """Create an instance of PaymentData from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> PaymentData:
        """Create an instance of PaymentData from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return PaymentData.parse_obj(obj)

        _obj = PaymentData.parse_obj({
            "auth_transaction_id": obj.get("authTransactionId"),
            "authorized_amount": obj.get("authorizedAmount"),
            "authorized_currency": obj.get("authorizedCurrency")
        })
        return _obj


