# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictBool, StrictStr

class PaymentGatwayResponse(BaseModel):
    """
    PaymentGatwayResponse
    """
    id: Optional[StrictStr] = Field(None, description="The ID of the payment gateway.")
    is_active: Optional[StrictBool] = Field(None, alias="isActive", description="Specifies if this payment gateway is in active status.")
    is_default: Optional[StrictBool] = Field(None, alias="isDefault", description="Specifies if this is the default payment gateway to process payments for your customer accounts.")
    name: Optional[StrictStr] = Field(None, description="The name of the payment gateway.")
    number: Optional[StrictStr] = Field(None, description="The number of the payment gateway.")
    type: Optional[StrictStr] = Field(None, description="The type of the payment gateway")
    __properties = ["id", "isActive", "isDefault", "name", "number", "type"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> PaymentGatwayResponse:
        """Create an instance of PaymentGatwayResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> PaymentGatwayResponse:
        """Create an instance of PaymentGatwayResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return PaymentGatwayResponse.parse_obj(obj)

        _obj = PaymentGatwayResponse.parse_obj({
            "id": obj.get("id"),
            "is_active": obj.get("isActive"),
            "is_default": obj.get("isDefault"),
            "name": obj.get("name"),
            "number": obj.get("number"),
            "type": obj.get("type")
        })
        return _obj


