# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import json
import pprint
import re  # noqa: F401
from aenum import Enum, no_arg





class PaymentMethodACHBankAccountType(str, Enum):
    """
    The type of bank account associated with the ACH payment. This field is only required if the `type` field is set to `ACH`.  When creating an ACH payment method on Adyen, this field is required by Zuora but it is not required by Adyen. To create the ACH payment method successfully, specify a real value for this field if you can. If it is not possible to get the real value for it, specify any of the allowed values as a dummy value, `Checking` preferably. 
    """

    """
    allowed enum values
    """
    BUSINESSCHECKING = 'BusinessChecking'
    BUSINESSSAVING = 'BusinessSaving'
    CHECKING = 'Checking'
    SAVING = 'Saving'

    @classmethod
    def from_json(cls, json_str: str) -> PaymentMethodACHBankAccountType:
        """Create an instance of PaymentMethodACHBankAccountType from a JSON string"""
        return PaymentMethodACHBankAccountType(json.loads(json_str))


