# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, constr

class PaymentMethodRequestMandateInfo(BaseModel):
    """
    The mandate information for the Credit Card, Credit Card Reference Transaction, ACH, or Bank Transfer payment method.   # noqa: E501
    """
    mandate_id: Optional[constr(strict=True, max_length=36)] = Field(None, alias="mandateId", description="The mandate ID.  When creating an ACH payment method, if you need to pass in tokenized information, use the `mandateId` instead of `tokenId` field. ")
    mandate_reason: Optional[constr(strict=True, max_length=64)] = Field(None, alias="mandateReason", description="The reason of the mandate from the gateway side. ")
    mandate_status: Optional[constr(strict=True, max_length=64)] = Field(None, alias="mandateStatus", description="The status of the mandate from the gateway side. ")
    __properties = ["mandateId", "mandateReason", "mandateStatus"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> PaymentMethodRequestMandateInfo:
        """Create an instance of PaymentMethodRequestMandateInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> PaymentMethodRequestMandateInfo:
        """Create an instance of PaymentMethodRequestMandateInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return PaymentMethodRequestMandateInfo.parse_obj(obj)

        _obj = PaymentMethodRequestMandateInfo.parse_obj({
            "mandate_id": obj.get("mandateId"),
            "mandate_reason": obj.get("mandateReason"),
            "mandate_status": obj.get("mandateStatus")
        })
        return _obj


