# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictStr

class PaymentMethodResponsePayPal(BaseModel):
    """
    PaymentMethodResponsePayPal
    """
    baid: Optional[StrictStr] = Field(None, alias="BAID", description="ID of a PayPal billing agreement. For example, I-1TJ3GAGG82Y9. ")
    email: Optional[StrictStr] = Field(None, description="Email address associated with the PayPal payment method.  ")
    preapproval_key: Optional[StrictStr] = Field(None, alias="preapprovalKey", description="The PayPal preapproval key. ")
    __properties = ["BAID", "email", "preapprovalKey"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> PaymentMethodResponsePayPal:
        """Create an instance of PaymentMethodResponsePayPal from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> PaymentMethodResponsePayPal:
        """Create an instance of PaymentMethodResponsePayPal from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return PaymentMethodResponsePayPal.parse_obj(obj)

        _obj = PaymentMethodResponsePayPal.parse_obj({
            "baid": obj.get("BAID"),
            "email": obj.get("email"),
            "preapproval_key": obj.get("preapprovalKey")
        })
        return _obj


