# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date, datetime
from typing import Optional
from pydantic import BaseModel, Field, StrictBool, StrictInt, StrictStr

class PaymentMethodSnapshotResponse(BaseModel):
    """
    PaymentMethodSnapshotResponse
    """
    account_id: Optional[StrictStr] = Field(None, alias="AccountId", description="The ID of the customer account associated with this payment method.")
    ach_aba_code: Optional[StrictStr] = Field(None, alias="AchAbaCode", description="The nine-digit routing number or ABA number used by banks. Applicable to ACH payment methods.")
    ach_account_name: Optional[StrictStr] = Field(None, alias="AchAccountName", description="The name of the account holder, which can be either a person or a company. Applicable to ACH payment methods.")
    ach_account_number_mask: Optional[StrictStr] = Field(None, alias="AchAccountNumberMask", description="This is a masked displayable version of the ACH account number, used for security purposes. For example: `XXXXXXXXX54321`.")
    ach_account_type: Optional[StrictStr] = Field(None, alias="AchAccountType")
    ach_bank_name: Optional[StrictStr] = Field(None, alias="AchBankName", description="The name of the bank where the ACH payment account is held.")
    bank_branch_code: Optional[StrictStr] = Field(None, alias="BankBranchCode", description="The branch code of the bank used for direct debit.")
    bank_check_digit: Optional[StrictStr] = Field(None, alias="BankCheckDigit", description="The check digit in the international bank account number, which confirms the validity of the account. Applicable to direct debit payment methods.")
    bank_city: Optional[StrictStr] = Field(None, alias="BankCity", description="The city of the direct debit bank.")
    bank_code: Optional[StrictStr] = Field(None, alias="BankCode", description="The sort code or number that identifies the bank. This is also known as the sort code.")
    bank_identification_number: Optional[StrictStr] = Field(None, alias="BankIdentificationNumber", description="The first six or eight digits of the payment method's number, such as the credit card number or account number. Banks use this number to identify a payment method.")
    bank_name: Optional[StrictStr] = Field(None, alias="BankName", description="The name of the direct debit bank.")
    bank_postal_code: Optional[StrictStr] = Field(None, alias="BankPostalCode", description="The zip code or postal code of the direct debit bank.")
    bank_street_name: Optional[StrictStr] = Field(None, alias="BankStreetName", description="The name of the street of the direct debit bank.")
    bank_street_number: Optional[StrictStr] = Field(None, alias="BankStreetNumber", description="The number of the direct debit bank.")
    bank_transfer_account_name: Optional[StrictStr] = Field(None, alias="BankTransferAccountName", description="The name on the direct debit bank account.")
    bank_transfer_account_number_mask: Optional[StrictStr] = Field(None, alias="BankTransferAccountNumberMask", description="This is a masked displayable version of the bank account number, used for security purposes. For example: `XXXXXXXXX54321`.")
    bank_transfer_account_type: Optional[StrictStr] = Field(None, alias="BankTransferAccountType", description="The type of the customer's bank account. Applicable to direct debit payment methods.")
    bank_transfer_type: Optional[StrictStr] = Field(None, alias="BankTransferType")
    business_identification_code: Optional[StrictStr] = Field(None, alias="BusinessIdentificationCode", description="The business identification code for Swiss direct payment methods that use the Global Collect payment gateway. Only applicable to direct debit payments in Switzerland with Global Collect.")
    city: Optional[StrictStr] = Field(None, alias="City", description="The city of the customer's address. Applicable to debit payment methods.")
    company_name: Optional[StrictStr] = Field(None, alias="CompanyName", description="The name of the company. ")
    country: Optional[StrictStr] = Field(None, alias="Country", description="The two-letter country code of the customer's address. Applicable to direct debit payment methods.")
    credit_card_address1: Optional[StrictStr] = Field(None, alias="CreditCardAddress1", description="The first line of the card holder's address, which is often a street address or business name. Applicable to credit card and direct debit payment methods.")
    credit_card_address2: Optional[StrictStr] = Field(None, alias="CreditCardAddress2", description="The second line of the card holder's address. Applicable to credit card and direct debit payment methods.")
    credit_card_city: Optional[StrictStr] = Field(None, alias="CreditCardCity", description="The city of the card holder's address. Applicable to credit card and direct debit payment methods.")
    credit_card_country: Optional[StrictStr] = Field(None, alias="CreditCardCountry", description="The country of the card holder's address.")
    credit_card_expiration_month: Optional[StrictInt] = Field(None, alias="CreditCardExpirationMonth", description="The expiration month of the credit card or debit card. Applicable to credit card and direct debit payment methods.")
    credit_card_expiration_year: Optional[StrictInt] = Field(None, alias="CreditCardExpirationYear", description="The expiration month of the credit card or debit card. Applicable to credit card and direct debit payment methods.")
    credit_card_holder_name: Optional[StrictStr] = Field(None, alias="CreditCardHolderName", description="The full name of the card holder. Applicable to credit card and direct debit payment methods.")
    credit_card_mask_number: Optional[StrictStr] = Field(None, alias="CreditCardMaskNumber", description="A masked version of the credit or debit card number.")
    credit_card_postal_code: Optional[StrictStr] = Field(None, alias="CreditCardPostalCode", description="The billing address's zip code.")
    credit_card_state: Optional[StrictStr] = Field(None, alias="CreditCardState", description="The billing address's state. Applicable if `CreditCardCountry` is either Canada or the US.")
    credit_card_type: Optional[StrictStr] = Field(None, alias="CreditCardType")
    device_session_id: Optional[StrictStr] = Field(None, alias="DeviceSessionId", description="The session ID of the user when the `PaymentMethod` was created or updated.")
    email: Optional[StrictStr] = Field(None, alias="Email", description="An email address for the payment method in addition to the bill to contact email address.")
    existing_mandate: Optional[StrictStr] = Field(None, alias="ExistingMandate")
    first_name: Optional[StrictStr] = Field(None, alias="FirstName", description="The customer's first name. Only applicable to direct debit payment methods.")
    iban: Optional[StrictStr] = Field(None, alias="IBAN", description="The International Bank Account Number. Only applicable to direct debit payment methods.")
    ip_address: Optional[StrictStr] = Field(None, alias="IPAddress", description="The IP address of the user when the payment method was created or updated.")
    id: Optional[StrictStr] = Field(None, alias="Id", description="Object identifier.")
    identity_number: Optional[StrictStr] = Field(None, alias="IdentityNumber", description="The unique identity number of the customer account.  ")
    is_company: Optional[StrictBool] = Field(None, alias="IsCompany", description="Whether the customer account is a company. ")
    last_failed_sale_transaction_date: Optional[datetime] = Field(None, alias="LastFailedSaleTransactionDate", description="The date of the last failed attempt to collect payment with this payment method.")
    last_name: Optional[StrictStr] = Field(None, alias="LastName", description="The customer's last name. Only applicable to direct debit payment methods.")
    last_transaction_date_time: Optional[datetime] = Field(None, alias="LastTransactionDateTime", description="The date of the most recent transaction.")
    last_transaction_status: Optional[StrictStr] = Field(None, alias="LastTransactionStatus", description="The status of the most recent transaction.")
    mandate_creation_date: Optional[date] = Field(None, alias="MandateCreationDate", description="The date when the mandate was created, in `yyyy-mm-dd` format. A mandate is a signed authorization for UK and NL customers. Only applicable to direct debit payment methods.")
    mandate_id: Optional[StrictStr] = Field(None, alias="MandateID", description="The ID of the mandate. A mandate is a signed authorization for UK and NL customers. Only applicable to direct debit payment methods.")
    mandate_received: Optional[StrictStr] = Field(None, alias="MandateReceived", description="Indicates if  the mandate was received. A mandate is a signed authorization for UK and NL customers. Only applicable to direct debit payment methods.")
    mandate_update_date: Optional[date] = Field(None, alias="MandateUpdateDate", description="The date when the mandate was last updated, in `yyyy-mm-dd` format. A mandate is a signed authorization for UK and NL customers. Only applicable to direct debit payment methods.")
    max_consecutive_payment_failures: Optional[StrictInt] = Field(None, alias="MaxConsecutivePaymentFailures", description="The number of allowable consecutive failures Zuora attempts with the payment method before stopping.")
    name: Optional[StrictStr] = Field(None, alias="Name", description="The name of the payment method.")
    num_consecutive_failures: Optional[StrictInt] = Field(None, alias="NumConsecutiveFailures", description="The number of consecutive failed payment for the payment method.")
    payment_method_id: Optional[StrictStr] = Field(None, alias="PaymentMethodId", description="Object identifier of the payment method.")
    payment_method_status: Optional[StrictStr] = Field(None, alias="PaymentMethodStatus")
    payment_retry_window: Optional[StrictInt] = Field(None, alias="PaymentRetryWindow", description="The retry interval setting, which prevents making a payment attempt if the last failed attempt was within the last specified number of hours.")
    paypal_baid: Optional[StrictStr] = Field(None, alias="PaypalBaid", description="The PayPal billing agreement ID, which is a contract between two PayPal accounts.")
    paypal_email: Optional[StrictStr] = Field(None, alias="PaypalEmail", description="The email address associated with the account holder's PayPal account or of the PayPal account of the person paying for the service.")
    paypal_preapproval_key: Optional[StrictStr] = Field(None, alias="PaypalPreapprovalKey", description="PayPal's Adaptive Payments API key.")
    paypal_type: Optional[StrictStr] = Field(None, alias="PaypalType")
    phone: Optional[StrictStr] = Field(None, alias="Phone", description="The phone number that the account holder registered with the bank. This field is used for credit card validation when passing to a gateway.")
    postal_code: Optional[StrictStr] = Field(None, alias="PostalCode", description="The zip code of the customer's address. Only applicable to direct debit payment methods.")
    second_token_id: Optional[StrictStr] = Field(None, alias="SecondTokenId", description="A gateway unique identifier that replaces sensitive payment method data. Applicable to CC Reference Transaction payment methods.")
    state: Optional[StrictStr] = Field(None, alias="State", description="The state of the customer's address. Only applicable to direct debit payment methods.")
    street_name: Optional[StrictStr] = Field(None, alias="StreetName", description="The street name of the customer's address. Only applicable to direct debit payment methods.")
    street_number: Optional[StrictStr] = Field(None, alias="StreetNumber", description="The street number of the customer's address. Only applicable to direct debit payment methods.")
    token_id: Optional[StrictStr] = Field(None, alias="TokenId", description="A gateway unique identifier that replaces sensitive payment method data or represents a gateway's unique customer profile. Applicable to CC Reference Transaction payment methods.")
    total_number_of_error_payments: Optional[StrictInt] = Field(None, alias="TotalNumberOfErrorPayments", description="The number of error payments that used this payment method.")
    total_number_of_processed_payments: Optional[StrictInt] = Field(None, alias="TotalNumberOfProcessedPayments", description="The number of successful payments that used this payment method.")
    type: Optional[StrictStr] = Field(None, alias="Type")
    use_default_retry_rule: Optional[StrictBool] = Field(None, alias="UseDefaultRetryRule", description="Determines whether to use the default retry rules configured in the Zuora Payments settings.")
    __properties = ["AccountId", "AchAbaCode", "AchAccountName", "AchAccountNumberMask", "AchAccountType", "AchBankName", "BankBranchCode", "BankCheckDigit", "BankCity", "BankCode", "BankIdentificationNumber", "BankName", "BankPostalCode", "BankStreetName", "BankStreetNumber", "BankTransferAccountName", "BankTransferAccountNumberMask", "BankTransferAccountType", "BankTransferType", "BusinessIdentificationCode", "City", "CompanyName", "Country", "CreditCardAddress1", "CreditCardAddress2", "CreditCardCity", "CreditCardCountry", "CreditCardExpirationMonth", "CreditCardExpirationYear", "CreditCardHolderName", "CreditCardMaskNumber", "CreditCardPostalCode", "CreditCardState", "CreditCardType", "DeviceSessionId", "Email", "ExistingMandate", "FirstName", "IBAN", "IPAddress", "Id", "IdentityNumber", "IsCompany", "LastFailedSaleTransactionDate", "LastName", "LastTransactionDateTime", "LastTransactionStatus", "MandateCreationDate", "MandateID", "MandateReceived", "MandateUpdateDate", "MaxConsecutivePaymentFailures", "Name", "NumConsecutiveFailures", "PaymentMethodId", "PaymentMethodStatus", "PaymentRetryWindow", "PaypalBaid", "PaypalEmail", "PaypalPreapprovalKey", "PaypalType", "Phone", "PostalCode", "SecondTokenId", "State", "StreetName", "StreetNumber", "TokenId", "TotalNumberOfErrorPayments", "TotalNumberOfProcessedPayments", "Type", "UseDefaultRetryRule"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> PaymentMethodSnapshotResponse:
        """Create an instance of PaymentMethodSnapshotResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> PaymentMethodSnapshotResponse:
        """Create an instance of PaymentMethodSnapshotResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return PaymentMethodSnapshotResponse.parse_obj(obj)

        _obj = PaymentMethodSnapshotResponse.parse_obj({
            "account_id": obj.get("AccountId"),
            "ach_aba_code": obj.get("AchAbaCode"),
            "ach_account_name": obj.get("AchAccountName"),
            "ach_account_number_mask": obj.get("AchAccountNumberMask"),
            "ach_account_type": obj.get("AchAccountType"),
            "ach_bank_name": obj.get("AchBankName"),
            "bank_branch_code": obj.get("BankBranchCode"),
            "bank_check_digit": obj.get("BankCheckDigit"),
            "bank_city": obj.get("BankCity"),
            "bank_code": obj.get("BankCode"),
            "bank_identification_number": obj.get("BankIdentificationNumber"),
            "bank_name": obj.get("BankName"),
            "bank_postal_code": obj.get("BankPostalCode"),
            "bank_street_name": obj.get("BankStreetName"),
            "bank_street_number": obj.get("BankStreetNumber"),
            "bank_transfer_account_name": obj.get("BankTransferAccountName"),
            "bank_transfer_account_number_mask": obj.get("BankTransferAccountNumberMask"),
            "bank_transfer_account_type": obj.get("BankTransferAccountType"),
            "bank_transfer_type": obj.get("BankTransferType"),
            "business_identification_code": obj.get("BusinessIdentificationCode"),
            "city": obj.get("City"),
            "company_name": obj.get("CompanyName"),
            "country": obj.get("Country"),
            "credit_card_address1": obj.get("CreditCardAddress1"),
            "credit_card_address2": obj.get("CreditCardAddress2"),
            "credit_card_city": obj.get("CreditCardCity"),
            "credit_card_country": obj.get("CreditCardCountry"),
            "credit_card_expiration_month": obj.get("CreditCardExpirationMonth"),
            "credit_card_expiration_year": obj.get("CreditCardExpirationYear"),
            "credit_card_holder_name": obj.get("CreditCardHolderName"),
            "credit_card_mask_number": obj.get("CreditCardMaskNumber"),
            "credit_card_postal_code": obj.get("CreditCardPostalCode"),
            "credit_card_state": obj.get("CreditCardState"),
            "credit_card_type": obj.get("CreditCardType"),
            "device_session_id": obj.get("DeviceSessionId"),
            "email": obj.get("Email"),
            "existing_mandate": obj.get("ExistingMandate"),
            "first_name": obj.get("FirstName"),
            "iban": obj.get("IBAN"),
            "ip_address": obj.get("IPAddress"),
            "id": obj.get("Id"),
            "identity_number": obj.get("IdentityNumber"),
            "is_company": obj.get("IsCompany"),
            "last_failed_sale_transaction_date": obj.get("LastFailedSaleTransactionDate"),
            "last_name": obj.get("LastName"),
            "last_transaction_date_time": obj.get("LastTransactionDateTime"),
            "last_transaction_status": obj.get("LastTransactionStatus"),
            "mandate_creation_date": obj.get("MandateCreationDate"),
            "mandate_id": obj.get("MandateID"),
            "mandate_received": obj.get("MandateReceived"),
            "mandate_update_date": obj.get("MandateUpdateDate"),
            "max_consecutive_payment_failures": obj.get("MaxConsecutivePaymentFailures"),
            "name": obj.get("Name"),
            "num_consecutive_failures": obj.get("NumConsecutiveFailures"),
            "payment_method_id": obj.get("PaymentMethodId"),
            "payment_method_status": obj.get("PaymentMethodStatus"),
            "payment_retry_window": obj.get("PaymentRetryWindow"),
            "paypal_baid": obj.get("PaypalBaid"),
            "paypal_email": obj.get("PaypalEmail"),
            "paypal_preapproval_key": obj.get("PaypalPreapprovalKey"),
            "paypal_type": obj.get("PaypalType"),
            "phone": obj.get("Phone"),
            "postal_code": obj.get("PostalCode"),
            "second_token_id": obj.get("SecondTokenId"),
            "state": obj.get("State"),
            "street_name": obj.get("StreetName"),
            "street_number": obj.get("StreetNumber"),
            "token_id": obj.get("TokenId"),
            "total_number_of_error_payments": obj.get("TotalNumberOfErrorPayments"),
            "total_number_of_processed_payments": obj.get("TotalNumberOfProcessedPayments"),
            "type": obj.get("Type"),
            "use_default_retry_rule": obj.get("UseDefaultRetryRule")
        })
        return _obj


