# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr

class PaymentVolumeSummaryRecord(BaseModel):
    """
    A volume summary record.   # noqa: E501
    """
    error: Optional[StrictInt] = Field(None, description="The count of failed payments of above `paymentGatewayType` and `paymentMethodType`. ")
    payment_gateway_type: Optional[StrictStr] = Field(None, alias="paymentGatewayType", description="The payment gateway type. ")
    payment_method_type: Optional[StrictStr] = Field(None, alias="paymentMethodType", description="The payment method type. ")
    success: Optional[StrictInt] = Field(None, description="The count of successful payments of above `paymentGatewayType` and `paymentMethodType`. ")
    total: Optional[StrictInt] = Field(None, description="The count of total payments of above `paymentGatewayType` and `paymentMethodType`.      ")
    __properties = ["error", "paymentGatewayType", "paymentMethodType", "success", "total"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> PaymentVolumeSummaryRecord:
        """Create an instance of PaymentVolumeSummaryRecord from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> PaymentVolumeSummaryRecord:
        """Create an instance of PaymentVolumeSummaryRecord from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return PaymentVolumeSummaryRecord.parse_obj(obj)

        _obj = PaymentVolumeSummaryRecord.parse_obj({
            "error": obj.get("error"),
            "payment_gateway_type": obj.get("paymentGatewayType"),
            "payment_method_type": obj.get("paymentMethodType"),
            "success": obj.get("success"),
            "total": obj.get("total")
        })
        return _obj


