# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date

from pydantic import BaseModel, Field

class PostBillRunRequest(BaseModel):
    """
    PostBillRunRequest
    """
    invoice_date: date = Field(..., alias="invoiceDate", description="The date that appears on the invoice being created, in `yyyy-mm-dd` format.   The value cannot fall in a closed accounting period. ")
    __properties = ["invoiceDate"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> PostBillRunRequest:
        """Create an instance of PostBillRunRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> PostBillRunRequest:
        """Create an instance of PostBillRunRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return PostBillRunRequest.parse_obj(obj)

        _obj = PostBillRunRequest.parse_obj({
            "invoice_date": obj.get("invoiceDate")
        })
        return _obj


