# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictBool, conlist
from com.zuora.models.post_create_or_update_email_template_request_format import PostCreateOrUpdateEmailTemplateRequestFormat

class PostCreateOrUpdateEmailTemplateRequest(BaseModel):
    """
    PostCreateOrUpdateEmailTemplateRequest
    """
    allow_partial_success: Optional[StrictBool] = Field(None, alias="allowPartialSuccess", description="When set to `false`, the call will fail if one or multiple instances fail to import, and a `200` response is returned if all email templates have been successfully updated. When set to `true`, a success (`200`) response is returned if one or more instances have imported successfully. All failed instances are also returned in the response. ")
    email_templates: Optional[conlist(PostCreateOrUpdateEmailTemplateRequestFormat)] = Field(None, alias="emailTemplates", description="A container for email templates. ")
    __properties = ["allowPartialSuccess", "emailTemplates"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> PostCreateOrUpdateEmailTemplateRequest:
        """Create an instance of PostCreateOrUpdateEmailTemplateRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in email_templates (list)
        _items = []
        if self.email_templates:
            for _item in self.email_templates:
                if _item:
                    _items.append(_item.to_dict())
            _dict['emailTemplates'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> PostCreateOrUpdateEmailTemplateRequest:
        """Create an instance of PostCreateOrUpdateEmailTemplateRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return PostCreateOrUpdateEmailTemplateRequest.parse_obj(obj)

        _obj = PostCreateOrUpdateEmailTemplateRequest.parse_obj({
            "allow_partial_success": obj.get("allowPartialSuccess"),
            "email_templates": [PostCreateOrUpdateEmailTemplateRequestFormat.from_dict(_item) for _item in obj.get("emailTemplates")] if obj.get("emailTemplates") is not None else None
        })
        return _obj


