# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict, List, Optional
from pydantic import BaseModel, Field, conlist
from com.zuora.models.workflow_error import WorkflowError

class PostRunWorkflow406Response(BaseModel):
    """
    PostRunWorkflow406Response
    """
    errors: Optional[conlist(WorkflowError)] = Field(None, description="The list of errors returned from the workflow")
    parameters: Optional[Dict[str, Any]] = Field(None, description="The request body that was originally provided to the run API.")
    __properties = ["errors", "parameters"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> PostRunWorkflow406Response:
        """Create an instance of PostRunWorkflow406Response from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in errors (list)
        _items = []
        if self.errors:
            for _item in self.errors:
                if _item:
                    _items.append(_item.to_dict())
            _dict['errors'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> PostRunWorkflow406Response:
        """Create an instance of PostRunWorkflow406Response from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return PostRunWorkflow406Response.parse_obj(obj)

        _obj = PostRunWorkflow406Response.parse_obj({
            "errors": [WorkflowError.from_dict(_item) for _item in obj.get("errors")] if obj.get("errors") is not None else None,
            "parameters": obj.get("parameters")
        })
        return _obj


