# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, conlist
from com.zuora.models.linkage import Linkage
from com.zuora.models.task import Task
from com.zuora.models.workflow import Workflow

class PostWorkflowDefinitionImportRequest(BaseModel):
    """
    PostWorkflowDefinitionImportRequest
    """
    linkages: Optional[conlist(Linkage)] = None
    tasks: Optional[conlist(Task)] = None
    workflow: Optional[Workflow] = None
    __properties = ["linkages", "tasks", "workflow"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> PostWorkflowDefinitionImportRequest:
        """Create an instance of PostWorkflowDefinitionImportRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in linkages (list)
        _items = []
        if self.linkages:
            for _item in self.linkages:
                if _item:
                    _items.append(_item.to_dict())
            _dict['linkages'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in tasks (list)
        _items = []
        if self.tasks:
            for _item in self.tasks:
                if _item:
                    _items.append(_item.to_dict())
            _dict['tasks'] = _items
        # override the default output from pydantic by calling `to_dict()` of workflow
        if self.workflow:
            _dict['workflow'] = self.workflow.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> PostWorkflowDefinitionImportRequest:
        """Create an instance of PostWorkflowDefinitionImportRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return PostWorkflowDefinitionImportRequest.parse_obj(obj)

        _obj = PostWorkflowDefinitionImportRequest.parse_obj({
            "linkages": [Linkage.from_dict(_item) for _item in obj.get("linkages")] if obj.get("linkages") is not None else None,
            "tasks": [Task.from_dict(_item) for _item in obj.get("tasks")] if obj.get("tasks") is not None else None,
            "workflow": Workflow.from_dict(obj.get("workflow")) if obj.get("workflow") is not None else None
        })
        return _obj


