# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import json
import pprint
import re  # noqa: F401
from aenum import Enum, no_arg





class PrepaidOperationType(str, Enum):
    """
    **Note**: This field is only available if you have the [Prepaid with Drawdown](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/J_Billing_Operations/Prepaid_with_Drawdown) feature enabled.  To use this field, you must set the `X-Zuora-WSDL-Version` request header to 114 or higher. Otherwise, an error occurs.   The type of this charge. It is either a prepayment (topup) charge or a drawdown charge.  
    """

    """
    allowed enum values
    """
    TOPUP = 'topup'
    DRAWDOWN = 'drawdown'

    @classmethod
    def from_json(cls, json_str: str) -> PrepaidOperationType:
        """Create an instance of PrepaidOperationType from a JSON string"""
        return PrepaidOperationType(json.loads(json_str))


