# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from typing import List, Optional, Union
from pydantic import BaseModel, Field, StrictBool, StrictFloat, StrictInt, StrictStr, conlist
from com.zuora.models.preview_existing_subscription_invoice_item_result import PreviewExistingSubscriptionInvoiceItemResult

class PreviewExistingSubscriptionResultInvoices(BaseModel):
    """
    PreviewExistingSubscriptionResultInvoices
    """
    invoice_number: Optional[StrictStr] = Field(None, alias="invoiceNumber", description="The invoice number.")
    amount: Optional[Union[StrictFloat, StrictInt]] = Field(None, description="Invoice amount.")
    amount_without_tax: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="amountWithoutTax", description="Invoice amount minus tax.")
    tax_amount: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="taxAmount", description="The tax amount of the invoice.")
    target_date: Optional[date] = Field(None, alias="targetDate", description="Date through which to calculate charges if an invoice is generated, as yyyy-mm-dd.")
    invoice_items: Optional[conlist(PreviewExistingSubscriptionInvoiceItemResult)] = Field(None, alias="invoiceItems", description="Container for invoice items.")
    status: Optional[StrictStr] = Field(None, description="The status of the invoice.")
    is_from_existing_invoice: Optional[StrictBool] = Field(None, alias="isFromExistingInvoice", description="Indicates whether the invoice information is from an existing invoice.")
    __properties = ["invoiceNumber", "amount", "amountWithoutTax", "taxAmount", "targetDate", "invoiceItems", "status", "isFromExistingInvoice"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> PreviewExistingSubscriptionResultInvoices:
        """Create an instance of PreviewExistingSubscriptionResultInvoices from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in invoice_items (list)
        _items = []
        if self.invoice_items:
            for _item in self.invoice_items:
                if _item:
                    _items.append(_item.to_dict())
            _dict['invoiceItems'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> PreviewExistingSubscriptionResultInvoices:
        """Create an instance of PreviewExistingSubscriptionResultInvoices from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return PreviewExistingSubscriptionResultInvoices.parse_obj(obj)

        _obj = PreviewExistingSubscriptionResultInvoices.parse_obj({
            "invoice_number": obj.get("invoiceNumber"),
            "amount": obj.get("amount"),
            "amount_without_tax": obj.get("amountWithoutTax"),
            "tax_amount": obj.get("taxAmount"),
            "target_date": obj.get("targetDate"),
            "invoice_items": [PreviewExistingSubscriptionInvoiceItemResult.from_dict(_item) for _item in obj.get("invoiceItems")] if obj.get("invoiceItems") is not None else None,
            "status": obj.get("status"),
            "is_from_existing_invoice": obj.get("isFromExistingInvoice")
        })
        return _obj


