# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from typing import List, Optional, Union
from pydantic import BaseModel, Field, StrictFloat, StrictInt, conlist
from com.zuora.models.invoice_item_preview_result import InvoiceItemPreviewResult

class PreviewOrderResultInvoices(BaseModel):
    """
    PreviewOrderResultInvoices
    """
    amount: Optional[Union[StrictFloat, StrictInt]] = None
    amount_without_tax: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="amountWithoutTax")
    invoice_items: Optional[conlist(InvoiceItemPreviewResult)] = Field(None, alias="invoiceItems")
    target_date: Optional[date] = Field(None, alias="targetDate")
    tax_amount: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="taxAmount")
    __properties = ["amount", "amountWithoutTax", "invoiceItems", "targetDate", "taxAmount"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> PreviewOrderResultInvoices:
        """Create an instance of PreviewOrderResultInvoices from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in invoice_items (list)
        _items = []
        if self.invoice_items:
            for _item in self.invoice_items:
                if _item:
                    _items.append(_item.to_dict())
            _dict['invoiceItems'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> PreviewOrderResultInvoices:
        """Create an instance of PreviewOrderResultInvoices from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return PreviewOrderResultInvoices.parse_obj(obj)

        _obj = PreviewOrderResultInvoices.parse_obj({
            "amount": obj.get("amount"),
            "amount_without_tax": obj.get("amountWithoutTax"),
            "invoice_items": [InvoiceItemPreviewResult.from_dict(_item) for _item in obj.get("invoiceItems")] if obj.get("invoiceItems") is not None else None,
            "target_date": obj.get("targetDate"),
            "tax_amount": obj.get("taxAmount")
        })
        return _obj


