# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional, Union
from pydantic import BaseModel, Field, StrictFloat, StrictInt, StrictStr
from com.zuora.models.preview_thru_date_policy import PreviewThruDatePolicy

class PreviewThroughDate(BaseModel):
    """
    The preview through date.   # noqa: E501
    """
    preview_thru_date_policy: Optional[PreviewThruDatePolicy] = Field(None, alias="previewThruDatePolicy")
    next_billing_periods: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="nextBillingPeriods", description="The number of billing periods to preview. Required if `previewThruDatePolicy` is `nextBillingPeriods`. ")
    specific_date: Optional[StrictStr] = Field(None, alias="specificDate", description="The specific date for the preview start date. Required if `previewThruDatePolicy` is `specificDate`. ")
    __properties = ["previewThruDatePolicy", "nextBillingPeriods", "specificDate"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> PreviewThroughDate:
        """Create an instance of PreviewThroughDate from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> PreviewThroughDate:
        """Create an instance of PreviewThroughDate from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return PreviewThroughDate.parse_obj(obj)

        _obj = PreviewThroughDate.parse_obj({
            "preview_thru_date_policy": obj.get("previewThruDatePolicy"),
            "next_billing_periods": obj.get("nextBillingPeriods"),
            "specific_date": obj.get("specificDate")
        })
        return _obj


