# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import Any, Dict, Optional, Union
from pydantic import BaseModel, Field, StrictBool, StrictFloat, StrictInt, StrictStr, constr
from com.zuora.models.apply_discount_to import ApplyDiscountTo
from com.zuora.models.bill_cycle_type import BillCycleType
from com.zuora.models.billing_period_alignment_product_rate_plan_charge_rest import BillingPeriodAlignmentProductRatePlanChargeRest
from com.zuora.models.billing_period_product_rate_plan_charge_rest import BillingPeriodProductRatePlanChargeRest
from com.zuora.models.billing_timing_product_rate_plan_charge_rest import BillingTimingProductRatePlanChargeRest
from com.zuora.models.charge_function import ChargeFunction
from com.zuora.models.charge_model_configuration import ChargeModelConfiguration
from com.zuora.models.charge_model_product_rate_plan_charge_rest import ChargeModelProductRatePlanChargeRest
from com.zuora.models.charge_type import ChargeType
from com.zuora.models.commitment_type import CommitmentType
from com.zuora.models.delivery_schedule_product_rate_plan_charge import DeliveryScheduleProductRatePlanCharge
from com.zuora.models.discount_level import DiscountLevel
from com.zuora.models.end_date_condition_product_rate_plan_charge_rest import EndDateConditionProductRatePlanChargeRest
from com.zuora.models.list_price_base import ListPriceBase
from com.zuora.models.overage_calculation_option import OverageCalculationOption
from com.zuora.models.overage_unused_units_credit_option import OverageUnusedUnitsCreditOption
from com.zuora.models.prepaid_operation_type import PrepaidOperationType
from com.zuora.models.price_change_option import PriceChangeOption
from com.zuora.models.price_increase_option import PriceIncreaseOption
from com.zuora.models.product_rate_plan_charge_object_ns_fields_include_children_ns import ProductRatePlanChargeObjectNSFieldsIncludeChildrenNS
from com.zuora.models.product_rate_plan_charge_object_ns_fields_item_type_ns import ProductRatePlanChargeObjectNSFieldsItemTypeNS
from com.zuora.models.product_rate_plan_charge_object_ns_fields_rev_rec_end_ns import ProductRatePlanChargeObjectNSFieldsRevRecEndNS
from com.zuora.models.product_rate_plan_charge_object_ns_fields_rev_rec_start_ns import ProductRatePlanChargeObjectNSFieldsRevRecStartNS
from com.zuora.models.rating_group import RatingGroup
from com.zuora.models.rev_rec_trigger_condition_product_rate_plan_charge_rest import RevRecTriggerConditionProductRatePlanChargeRest
from com.zuora.models.revenue_recognition_rule_name import RevenueRecognitionRuleName
from com.zuora.models.rollover_apply import RolloverApply
from com.zuora.models.smoothing_model import SmoothingModel
from com.zuora.models.tax_mode import TaxMode
from com.zuora.models.trigger_event_product_rate_plan_charge_rest import TriggerEventProductRatePlanChargeRest
from com.zuora.models.up_to_periods_type_product_rate_plan_charge_rest import UpToPeriodsTypeProductRatePlanChargeRest
from com.zuora.models.usage_record_rating_option import UsageRecordRatingOption
from com.zuora.models.validity_period_type import ValidityPeriodType
from com.zuora.models.weekly_bill_cycle_day import WeeklyBillCycleDay

class ProductRatePlanCharge(BaseModel):
    """
    ProductRatePlanCharge
    """
    class__ns: Optional[constr(strict=True, max_length=255)] = Field(None, alias="Class__NS", description="Class associated with the corresponding item in NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265). ")
    deferred_rev_account__ns: Optional[constr(strict=True, max_length=255)] = Field(None, alias="DeferredRevAccount__NS", description="Deferrred revenue account associated with the corresponding item in NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265). ")
    department__ns: Optional[constr(strict=True, max_length=255)] = Field(None, alias="Department__NS", description="Department associated with the corresponding item in NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265). ")
    include_children__ns: Optional[StrictStr] = Field(None, alias="IncludeChildren__NS")
    integration_id__ns: Optional[constr(strict=True, max_length=255)] = Field(None, alias="IntegrationId__NS", description="ID of the corresponding object in NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265). ")
    integration_status__ns: Optional[constr(strict=True, max_length=255)] = Field(None, alias="IntegrationStatus__NS", description="Status of the product rate plan charge's synchronization with NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265). ")
    item_type__ns: Optional[StrictStr] = Field(None, alias="ItemType__NS")
    location__ns: Optional[constr(strict=True, max_length=255)] = Field(None, alias="Location__NS", description="Location associated with the corresponding item in NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265). ")
    recognized_rev_account__ns: Optional[constr(strict=True, max_length=255)] = Field(None, alias="RecognizedRevAccount__NS", description="Recognized revenue account associated with the corresponding item in NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265). ")
    rev_rec_end__ns: Optional[StrictStr] = Field(None, alias="RevRecEnd__NS")
    rev_rec_start__ns: Optional[StrictStr] = Field(None, alias="RevRecStart__NS")
    rev_rec_template_type__ns: Optional[constr(strict=True, max_length=255)] = Field(None, alias="RevRecTemplateType__NS", description="Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265). ")
    subsidiary__ns: Optional[constr(strict=True, max_length=255)] = Field(None, alias="Subsidiary__NS", description="Subsidiary associated with the corresponding item in NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265). ")
    sync_date__ns: Optional[constr(strict=True, max_length=255)] = Field(None, alias="SyncDate__NS", description="Date when the product rate plan charge was synchronized with NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265). ")
    id: Optional[StrictStr] = Field(None, alias="Id", description="Object identifier.")
    product_rate_plan_id: Optional[constr(strict=True, max_length=32)] = Field(None, alias="ProductRatePlanId", description="The ID of the product rate plan associated with this product rate plan charge. ")
    accounting_code: Optional[constr(strict=True, max_length=100)] = Field(None, alias="AccountingCode", description="The accounting code for the charge. Accounting codes group transactions that contain similar accounting attributes. ")
    apply_discount_to: Optional[ApplyDiscountTo] = Field(None, alias="ApplyDiscountTo")
    bill_cycle_day: Optional[StrictInt] = Field(None, alias="BillCycleDay", description="Sets the bill cycle day (BCD) for the charge. The BCD determines which day of the month customer is billed. The BCD value in the account can override the BCD in this object. StackedDiscount **Character limit**: 2  **Values**: a valid BCD integer, 1 - 31 ")
    bill_cycle_type: Optional[BillCycleType] = Field(None, alias="BillCycleType")
    billing_period: Optional[BillingPeriodProductRatePlanChargeRest] = Field(None, alias="BillingPeriod")
    billing_period_alignment: Optional[BillingPeriodAlignmentProductRatePlanChargeRest] = Field(None, alias="BillingPeriodAlignment")
    billing_timing: Optional[BillingTimingProductRatePlanChargeRest] = Field(None, alias="BillingTiming")
    charge_function: Optional[ChargeFunction] = Field(None, alias="ChargeFunction")
    charge_model: Optional[ChargeModelProductRatePlanChargeRest] = Field(None, alias="ChargeModel")
    charge_model_configuration: Optional[ChargeModelConfiguration] = Field(None, alias="ChargeModelConfiguration")
    charge_type: Optional[ChargeType] = Field(None, alias="ChargeType")
    commitment_type: Optional[CommitmentType] = Field(None, alias="CommitmentType")
    created_by_id: Optional[constr(strict=True, max_length=32)] = Field(None, alias="CreatedById", description="The automatically generated ID of the Zuora user who created the `ProductRatePlanCharge` object. ")
    created_date: Optional[datetime] = Field(None, alias="CreatedDate", description="The date when the `ProductRatePlanCharge` object was created. ")
    default_quantity: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="DefaultQuantity", description="The default quantity of units, such as the number of authors in a hosted wiki service. This field is required if you use a per-unit pricing model.  **Character limit**: 16  **Values**: a valid quantity value.  **Note**: When `ChargeModel` is `Tiered Pricing` or `Volume Pricing`, if this field is not specified, the value will default to `0`. ")
    deferred_revenue_account: Optional[constr(strict=True, max_length=100)] = Field(None, alias="DeferredRevenueAccount", description="The name of the deferred revenue account for this charge.  This feature is in **Limited Availability**. If you wish to have access to the feature, submit a request at [Zuora Global Support](http://support.zuora.com/).  ")
    delivery_schedule: Optional[DeliveryScheduleProductRatePlanCharge] = Field(None, alias="DeliverySchedule")
    description: Optional[constr(strict=True, max_length=500)] = Field(None, alias="Description", description="A description of the charge. ")
    discount_level: Optional[DiscountLevel] = Field(None, alias="DiscountLevel")
    drawdown_rate: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="DrawdownRate", description="**Note**: This field is only available if you have the [Prepaid with Drawdown](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/J_Billing_Operations/Prepaid_with_Drawdown) feature enabled.  The [conversion rate](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/J_Billing_Operations/Prepaid_with_Drawdown/Create_drawdown_charge#UOM_Conversion) between Usage UOM and Drawdown UOM for a [drawdown charge](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/J_Billing_Operations/Prepaid_with_Drawdown/Create_drawdown_charge). Must be a positive number (>0). ")
    drawdown_uom: Optional[StrictStr] = Field(None, alias="DrawdownUom", description="**Note**: This field is only available if you have the [Prepaid with Drawdown](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/J_Billing_Operations/Prepaid_with_Drawdown) feature enabled. Unit of measurement for a [drawdown charge](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/J_Billing_Operations/Prepaid_with_Drawdown/Create_drawdown_charge). ")
    end_date_condition: Optional[EndDateConditionProductRatePlanChargeRest] = Field(None, alias="EndDateCondition")
    exclude_item_billing_from_revenue_accounting: Optional[StrictBool] = Field(None, alias="ExcludeItemBillingFromRevenueAccounting", description="The flag to exclude the related invoice items, invoice item adjustments, credit memo items, and debit memo items from revenue accounting.  **Notes**:    - To use this field, you must set the `X-Zuora-WSDL-Version` request header to `115` or later. Otherwise, an error occurs.   - This field is only available if you have the Billing - Revenue Integration feature enabled.  ")
    exclude_item_booking_from_revenue_accounting: Optional[StrictBool] = Field(None, alias="ExcludeItemBookingFromRevenueAccounting", description="The flag to exclude the related rate plan charges and order line items from revenue accounting.  **Notes**:    - To use this field, you must set the `X-Zuora-WSDL-Version` request header to `115` or later. Otherwise, an error occurs.   - This field is only available if you have the Billing - Revenue Integration feature enabled.  ")
    included_units: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="IncludedUnits", description="Specifies the number of units in the base set of units.  **Character limit**: 16  **Values**: a positive decimal value ")
    is_prepaid: Optional[StrictBool] = Field(None, alias="IsPrepaid", description="**Note**: This field is only available if you have the [Prepaid with Drawdown](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/J_Billing_Operations/Prepaid_with_Drawdown) feature enabled.  Indicates whether this charge is a prepayment (topup) charge or a drawdown charge. Values: `true` or `false`. ")
    is_rollover: Optional[StrictBool] = Field(None, alias="IsRollover", description="**Note**: This field is only available if you have the [Prepaid with Drawdown](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/J_Billing_Operations/Prepaid_with_Drawdown) feature enabled.  To use this field, you must set the `X-Zuora-WSDL-Version` request header to 114 or higher. Otherwise, an error occurs.  The value is either \"True\" or \"False\". It determines whether the rollover fields are needed. ")
    is_stacked_discount: Optional[StrictBool] = Field(None, alias="IsStackedDiscount", description="**Note**: This field is only applicable to the Discount - Percentage charge model. To use this field, you must set the `X-Zuora-WSDL-Version` request header to 130 or higher. Otherwise, an error occurs. This field indicates whether the discount is to be calculated as stacked discount. Possible values are as follows: - `true`: This is a stacked discount, which should be calculated by stacking with other discounts. - `false`: This is not a stacked discount, which should be calculated in sequence with other discounts. For more information, see [Stacked discounts](https://knowledgecenter.zuora.com/Zuora_Billing/Products/Product_Catalog/B_Charge_Models/B_Discount_Charge_Models). ")
    is_unbilled: Optional[StrictBool] = Field(None, alias="IsUnbilled", description="This field is used to dictate how to perform the accounting during revenue recognition. **Note**: This feature is in the **Early Adopter** phase. If you want to use the feature, submit a request at <a href=\"https://support.zuora.com/\" target=\"_blank\">Zuora Global Support</a>, and we will evaluate whether the feature is suitable for your use cases. ")
    revenue_recognition_timing: Optional[constr(strict=True, max_length=200)] = Field(None, alias="RevenueRecognitionTiming", description="This field is used to dictate the type of revenue recognition timing. ")
    revenue_amortization_method: Optional[constr(strict=True, max_length=200)] = Field(None, alias="RevenueAmortizationMethod", description="This field is used to dictate the type of revenue amortization method. ")
    legacy_revenue_reporting: Optional[StrictBool] = Field(None, alias="LegacyRevenueReporting")
    list_price_base: Optional[ListPriceBase] = Field(None, alias="ListPriceBase")
    min_quantity: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="MinQuantity", description="Specifies the minimum number of units for this charge. Use this field and the `MaxQuantity` field to create a range of units allowed in a product rate plan charge.  **Character limit**: 16  **Values**: a positive decimal value ")
    max_quantity: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="MaxQuantity", description="Specifies the maximum number of units for this charge. Use this field and the `MinQuantity` field to create a range of units allowed in a product rate plan charge.  **Character limit**: 16  **Values**: a positive decimal value ")
    name: Optional[constr(strict=True, max_length=100)] = Field(None, alias="Name", description="The name of the product rate plan charge. ")
    number_of_period: Optional[StrictInt] = Field(None, alias="NumberOfPeriod", description="Specifies the number of periods to use when calculating charges in an overage smoothing charge model. The valid value is a positive whole number. ")
    overage_calculation_option: Optional[OverageCalculationOption] = Field(None, alias="OverageCalculationOption")
    overage_unused_units_credit_option: Optional[OverageUnusedUnitsCreditOption] = Field(None, alias="OverageUnusedUnitsCreditOption")
    prepaid_operation_type: Optional[PrepaidOperationType] = Field(None, alias="PrepaidOperationType")
    prepaid_quantity: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="prepaidQuantity", description="**Note**: This field is only available if you have the [Prepaid with Drawdown](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/J_Billing_Operations/Prepaid_with_Drawdown) feature enabled. The number of units included in a [prepayment charge](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/J_Billing_Operations/Prepaid_with_Drawdown/Create_prepayment_charge). Must be a positive number (>0). ")
    prepaid_total_quantity: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="prepaidTotalQuantity", description="**Note**: This field is only available if you have the [Prepaid with Drawdown](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/J_Billing_Operations/Prepaid_with_Drawdown) feature enabled. The total amount of units that end customers can use during a validity period when they subscribe to a [prepayment charge](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/J_Billing_Operations/Prepaid_with_Drawdown/Create_prepayment_charge). ")
    prepaid_uom: Optional[StrictStr] = Field(None, alias="prepaidUom", description="**Note**: This field is only available if you have the [Prepaid with Drawdown](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/J_Billing_Operations/Prepaid_with_Drawdown) feature enabled. Unit of measurement for a [prepayment charge](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/J_Billing_Operations/Prepaid_with_Drawdown/Create_prepayment_charge). ")
    prepay_periods: Optional[StrictInt] = Field(None, alias="prepayPeriods", description="The number of periods to which prepayment is set. **Note:** This field is only available if you already have the prepayment feature enabled.  The prepayment feature is deprecated and available only for backward compatibility. Zuora does not support enabling this feature anymore. ")
    price_change_option: Optional[PriceChangeOption] = Field(None, alias="PriceChangeOption")
    price_increase_percentage: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="PriceIncreasePercentage", description="Specifies the percentage to increase or decrease the price of a termed subscription's renewal. Use this field if you set the value to `SpecificPercentageValue`.  **Character limit**: 16  **Values**: a decimal value between -100 and 100 ")
    price_increase_option: Optional[PriceIncreaseOption] = Field(None, alias="PriceIncreaseOption")
    rating_group: Optional[RatingGroup] = Field(None, alias="RatingGroup")
    recognized_revenue_account: Optional[constr(strict=True, max_length=100)] = Field(None, alias="RecognizedRevenueAccount", description="The name of the recognized revenue account for this charge.   - Required when the Allow Blank Accounting Code setting is No.   - Optional when the Allow Blank Accounting Code setting is Yes.  This feature is in **Limited Availability**. If you wish to have access to the feature, submit a request at [Zuora Global Support](http://support.zuora.com/).  ")
    rev_rec_code: Optional[constr(strict=True, max_length=70)] = Field(None, alias="RevRecCode", description="Associates this product rate plan charge with a specific revenue recognition code. ")
    rev_rec_trigger_condition: Optional[RevRecTriggerConditionProductRatePlanChargeRest] = Field(None, alias="RevRecTriggerCondition")
    revenue_recognition_rule_name: Optional[RevenueRecognitionRuleName] = Field(None, alias="RevenueRecognitionRuleName")
    rollover_apply: Optional[RolloverApply] = Field(None, alias="RolloverApply")
    rollover_periods: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="RolloverPeriods", description="**Note**: This field is only available if you have the [Prepaid with Drawdown](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/J_Billing_Operations/Prepaid_with_Drawdown) feature enabled. To use this field, you must set the `X-Zuora-WSDL-Version` request header to 114 or higher. Otherwise, an error occurs. This field defines the number of rollover periods, it is restricted to 3. ")
    smoothing_model: Optional[SmoothingModel] = Field(None, alias="SmoothingModel")
    specific_billing_period: Optional[StrictInt] = Field(None, alias="SpecificBillingPeriod", description="Customizes the number of months or weeks for the charges billing period. This field is required if you set the value of the BillingPeriod field to `Specific Months` or `Specific Weeks`. The valid value is a positive integer. ")
    specific_list_price_base: Optional[Dict[str, Any]] = Field(None, alias="SpecificListPriceBase", description="The number of months for the list price base of the charge. The value of this field is `null` if you do not set the value of the `ListPriceBase` field to `Per Specific Months`.  **Notes**:    - This field is available only if you have the <a href=\"https://knowledgecenter.zuora.com/Billing/Subscriptions/Product_Catalog/I_Annual_List_Price\" target=\"_blank\">Annual List Price</a> feature enabled.   - To use this field, you must set the `X-Zuora-WSDL-Version` request header to `129` or later. Otherwise, an error occurs.   - The value of this field is `null` if you do not set the value of the `ListPriceBase` field to `Per Specific Months`. ")
    tax_code: Optional[constr(strict=True, max_length=64)] = Field(None, alias="TaxCode", description="Specifies the tax code for taxation rules. Required when the Taxable field is set to `True`.  **Note**: This value affects the tax calculation of rate plan charges that come from the `ProductRatePlanCharge`. ")
    tax_mode: Optional[TaxMode] = Field(None, alias="TaxMode")
    taxable: Optional[StrictBool] = Field(None, alias="Taxable", description="Determines whether the charge is taxable. When set to `True`, the TaxMode and TaxCode fields are required when creating or updating th ProductRatePlanCharge object.  **Character limit**: 5  **Values**: `True`, `False`  **Note**: This value affects the tax calculation of rate plan charges that come from the `ProductRatePlanCharge`. ")
    trigger_event: Optional[TriggerEventProductRatePlanChargeRest] = Field(None, alias="TriggerEvent")
    uom: Optional[constr(strict=True, max_length=25)] = Field(None, alias="UOM", description="Specifies the units to measure usage.   **Note**: You must specify this field when creating the following charge models:   - Per Unit Pricing   - Volume Pricin   - Overage Pricing   - Tiered Pricing   - Tiered with Overage Pricing ")
    up_to_periods: Optional[StrictInt] = Field(None, alias="UpToPeriods", description="Specifies the length of the period during which the charge is active. If this period ends before the subscription ends, the charge ends when this period ends.  **Character limit**: 5  **Values**: a whole number between 0 and 65535, exclusive  **Notes**:   - You must use this field together with the `UpToPeriodsType` field to specify the time period. This field is applicable only when the `EndDateCondition` field is set to `FixedPeriod`.    - If the subscription end date is subsequently changed through a Renewal, or Terms and Conditions amendment, the charge end date will change accordingly up to the original period end. ")
    up_to_periods_type: Optional[UpToPeriodsTypeProductRatePlanChargeRest] = Field(None, alias="UpToPeriodsType")
    updated_by_id: Optional[constr(strict=True, max_length=32)] = Field(None, alias="UpdatedById", description="The ID of the last user to update the object. ")
    updated_date: Optional[datetime] = Field(None, alias="UpdatedDate", description="The date when the object was last updated. ")
    usage_record_rating_option: Optional[UsageRecordRatingOption] = Field(None, alias="UsageRecordRatingOption")
    use_discount_specific_accounting_code: Optional[StrictBool] = Field(None, alias="UseDiscountSpecificAccountingCode", description="Determines whether to define a new accounting code for the new discount charge.  **Character limit**: 5  **Values**: `True`, `False` ")
    use_tenant_default_for_price_change: Optional[StrictBool] = Field(None, alias="UseTenantDefaultForPriceChange", description="Applies the tenant-level percentage uplift value for an automatic price change to a termed subscription's renewal.   **Character limit**: 5  **Values**: `true`, `false` ")
    validity_period_type: Optional[ValidityPeriodType] = Field(None, alias="ValidityPeriodType")
    weekly_bill_cycle_day: Optional[WeeklyBillCycleDay] = Field(None, alias="WeeklyBillCycleDay")
    __properties = ["Class__NS", "DeferredRevAccount__NS", "Department__NS", "IncludeChildren__NS", "IntegrationId__NS", "IntegrationStatus__NS", "ItemType__NS", "Location__NS", "RecognizedRevAccount__NS", "RevRecEnd__NS", "RevRecStart__NS", "RevRecTemplateType__NS", "Subsidiary__NS", "SyncDate__NS", "Id", "ProductRatePlanId", "AccountingCode", "ApplyDiscountTo", "BillCycleDay", "BillCycleType", "BillingPeriod", "BillingPeriodAlignment", "BillingTiming", "ChargeFunction", "ChargeModel", "ChargeModelConfiguration", "ChargeType", "CommitmentType", "CreatedById", "CreatedDate", "DefaultQuantity", "DeferredRevenueAccount", "DeliverySchedule", "Description", "DiscountLevel", "DrawdownRate", "DrawdownUom", "EndDateCondition", "ExcludeItemBillingFromRevenueAccounting", "ExcludeItemBookingFromRevenueAccounting", "IncludedUnits", "IsPrepaid", "IsRollover", "IsStackedDiscount", "IsUnbilled", "RevenueRecognitionTiming", "RevenueAmortizationMethod", "LegacyRevenueReporting", "ListPriceBase", "MinQuantity", "MaxQuantity", "Name", "NumberOfPeriod", "OverageCalculationOption", "OverageUnusedUnitsCreditOption", "PrepaidOperationType", "prepaidQuantity", "prepaidTotalQuantity", "prepaidUom", "prepayPeriods", "PriceChangeOption", "PriceIncreasePercentage", "PriceIncreaseOption", "RatingGroup", "RecognizedRevenueAccount", "RevRecCode", "RevRecTriggerCondition", "RevenueRecognitionRuleName", "RolloverApply", "RolloverPeriods", "SmoothingModel", "SpecificBillingPeriod", "SpecificListPriceBase", "TaxCode", "TaxMode", "Taxable", "TriggerEvent", "UOM", "UpToPeriods", "UpToPeriodsType", "UpdatedById", "UpdatedDate", "UsageRecordRatingOption", "UseDiscountSpecificAccountingCode", "UseTenantDefaultForPriceChange", "ValidityPeriodType", "WeeklyBillCycleDay"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ProductRatePlanCharge:
        """Create an instance of ProductRatePlanCharge from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of charge_model_configuration
        if self.charge_model_configuration:
            _dict['ChargeModelConfiguration'] = self.charge_model_configuration.to_dict()
        # override the default output from pydantic by calling `to_dict()` of delivery_schedule
        if self.delivery_schedule:
            _dict['DeliverySchedule'] = self.delivery_schedule.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ProductRatePlanCharge:
        """Create an instance of ProductRatePlanCharge from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return ProductRatePlanCharge.parse_obj(obj)

        _obj = ProductRatePlanCharge.parse_obj({
            "class__ns": obj.get("Class__NS"),
            "deferred_rev_account__ns": obj.get("DeferredRevAccount__NS"),
            "department__ns": obj.get("Department__NS"),
            "include_children__ns": obj.get("IncludeChildren__NS"),
            "integration_id__ns": obj.get("IntegrationId__NS"),
            "integration_status__ns": obj.get("IntegrationStatus__NS"),
            "item_type__ns": obj.get("ItemType__NS"),
            "location__ns": obj.get("Location__NS"),
            "recognized_rev_account__ns": obj.get("RecognizedRevAccount__NS"),
            "rev_rec_end__ns": obj.get("RevRecEnd__NS"),
            "rev_rec_start__ns": obj.get("RevRecStart__NS"),
            "rev_rec_template_type__ns": obj.get("RevRecTemplateType__NS"),
            "subsidiary__ns": obj.get("Subsidiary__NS"),
            "sync_date__ns": obj.get("SyncDate__NS"),
            "id": obj.get("Id"),
            "product_rate_plan_id": obj.get("ProductRatePlanId"),
            "accounting_code": obj.get("AccountingCode"),
            "apply_discount_to": obj.get("ApplyDiscountTo"),
            "bill_cycle_day": obj.get("BillCycleDay"),
            "bill_cycle_type": obj.get("BillCycleType"),
            "billing_period": obj.get("BillingPeriod"),
            "billing_period_alignment": obj.get("BillingPeriodAlignment"),
            "billing_timing": obj.get("BillingTiming"),
            "charge_function": obj.get("ChargeFunction"),
            "charge_model": obj.get("ChargeModel"),
            "charge_model_configuration": ChargeModelConfiguration.from_dict(obj.get("ChargeModelConfiguration")) if obj.get("ChargeModelConfiguration") is not None else None,
            "charge_type": obj.get("ChargeType"),
            "commitment_type": obj.get("CommitmentType"),
            "created_by_id": obj.get("CreatedById"),
            "created_date": obj.get("CreatedDate"),
            "default_quantity": obj.get("DefaultQuantity"),
            "deferred_revenue_account": obj.get("DeferredRevenueAccount"),
            "delivery_schedule": DeliveryScheduleProductRatePlanCharge.from_dict(obj.get("DeliverySchedule")) if obj.get("DeliverySchedule") is not None else None,
            "description": obj.get("Description"),
            "discount_level": obj.get("DiscountLevel"),
            "drawdown_rate": obj.get("DrawdownRate"),
            "drawdown_uom": obj.get("DrawdownUom"),
            "end_date_condition": obj.get("EndDateCondition"),
            "exclude_item_billing_from_revenue_accounting": obj.get("ExcludeItemBillingFromRevenueAccounting"),
            "exclude_item_booking_from_revenue_accounting": obj.get("ExcludeItemBookingFromRevenueAccounting"),
            "included_units": obj.get("IncludedUnits"),
            "is_prepaid": obj.get("IsPrepaid"),
            "is_rollover": obj.get("IsRollover"),
            "is_stacked_discount": obj.get("IsStackedDiscount"),
            "is_unbilled": obj.get("IsUnbilled"),
            "revenue_recognition_timing": obj.get("RevenueRecognitionTiming"),
            "revenue_amortization_method": obj.get("RevenueAmortizationMethod"),
            "legacy_revenue_reporting": obj.get("LegacyRevenueReporting"),
            "list_price_base": obj.get("ListPriceBase"),
            "min_quantity": obj.get("MinQuantity"),
            "max_quantity": obj.get("MaxQuantity"),
            "name": obj.get("Name"),
            "number_of_period": obj.get("NumberOfPeriod"),
            "overage_calculation_option": obj.get("OverageCalculationOption"),
            "overage_unused_units_credit_option": obj.get("OverageUnusedUnitsCreditOption"),
            "prepaid_operation_type": obj.get("PrepaidOperationType"),
            "prepaid_quantity": obj.get("prepaidQuantity"),
            "prepaid_total_quantity": obj.get("prepaidTotalQuantity"),
            "prepaid_uom": obj.get("prepaidUom"),
            "prepay_periods": obj.get("prepayPeriods"),
            "price_change_option": obj.get("PriceChangeOption"),
            "price_increase_percentage": obj.get("PriceIncreasePercentage"),
            "price_increase_option": obj.get("PriceIncreaseOption"),
            "rating_group": obj.get("RatingGroup"),
            "recognized_revenue_account": obj.get("RecognizedRevenueAccount"),
            "rev_rec_code": obj.get("RevRecCode"),
            "rev_rec_trigger_condition": obj.get("RevRecTriggerCondition"),
            "revenue_recognition_rule_name": obj.get("RevenueRecognitionRuleName"),
            "rollover_apply": obj.get("RolloverApply"),
            "rollover_periods": obj.get("RolloverPeriods"),
            "smoothing_model": obj.get("SmoothingModel"),
            "specific_billing_period": obj.get("SpecificBillingPeriod"),
            "specific_list_price_base": obj.get("SpecificListPriceBase"),
            "tax_code": obj.get("TaxCode"),
            "tax_mode": obj.get("TaxMode"),
            "taxable": obj.get("Taxable"),
            "trigger_event": obj.get("TriggerEvent"),
            "uom": obj.get("UOM"),
            "up_to_periods": obj.get("UpToPeriods"),
            "up_to_periods_type": obj.get("UpToPeriodsType"),
            "updated_by_id": obj.get("UpdatedById"),
            "updated_date": obj.get("UpdatedDate"),
            "usage_record_rating_option": obj.get("UsageRecordRatingOption"),
            "use_discount_specific_accounting_code": obj.get("UseDiscountSpecificAccountingCode"),
            "use_tenant_default_for_price_change": obj.get("UseTenantDefaultForPriceChange"),
            "validity_period_type": obj.get("ValidityPeriodType"),
            "weekly_bill_cycle_day": obj.get("WeeklyBillCycleDay")
        })
        return _obj


