# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictStr, constr

class ProductRatePlanChargeObjectNSFields(BaseModel):
    """
    Container for Product Rate Plan Charge fields provided by the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265).   # noqa: E501
    """
    class__ns: Optional[constr(strict=True, max_length=255)] = Field(None, alias="Class__NS", description="Class associated with the corresponding item in NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265). ")
    deferred_rev_account__ns: Optional[constr(strict=True, max_length=255)] = Field(None, alias="DeferredRevAccount__NS", description="Deferrred revenue account associated with the corresponding item in NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265). ")
    department__ns: Optional[constr(strict=True, max_length=255)] = Field(None, alias="Department__NS", description="Department associated with the corresponding item in NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265). ")
    include_children__ns: Optional[StrictStr] = Field(None, alias="IncludeChildren__NS")
    integration_id__ns: Optional[constr(strict=True, max_length=255)] = Field(None, alias="IntegrationId__NS", description="ID of the corresponding object in NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265). ")
    integration_status__ns: Optional[constr(strict=True, max_length=255)] = Field(None, alias="IntegrationStatus__NS", description="Status of the product rate plan charge's synchronization with NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265). ")
    item_type__ns: Optional[StrictStr] = Field(None, alias="ItemType__NS")
    location__ns: Optional[constr(strict=True, max_length=255)] = Field(None, alias="Location__NS", description="Location associated with the corresponding item in NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265). ")
    recognized_rev_account__ns: Optional[constr(strict=True, max_length=255)] = Field(None, alias="RecognizedRevAccount__NS", description="Recognized revenue account associated with the corresponding item in NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265). ")
    rev_rec_end__ns: Optional[StrictStr] = Field(None, alias="RevRecEnd__NS")
    rev_rec_start__ns: Optional[StrictStr] = Field(None, alias="RevRecStart__NS")
    rev_rec_template_type__ns: Optional[constr(strict=True, max_length=255)] = Field(None, alias="RevRecTemplateType__NS", description="Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265). ")
    subsidiary__ns: Optional[constr(strict=True, max_length=255)] = Field(None, alias="Subsidiary__NS", description="Subsidiary associated with the corresponding item in NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265). ")
    sync_date__ns: Optional[constr(strict=True, max_length=255)] = Field(None, alias="SyncDate__NS", description="Date when the product rate plan charge was synchronized with NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265). ")
    __properties = ["Class__NS", "DeferredRevAccount__NS", "Department__NS", "IncludeChildren__NS", "IntegrationId__NS", "IntegrationStatus__NS", "ItemType__NS", "Location__NS", "RecognizedRevAccount__NS", "RevRecEnd__NS", "RevRecStart__NS", "RevRecTemplateType__NS", "Subsidiary__NS", "SyncDate__NS"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ProductRatePlanChargeObjectNSFields:
        """Create an instance of ProductRatePlanChargeObjectNSFields from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ProductRatePlanChargeObjectNSFields:
        """Create an instance of ProductRatePlanChargeObjectNSFields from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return ProductRatePlanChargeObjectNSFields.parse_obj(obj)

        _obj = ProductRatePlanChargeObjectNSFields.parse_obj({
            "class__ns": obj.get("Class__NS"),
            "deferred_rev_account__ns": obj.get("DeferredRevAccount__NS"),
            "department__ns": obj.get("Department__NS"),
            "include_children__ns": obj.get("IncludeChildren__NS"),
            "integration_id__ns": obj.get("IntegrationId__NS"),
            "integration_status__ns": obj.get("IntegrationStatus__NS"),
            "item_type__ns": obj.get("ItemType__NS"),
            "location__ns": obj.get("Location__NS"),
            "recognized_rev_account__ns": obj.get("RecognizedRevAccount__NS"),
            "rev_rec_end__ns": obj.get("RevRecEnd__NS"),
            "rev_rec_start__ns": obj.get("RevRecStart__NS"),
            "rev_rec_template_type__ns": obj.get("RevRecTemplateType__NS"),
            "subsidiary__ns": obj.get("Subsidiary__NS"),
            "sync_date__ns": obj.get("SyncDate__NS")
        })
        return _obj


