# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictStr
from com.zuora.models.proxy_actionquery_more_request_conf import ProxyActionqueryMoreRequestConf

class ProxyActionqueryRequest(BaseModel):
    """
    ProxyActionqueryRequest
    """
    conf: Optional[ProxyActionqueryMoreRequestConf] = None
    query_string: StrictStr = Field(..., alias="queryString", description="[ZOQL](https://knowledgecenter.zuora.com/DC_Developers/K_Zuora_Object_Query_Language) expression that specifies the object to query, the fields to retrieve, and any filters.  **Note:** When querying one time charges from ProductRatePlanCharge, you need to specify the `ChargeType` value as `One-Time` rather than `OneTime`. ")
    __properties = ["conf", "queryString"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ProxyActionqueryRequest:
        """Create an instance of ProxyActionqueryRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of conf
        if self.conf:
            _dict['conf'] = self.conf.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ProxyActionqueryRequest:
        """Create an instance of ProxyActionqueryRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return ProxyActionqueryRequest.parse_obj(obj)

        _obj = ProxyActionqueryRequest.parse_obj({
            "conf": ProxyActionqueryMoreRequestConf.from_dict(obj.get("conf")) if obj.get("conf") is not None else None,
            "query_string": obj.get("queryString")
        })
        return _obj


