# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictBool, StrictStr

class ProxyPostImport(BaseModel):
    """
    ProxyPostImport
    """
    id: Optional[StrictStr] = Field(None, alias="Id", description="The ID of the Import object that was created. ")
    success: Optional[StrictBool] = Field(None, alias="Success", description="Indicates whether the call succeeded. ")
    __properties = ["Id", "Success"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ProxyPostImport:
        """Create an instance of ProxyPostImport from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ProxyPostImport:
        """Create an instance of ProxyPostImport from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return ProxyPostImport.parse_obj(obj)

        _obj = ProxyPostImport.parse_obj({
            "id": obj.get("Id"),
            "success": obj.get("Success")
        })
        return _obj


