# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, constr

class PutEventTriggerRequestEventType(BaseModel):
    """
    The type of events to be triggered.  # noqa: E501
    """
    description: Optional[constr(strict=True, max_length=1000)] = Field(None, description="The description for the event type.")
    display_name: Optional[constr(strict=True, max_length=500, min_length=1)] = Field(None, alias="displayName", description="The display name for the event type.")
    __properties = ["description", "displayName"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> PutEventTriggerRequestEventType:
        """Create an instance of PutEventTriggerRequestEventType from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> PutEventTriggerRequestEventType:
        """Create an instance of PutEventTriggerRequestEventType from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return PutEventTriggerRequestEventType.parse_obj(obj)

        _obj = PutEventTriggerRequestEventType.parse_obj({
            "description": obj.get("description"),
            "display_name": obj.get("displayName")
        })
        return _obj


