# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List
from pydantic import BaseModel, Field, StrictInt, conlist
from com.zuora.models.custom_object_record_with_all_fields import CustomObjectRecordWithAllFields

class QueryCustomObjectRecordsResponse(BaseModel):
    """
    QueryCustomObjectRecordsResponse
    """
    count: StrictInt = Field(..., description="The record count of the given custom object type")
    records: conlist(CustomObjectRecordWithAllFields) = Field(...)
    __properties = ["count", "records"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> QueryCustomObjectRecordsResponse:
        """Create an instance of QueryCustomObjectRecordsResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in records (list)
        _items = []
        if self.records:
            for _item in self.records:
                if _item:
                    _items.append(_item.to_dict())
            _dict['records'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> QueryCustomObjectRecordsResponse:
        """Create an instance of QueryCustomObjectRecordsResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return QueryCustomObjectRecordsResponse.parse_obj(obj)

        _obj = QueryCustomObjectRecordsResponse.parse_obj({
            "count": obj.get("count"),
            "records": [CustomObjectRecordWithAllFields.from_dict(_item) for _item in obj.get("records")] if obj.get("records") is not None else None
        })
        return _obj


