# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from typing import Optional, Union
from pydantic import BaseModel, Field, StrictFloat, StrictInt

class RampIntervalChargeDeltaMetricsDeltaQuantityInner(BaseModel):
    """
    RampIntervalChargeDeltaMetricsDeltaQuantityInner
    """
    amount: Optional[Union[StrictFloat, StrictInt]] = Field(None, description="The delta amount of the charge quantity.")
    end_date: Optional[date] = Field(None, alias="endDate", description="The end date.")
    start_date: Optional[date] = Field(None, alias="startDate", description="The start date.")
    __properties = ["amount", "endDate", "startDate"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> RampIntervalChargeDeltaMetricsDeltaQuantityInner:
        """Create an instance of RampIntervalChargeDeltaMetricsDeltaQuantityInner from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> RampIntervalChargeDeltaMetricsDeltaQuantityInner:
        """Create an instance of RampIntervalChargeDeltaMetricsDeltaQuantityInner from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return RampIntervalChargeDeltaMetricsDeltaQuantityInner.parse_obj(obj)

        _obj = RampIntervalChargeDeltaMetricsDeltaQuantityInner.parse_obj({
            "amount": obj.get("amount"),
            "end_date": obj.get("endDate"),
            "start_date": obj.get("startDate")
        })
        return _obj


