# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from typing import List, Optional, Union
from pydantic import BaseModel, Field, StrictFloat, StrictInt, StrictStr, conlist
from com.zuora.models.ramp_interval_charge_metrics_mrr_inner import RampIntervalChargeMetricsMrrInner

class RampIntervalChargeMetrics(BaseModel):
    """
    RampIntervalChargeMetrics
    """
    charge_number: Optional[StrictStr] = Field(None, alias="chargeNumber", description="The number of the charge.")
    discount_tcb: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="discountTcb", description="The discount amount for the TCB.")
    discount_tcv: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="discountTcv", description="The discount amount for the TCV.")
    end_date: Optional[date] = Field(None, alias="endDate", description="The end date of the rate plan charge in the current ramp interval.")
    gross_tcb: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="grossTcb", description="The gross TCB value before discount charges are applied.")
    gross_tcv: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="grossTcv", description="The gross TCV value before discount charges are applied.")
    mrr: Optional[conlist(RampIntervalChargeMetricsMrrInner)] = Field(None, description="The MRR changing history of the current rate plan charge in the current ramp interval.")
    net_tcb: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="netTcb", description="The net TCB value after discount charges are applied.")
    net_tcv: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="netTcv", description="The net TCV value after discount charges are applied.")
    product_rate_plan_charge_id: Optional[StrictStr] = Field(None, alias="productRatePlanChargeId", description="The ID of the corresponding product rate plan charge.")
    quantity: Optional[Union[StrictFloat, StrictInt]] = Field(None, description="The quantity of the rate plan charge.")
    rate_plan_charge_id: Optional[StrictStr] = Field(None, alias="ratePlanChargeId", description="The ID of the rate plan charge.")
    start_date: Optional[date] = Field(None, alias="startDate", description="The start date of the rate plan charge in the current ramp interval.")
    subscription_number: Optional[StrictStr] = Field(None, alias="subscriptionNumber", description="The number of the subscription that the current rate plan charge belongs to.")
    __properties = ["chargeNumber", "discountTcb", "discountTcv", "endDate", "grossTcb", "grossTcv", "mrr", "netTcb", "netTcv", "productRatePlanChargeId", "quantity", "ratePlanChargeId", "startDate", "subscriptionNumber"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> RampIntervalChargeMetrics:
        """Create an instance of RampIntervalChargeMetrics from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in mrr (list)
        _items = []
        if self.mrr:
            for _item in self.mrr:
                if _item:
                    _items.append(_item.to_dict())
            _dict['mrr'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> RampIntervalChargeMetrics:
        """Create an instance of RampIntervalChargeMetrics from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return RampIntervalChargeMetrics.parse_obj(obj)

        _obj = RampIntervalChargeMetrics.parse_obj({
            "charge_number": obj.get("chargeNumber"),
            "discount_tcb": obj.get("discountTcb"),
            "discount_tcv": obj.get("discountTcv"),
            "end_date": obj.get("endDate"),
            "gross_tcb": obj.get("grossTcb"),
            "gross_tcv": obj.get("grossTcv"),
            "mrr": [RampIntervalChargeMetricsMrrInner.from_dict(_item) for _item in obj.get("mrr")] if obj.get("mrr") is not None else None,
            "net_tcb": obj.get("netTcb"),
            "net_tcv": obj.get("netTcv"),
            "product_rate_plan_charge_id": obj.get("productRatePlanChargeId"),
            "quantity": obj.get("quantity"),
            "rate_plan_charge_id": obj.get("ratePlanChargeId"),
            "start_date": obj.get("startDate"),
            "subscription_number": obj.get("subscriptionNumber")
        })
        return _obj


