# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from typing import Optional, Union
from pydantic import BaseModel, Field, StrictFloat, StrictInt

class RampIntervalChargeMetricsMrrInner(BaseModel):
    """
    RampIntervalChargeMetricsMrrInner
    """
    discount: Optional[Union[StrictFloat, StrictInt]] = Field(None, description="The discount amount for the MRR.")
    end_date: Optional[date] = Field(None, alias="endDate", description="The end date.")
    gross: Optional[Union[StrictFloat, StrictInt]] = Field(None, description="The gross MRR amount before discounts charges are applied.")
    net: Optional[Union[StrictFloat, StrictInt]] = Field(None, description="The net MRR amount after discounts charges are applied.")
    start_date: Optional[date] = Field(None, alias="startDate", description="The start date.")
    __properties = ["discount", "endDate", "gross", "net", "startDate"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> RampIntervalChargeMetricsMrrInner:
        """Create an instance of RampIntervalChargeMetricsMrrInner from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> RampIntervalChargeMetricsMrrInner:
        """Create an instance of RampIntervalChargeMetricsMrrInner from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return RampIntervalChargeMetricsMrrInner.parse_obj(obj)

        _obj = RampIntervalChargeMetricsMrrInner.parse_obj({
            "discount": obj.get("discount"),
            "end_date": obj.get("endDate"),
            "gross": obj.get("gross"),
            "net": obj.get("net"),
            "start_date": obj.get("startDate")
        })
        return _obj


