# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from typing import Optional
from pydantic import BaseModel, Field, StrictStr

class RampIntervalRequest(BaseModel):
    """
    Container for the intervals that the ramp is split into in its timeline. Zuora can report metrics for this specific period.   # noqa: E501
    """
    description: Optional[StrictStr] = Field(None, description="The short description of the interval.")
    end_date: date = Field(..., alias="endDate", description="The end date of the interval.")
    name: Optional[StrictStr] = Field(None, description="The name of the interval.")
    start_date: date = Field(..., alias="startDate", description="The start date of the interval.")
    __properties = ["description", "endDate", "name", "startDate"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> RampIntervalRequest:
        """Create an instance of RampIntervalRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> RampIntervalRequest:
        """Create an instance of RampIntervalRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return RampIntervalRequest.parse_obj(obj)

        _obj = RampIntervalRequest.parse_obj({
            "description": obj.get("description"),
            "end_date": obj.get("endDate"),
            "name": obj.get("name"),
            "start_date": obj.get("startDate")
        })
        return _obj


