# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field
from com.zuora.models.discount_pricing_override import DiscountPricingOverride
from com.zuora.models.one_time_flat_fee_pricing_override import OneTimeFlatFeePricingOverride
from com.zuora.models.one_time_per_unit_pricing_override import OneTimePerUnitPricingOverride
from com.zuora.models.one_time_tiered_pricing_override import OneTimeTieredPricingOverride
from com.zuora.models.one_time_volume_pricing_override import OneTimeVolumePricingOverride
from com.zuora.models.order_action_rate_plan_charge_model_data_override import OrderActionRatePlanChargeModelDataOverride
from com.zuora.models.order_action_rate_plan_recurring_delivery_pricing_override import OrderActionRatePlanRecurringDeliveryPricingOverride
from com.zuora.models.order_action_rate_plan_recurring_flat_fee_pricing_override import OrderActionRatePlanRecurringFlatFeePricingOverride
from com.zuora.models.order_action_rate_plan_recurring_per_unit_pricing_override import OrderActionRatePlanRecurringPerUnitPricingOverride
from com.zuora.models.order_action_rate_plan_recurring_tiered_pricing_override import OrderActionRatePlanRecurringTieredPricingOverride
from com.zuora.models.order_action_rate_plan_recurring_volume_pricing_override import OrderActionRatePlanRecurringVolumePricingOverride
from com.zuora.models.usage_flat_fee_pricing_override import UsageFlatFeePricingOverride
from com.zuora.models.usage_overage_pricing_override import UsageOveragePricingOverride
from com.zuora.models.usage_per_unit_pricing_override import UsagePerUnitPricingOverride
from com.zuora.models.usage_tiered_pricing_override import UsageTieredPricingOverride
from com.zuora.models.usage_tiered_with_overage_pricing_override import UsageTieredWithOveragePricingOverride
from com.zuora.models.usage_volume_pricing_override import UsageVolumePricingOverride

class RatePlanChargeOverridePricing(BaseModel):
    """
    Pricing information about the charge.   # noqa: E501
    """
    charge_model_data: Optional[OrderActionRatePlanChargeModelDataOverride] = Field(None, alias="chargeModelData")
    discount: Optional[DiscountPricingOverride] = None
    one_time_flat_fee: Optional[OneTimeFlatFeePricingOverride] = Field(None, alias="oneTimeFlatFee")
    one_time_per_unit: Optional[OneTimePerUnitPricingOverride] = Field(None, alias="oneTimePerUnit")
    one_time_tiered: Optional[OneTimeTieredPricingOverride] = Field(None, alias="oneTimeTiered")
    one_time_volume: Optional[OneTimeVolumePricingOverride] = Field(None, alias="oneTimeVolume")
    recurring_delivery: Optional[OrderActionRatePlanRecurringDeliveryPricingOverride] = Field(None, alias="recurringDelivery")
    recurring_flat_fee: Optional[OrderActionRatePlanRecurringFlatFeePricingOverride] = Field(None, alias="recurringFlatFee")
    recurring_per_unit: Optional[OrderActionRatePlanRecurringPerUnitPricingOverride] = Field(None, alias="recurringPerUnit")
    recurring_tiered: Optional[OrderActionRatePlanRecurringTieredPricingOverride] = Field(None, alias="recurringTiered")
    recurring_volume: Optional[OrderActionRatePlanRecurringVolumePricingOverride] = Field(None, alias="recurringVolume")
    usage_flat_fee: Optional[UsageFlatFeePricingOverride] = Field(None, alias="usageFlatFee")
    usage_overage: Optional[UsageOveragePricingOverride] = Field(None, alias="usageOverage")
    usage_per_unit: Optional[UsagePerUnitPricingOverride] = Field(None, alias="usagePerUnit")
    usage_tiered: Optional[UsageTieredPricingOverride] = Field(None, alias="usageTiered")
    usage_tiered_with_overage: Optional[UsageTieredWithOveragePricingOverride] = Field(None, alias="usageTieredWithOverage")
    usage_volume: Optional[UsageVolumePricingOverride] = Field(None, alias="usageVolume")
    __properties = ["chargeModelData", "discount", "oneTimeFlatFee", "oneTimePerUnit", "oneTimeTiered", "oneTimeVolume", "recurringDelivery", "recurringFlatFee", "recurringPerUnit", "recurringTiered", "recurringVolume", "usageFlatFee", "usageOverage", "usagePerUnit", "usageTiered", "usageTieredWithOverage", "usageVolume"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> RatePlanChargeOverridePricing:
        """Create an instance of RatePlanChargeOverridePricing from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of charge_model_data
        if self.charge_model_data:
            _dict['chargeModelData'] = self.charge_model_data.to_dict()
        # override the default output from pydantic by calling `to_dict()` of discount
        if self.discount:
            _dict['discount'] = self.discount.to_dict()
        # override the default output from pydantic by calling `to_dict()` of one_time_flat_fee
        if self.one_time_flat_fee:
            _dict['oneTimeFlatFee'] = self.one_time_flat_fee.to_dict()
        # override the default output from pydantic by calling `to_dict()` of one_time_per_unit
        if self.one_time_per_unit:
            _dict['oneTimePerUnit'] = self.one_time_per_unit.to_dict()
        # override the default output from pydantic by calling `to_dict()` of one_time_tiered
        if self.one_time_tiered:
            _dict['oneTimeTiered'] = self.one_time_tiered.to_dict()
        # override the default output from pydantic by calling `to_dict()` of one_time_volume
        if self.one_time_volume:
            _dict['oneTimeVolume'] = self.one_time_volume.to_dict()
        # override the default output from pydantic by calling `to_dict()` of recurring_delivery
        if self.recurring_delivery:
            _dict['recurringDelivery'] = self.recurring_delivery.to_dict()
        # override the default output from pydantic by calling `to_dict()` of recurring_flat_fee
        if self.recurring_flat_fee:
            _dict['recurringFlatFee'] = self.recurring_flat_fee.to_dict()
        # override the default output from pydantic by calling `to_dict()` of recurring_per_unit
        if self.recurring_per_unit:
            _dict['recurringPerUnit'] = self.recurring_per_unit.to_dict()
        # override the default output from pydantic by calling `to_dict()` of recurring_tiered
        if self.recurring_tiered:
            _dict['recurringTiered'] = self.recurring_tiered.to_dict()
        # override the default output from pydantic by calling `to_dict()` of recurring_volume
        if self.recurring_volume:
            _dict['recurringVolume'] = self.recurring_volume.to_dict()
        # override the default output from pydantic by calling `to_dict()` of usage_flat_fee
        if self.usage_flat_fee:
            _dict['usageFlatFee'] = self.usage_flat_fee.to_dict()
        # override the default output from pydantic by calling `to_dict()` of usage_overage
        if self.usage_overage:
            _dict['usageOverage'] = self.usage_overage.to_dict()
        # override the default output from pydantic by calling `to_dict()` of usage_per_unit
        if self.usage_per_unit:
            _dict['usagePerUnit'] = self.usage_per_unit.to_dict()
        # override the default output from pydantic by calling `to_dict()` of usage_tiered
        if self.usage_tiered:
            _dict['usageTiered'] = self.usage_tiered.to_dict()
        # override the default output from pydantic by calling `to_dict()` of usage_tiered_with_overage
        if self.usage_tiered_with_overage:
            _dict['usageTieredWithOverage'] = self.usage_tiered_with_overage.to_dict()
        # override the default output from pydantic by calling `to_dict()` of usage_volume
        if self.usage_volume:
            _dict['usageVolume'] = self.usage_volume.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> RatePlanChargeOverridePricing:
        """Create an instance of RatePlanChargeOverridePricing from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return RatePlanChargeOverridePricing.parse_obj(obj)

        _obj = RatePlanChargeOverridePricing.parse_obj({
            "charge_model_data": OrderActionRatePlanChargeModelDataOverride.from_dict(obj.get("chargeModelData")) if obj.get("chargeModelData") is not None else None,
            "discount": DiscountPricingOverride.from_dict(obj.get("discount")) if obj.get("discount") is not None else None,
            "one_time_flat_fee": OneTimeFlatFeePricingOverride.from_dict(obj.get("oneTimeFlatFee")) if obj.get("oneTimeFlatFee") is not None else None,
            "one_time_per_unit": OneTimePerUnitPricingOverride.from_dict(obj.get("oneTimePerUnit")) if obj.get("oneTimePerUnit") is not None else None,
            "one_time_tiered": OneTimeTieredPricingOverride.from_dict(obj.get("oneTimeTiered")) if obj.get("oneTimeTiered") is not None else None,
            "one_time_volume": OneTimeVolumePricingOverride.from_dict(obj.get("oneTimeVolume")) if obj.get("oneTimeVolume") is not None else None,
            "recurring_delivery": OrderActionRatePlanRecurringDeliveryPricingOverride.from_dict(obj.get("recurringDelivery")) if obj.get("recurringDelivery") is not None else None,
            "recurring_flat_fee": OrderActionRatePlanRecurringFlatFeePricingOverride.from_dict(obj.get("recurringFlatFee")) if obj.get("recurringFlatFee") is not None else None,
            "recurring_per_unit": OrderActionRatePlanRecurringPerUnitPricingOverride.from_dict(obj.get("recurringPerUnit")) if obj.get("recurringPerUnit") is not None else None,
            "recurring_tiered": OrderActionRatePlanRecurringTieredPricingOverride.from_dict(obj.get("recurringTiered")) if obj.get("recurringTiered") is not None else None,
            "recurring_volume": OrderActionRatePlanRecurringVolumePricingOverride.from_dict(obj.get("recurringVolume")) if obj.get("recurringVolume") is not None else None,
            "usage_flat_fee": UsageFlatFeePricingOverride.from_dict(obj.get("usageFlatFee")) if obj.get("usageFlatFee") is not None else None,
            "usage_overage": UsageOveragePricingOverride.from_dict(obj.get("usageOverage")) if obj.get("usageOverage") is not None else None,
            "usage_per_unit": UsagePerUnitPricingOverride.from_dict(obj.get("usagePerUnit")) if obj.get("usagePerUnit") is not None else None,
            "usage_tiered": UsageTieredPricingOverride.from_dict(obj.get("usageTiered")) if obj.get("usageTiered") is not None else None,
            "usage_tiered_with_overage": UsageTieredWithOveragePricingOverride.from_dict(obj.get("usageTieredWithOverage")) if obj.get("usageTieredWithOverage") is not None else None,
            "usage_volume": UsageVolumePricingOverride.from_dict(obj.get("usageVolume")) if obj.get("usageVolume") is not None else None
        })
        return _obj


