# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import json
import pprint
import re  # noqa: F401
from aenum import Enum, no_arg





class ReconcileRefundRequestAction(str, Enum):
    """
    The action of the refund reconciliation.   - `settle`: Sets Gateway State to \"Settled\" and returns the refund object as response.   - `reject`: Sets Gateway State to \"FailedToSettle\" and handle the event according to the settings configured in the Gateway Reconciliation Configuration in Payments Settings through Zuora UI. See [Configure how to handle refund rejected events](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/M_Payment_Gateways/Gateway_Reconciliation#Configure_how_to_handle_refund_rejected_events) for details. 
    """

    """
    allowed enum values
    """
    SETTLE = 'settle'
    REJECT = 'reject'

    @classmethod
    def from_json(cls, json_str: str) -> ReconcileRefundRequestAction:
        """Create an instance of ReconcileRefundRequestAction from a JSON string"""
        return ReconcileRefundRequestAction(json.loads(json_str))


