# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional, Union
from pydantic import BaseModel, Field, StrictFloat, StrictInt, StrictStr

class RefundCreditMemoItemRequest(BaseModel):
    """
    RefundCreditMemoItemRequest
    """
    amount: Union[StrictFloat, StrictInt] = Field(..., description="The amount of the refund on the specific item. ")
    credit_memo_item_id: Optional[StrictStr] = Field(None, alias="creditMemoItemId", description="The ID of the credit memo item that is refunded. ")
    credit_tax_item_id: Optional[StrictStr] = Field(None, alias="creditTaxItemId", description="The ID of the credit memo taxation item that is refunded. ")
    __properties = ["amount", "creditMemoItemId", "creditTaxItemId"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> RefundCreditMemoItemRequest:
        """Create an instance of RefundCreditMemoItemRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> RefundCreditMemoItemRequest:
        """Create an instance of RefundCreditMemoItemRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return RefundCreditMemoItemRequest.parse_obj(obj)

        _obj = RefundCreditMemoItemRequest.parse_obj({
            "amount": obj.get("amount"),
            "credit_memo_item_id": obj.get("creditMemoItemId"),
            "credit_tax_item_id": obj.get("creditTaxItemId")
        })
        return _obj


