# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictStr, constr

class RejectPaymentRequest(BaseModel):
    """
    RejectPaymentRequest
    """
    gateway_reconciliation_reason: Optional[StrictStr] = Field(None, alias="gatewayReconciliationReason", description="The reason of gateway reconciliation. ")
    gateway_reconciliation_status: Optional[StrictStr] = Field(None, alias="gatewayReconciliationStatus", description="The status of gateway reconciliation. ")
    gateway_response: Optional[StrictStr] = Field(None, alias="gatewayResponse", description="The transaction response returned by the gateway for this transaction. If the transaction was declined, this reason is provided in the message. ")
    gateway_response_code: Optional[StrictStr] = Field(None, alias="gatewayResponseCode", description="Response message Code returned by the gateway about the transaction status. ")
    reference_id: Optional[constr(strict=True, max_length=100)] = Field(None, alias="referenceId", description="Unique Id generated by the gateway for each transaction. Use this ID to find the respective Zuora Payment ID.  ")
    second_reference_id: Optional[constr(strict=True, max_length=100)] = Field(None, alias="secondReferenceId", description="The second reference Id. Some gateway uses two unique transaction IDs. ")
    settled_on: Optional[StrictStr] = Field(None, alias="settledOn", description="The date and time of the transaction settlement. The format is `yyyy-mm-dd hh:mm:ss`. ")
    __properties = ["gatewayReconciliationReason", "gatewayReconciliationStatus", "gatewayResponse", "gatewayResponseCode", "referenceId", "secondReferenceId", "settledOn"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> RejectPaymentRequest:
        """Create an instance of RejectPaymentRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> RejectPaymentRequest:
        """Create an instance of RejectPaymentRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return RejectPaymentRequest.parse_obj(obj)

        _obj = RejectPaymentRequest.parse_obj({
            "gateway_reconciliation_reason": obj.get("gatewayReconciliationReason"),
            "gateway_reconciliation_status": obj.get("gatewayReconciliationStatus"),
            "gateway_response": obj.get("gatewayResponse"),
            "gateway_response_code": obj.get("gatewayResponseCode"),
            "reference_id": obj.get("referenceId"),
            "second_reference_id": obj.get("secondReferenceId"),
            "settled_on": obj.get("settledOn")
        })
        return _obj


