# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict, List, Optional
from pydantic import BaseModel, Field, StrictStr, conlist
from com.zuora.models.setting_item_http_request_parameter import SettingItemHttpRequestParameter

class SettingItemHttpOperation(BaseModel):
    """
    SettingItemHttpOperation
    """
    method: Optional[StrictStr] = None
    parameters: Optional[conlist(SettingItemHttpRequestParameter)] = Field(None, description="An array of paramters required by this operation.")
    request_type: Optional[Dict[str, Any]] = Field(None, alias="requestType", description="JSON Schema for the request body of this operation.")
    response_type: Optional[Dict[str, Any]] = Field(None, alias="responseType", description="JSON Schema for the response body of this operation.")
    url: Optional[StrictStr] = Field(None, description="The endpoint url of the operation method. For example, `/settings/billing-rules`.")
    __properties = ["method", "parameters", "requestType", "responseType", "url"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> SettingItemHttpOperation:
        """Create an instance of SettingItemHttpOperation from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in parameters (list)
        _items = []
        if self.parameters:
            for _item in self.parameters:
                if _item:
                    _items.append(_item.to_dict())
            _dict['parameters'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> SettingItemHttpOperation:
        """Create an instance of SettingItemHttpOperation from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return SettingItemHttpOperation.parse_obj(obj)

        _obj = SettingItemHttpOperation.parse_obj({
            "method": obj.get("method"),
            "parameters": [SettingItemHttpRequestParameter.from_dict(_item) for _item in obj.get("parameters")] if obj.get("parameters") is not None else None,
            "request_type": obj.get("requestType"),
            "response_type": obj.get("responseType"),
            "url": obj.get("url")
        })
        return _obj


