# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictStr, conlist
from com.zuora.models.setting_item_http_operation import SettingItemHttpOperation

class SettingItemWithOperationsInformation(BaseModel):
    """
    SettingItemWithOperationsInformation
    """
    context: Optional[StrictStr] = None
    description: Optional[StrictStr] = Field(None, description="The description of the setting item as you see from Zuora UI.")
    http_operations: Optional[conlist(SettingItemHttpOperation)] = Field(None, alias="httpOperations", description="An array of HTTP operation methods that are supported on this setting endpoint.")
    key: Optional[StrictStr] = Field(None, description="The unique key to distinguish the setting item.")
    path_pattern: Optional[StrictStr] = Field(None, alias="pathPattern", description="The path pattern of the setting endpoint, relative to `/settings`. For example, `/billing-rules`.")
    __properties = ["context", "description", "httpOperations", "key", "pathPattern"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> SettingItemWithOperationsInformation:
        """Create an instance of SettingItemWithOperationsInformation from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in http_operations (list)
        _items = []
        if self.http_operations:
            for _item in self.http_operations:
                if _item:
                    _items.append(_item.to_dict())
            _dict['httpOperations'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> SettingItemWithOperationsInformation:
        """Create an instance of SettingItemWithOperationsInformation from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return SettingItemWithOperationsInformation.parse_obj(obj)

        _obj = SettingItemWithOperationsInformation.parse_obj({
            "context": obj.get("context"),
            "description": obj.get("description"),
            "http_operations": [SettingItemHttpOperation.from_dict(_item) for _item in obj.get("httpOperations")] if obj.get("httpOperations") is not None else None,
            "key": obj.get("key"),
            "path_pattern": obj.get("pathPattern")
        })
        return _obj


