# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictStr

class SettlePaymentRequest(BaseModel):
    """
    SettlePaymentRequest
    """
    gateway_reconciliation_reason: Optional[StrictStr] = Field(None, alias="gatewayReconciliationReason", description="The reason of gateway reconciliation. ")
    gateway_reconciliation_status: Optional[StrictStr] = Field(None, alias="gatewayReconciliationStatus", description="The status of gateway reconciliation. ")
    payout_id: Optional[StrictStr] = Field(None, alias="payoutId", description="The payout ID from the gateway side. ")
    settled_on: Optional[StrictStr] = Field(None, alias="settledOn", description="The date and time of the transaction settlement. The format is `yyyy-mm-dd hh:mm:ss`. ")
    __properties = ["gatewayReconciliationReason", "gatewayReconciliationStatus", "payoutId", "settledOn"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> SettlePaymentRequest:
        """Create an instance of SettlePaymentRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> SettlePaymentRequest:
        """Create an instance of SettlePaymentRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return SettlePaymentRequest.parse_obj(obj)

        _obj = SettlePaymentRequest.parse_obj({
            "gateway_reconciliation_reason": obj.get("gatewayReconciliationReason"),
            "gateway_reconciliation_status": obj.get("gatewayReconciliationStatus"),
            "payout_id": obj.get("payoutId"),
            "settled_on": obj.get("settledOn")
        })
        return _obj


