# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict, Optional
from pydantic import BaseModel, Field, StrictStr
from com.zuora.models.account_data import AccountData
from com.zuora.models.options import Options
from com.zuora.models.payment_data import PaymentData
from com.zuora.models.subscription_data import SubscriptionData

class SignUpRequest(BaseModel):
    """
    SignUpRequest
    """
    account_data: Optional[AccountData] = Field(None, alias="accountData")
    account_identifier_field: Optional[StrictStr] = Field(None, alias="accountIdentifierField", description="Specify the name of the field that holds external account id")
    custom_fields: Optional[Dict[str, Dict[str, Any]]] = Field(None, alias="customFields", description="Container for custom fields. ")
    options: Optional[Options] = None
    payment_data: Optional[PaymentData] = Field(None, alias="paymentData")
    subscription_data: Optional[SubscriptionData] = Field(None, alias="subscriptionData")
    __properties = ["accountData", "accountIdentifierField", "customFields", "options", "paymentData", "subscriptionData"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> SignUpRequest:
        """Create an instance of SignUpRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of account_data
        if self.account_data:
            _dict['accountData'] = self.account_data.to_dict()
        # override the default output from pydantic by calling `to_dict()` of options
        if self.options:
            _dict['options'] = self.options.to_dict()
        # override the default output from pydantic by calling `to_dict()` of payment_data
        if self.payment_data:
            _dict['paymentData'] = self.payment_data.to_dict()
        # override the default output from pydantic by calling `to_dict()` of subscription_data
        if self.subscription_data:
            _dict['subscriptionData'] = self.subscription_data.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> SignUpRequest:
        """Create an instance of SignUpRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return SignUpRequest.parse_obj(obj)

        _obj = SignUpRequest.parse_obj({
            "account_data": AccountData.from_dict(obj.get("accountData")) if obj.get("accountData") is not None else None,
            "account_identifier_field": obj.get("accountIdentifierField"),
            "custom_fields": obj.get("customFields"),
            "options": Options.from_dict(obj.get("options")) if obj.get("options") is not None else None,
            "payment_data": PaymentData.from_dict(obj.get("paymentData")) if obj.get("paymentData") is not None else None,
            "subscription_data": SubscriptionData.from_dict(obj.get("subscriptionData")) if obj.get("subscriptionData") is not None else None
        })
        return _obj


