# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from typing import Any, Dict, List, Optional
from pydantic import BaseModel, Field, StrictBool, conlist, constr
from com.zuora.models.rate_plan import RatePlan
from com.zuora.models.term_info import TermInfo

class SubscriptionData(BaseModel):
    """
    SubscriptionData
    """
    custom_fields: Optional[Dict[str, Dict[str, Any]]] = Field(None, alias="customFields", description="Container for custom fields. ")
    invoice_separately: Optional[StrictBool] = Field(None, alias="invoiceSeparately", description="Specifies whether the subscription appears on a separate invoice when Zuora generates invoices. ")
    notes: Optional[constr(strict=True, max_length=500)] = Field(None, description="Notes about the subscription. These notes are only visible to Zuora users. ")
    rate_plans: Optional[conlist(RatePlan)] = Field(None, alias="ratePlans")
    start_date: Optional[date] = Field(None, alias="startDate")
    subscription_number: Optional[constr(strict=True, max_length=100)] = Field(None, alias="subscriptionNumber", description="Subscription number of the subscription to create, for example, A-S00000001.  If you do not set this field, Zuora will generate a subscription number. ")
    terms: Optional[TermInfo] = None
    __properties = ["customFields", "invoiceSeparately", "notes", "ratePlans", "startDate", "subscriptionNumber", "terms"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> SubscriptionData:
        """Create an instance of SubscriptionData from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in rate_plans (list)
        _items = []
        if self.rate_plans:
            for _item in self.rate_plans:
                if _item:
                    _items.append(_item.to_dict())
            _dict['ratePlans'] = _items
        # override the default output from pydantic by calling `to_dict()` of terms
        if self.terms:
            _dict['terms'] = self.terms.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> SubscriptionData:
        """Create an instance of SubscriptionData from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return SubscriptionData.parse_obj(obj)

        _obj = SubscriptionData.parse_obj({
            "custom_fields": obj.get("customFields"),
            "invoice_separately": obj.get("invoiceSeparately"),
            "notes": obj.get("notes"),
            "rate_plans": [RatePlan.from_dict(_item) for _item in obj.get("ratePlans")] if obj.get("ratePlans") is not None else None,
            "start_date": obj.get("startDate"),
            "subscription_number": obj.get("subscriptionNumber"),
            "terms": TermInfo.from_dict(obj.get("terms")) if obj.get("terms") is not None else None
        })
        return _obj


