# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional, Union
from pydantic import BaseModel, Field, StrictFloat, StrictInt, StrictStr

class SubscriptionMetrics(BaseModel):
    """
    SubscriptionMetrics
    """
    subscription_number: Optional[StrictStr] = Field(None, alias="subscriptionNumber", description="The number for the subscription.")
    contracted_mrr: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="contractedMrr", description="Monthly recurring revenue of the subscription.")
    contracted_net_mrr: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="contractedNetMrr", description="Monthly recurring revenue of the subscription rate plan inclusive of all the discounts applicable, including the fixed-amount discounts and percentage discounts.")
    as_of_day_gross_mrr: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="asOfDayGrossMrr", description="Monthly recurring revenue of the subscription rate plan exclusive of any discounts applicable as of specified day.")
    as_of_day_net_mrr: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="asOfDayNetMrr", description="Monthly recurring revenue of the subscription rate plan inclusive of all the discounts applicable, including the fixed-amount discounts and percentage discounts as of specified day.")
    __properties = ["subscriptionNumber", "contractedMrr", "contractedNetMrr", "asOfDayGrossMrr", "asOfDayNetMrr"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> SubscriptionMetrics:
        """Create an instance of SubscriptionMetrics from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> SubscriptionMetrics:
        """Create an instance of SubscriptionMetrics from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return SubscriptionMetrics.parse_obj(obj)

        _obj = SubscriptionMetrics.parse_obj({
            "subscription_number": obj.get("subscriptionNumber"),
            "contracted_mrr": obj.get("contractedMrr"),
            "contracted_net_mrr": obj.get("contractedNetMrr"),
            "as_of_day_gross_mrr": obj.get("asOfDayGrossMrr"),
            "as_of_day_net_mrr": obj.get("asOfDayNetMrr")
        })
        return _obj


