# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional, Union
from pydantic import BaseModel, Field, StrictFloat, StrictInt, StrictStr

class Tier(BaseModel):
    """
    Tier
    """
    ending_unit: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="endingUnit", description="End number of a range of units for the tier. ")
    price: Union[StrictFloat, StrictInt] = Field(..., description="Price of the tier if the charge is a flat fee, or the price of each unit in the tier if the charge model is tiered pricing. ")
    price_format: Optional[StrictStr] = Field(None, alias="priceFormat", description="Indicates if pricing is a flat fee or is per unit.  Values:  * `FlatFee` * `PerUnit` ")
    starting_unit: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="startingUnit", description="Starting number of a range of units for the tier. ")
    tier: StrictInt = Field(..., description="Unique number that identifies the tier that the price applies to. ")
    __properties = ["endingUnit", "price", "priceFormat", "startingUnit", "tier"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Tier:
        """Create an instance of Tier from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> Tier:
        """Create an instance of Tier from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return Tier.parse_obj(obj)

        _obj = Tier.parse_obj({
            "ending_unit": obj.get("endingUnit"),
            "price": obj.get("price"),
            "price_format": obj.get("priceFormat"),
            "starting_unit": obj.get("startingUnit"),
            "tier": obj.get("tier")
        })
        return _obj


