# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional, Union
from pydantic import BaseModel, Field, StrictFloat, StrictInt, StrictStr

class TokenResponse(BaseModel):
    """
    TokenResponse
    """
    access_token: Optional[StrictStr] = Field(None, description="The generated token.")
    expires_in: Optional[Union[StrictFloat, StrictInt]] = Field(None, description="The number of seconds until the token expires.")
    jti: Optional[StrictStr] = Field(None, description="A globally unique identifier for the token.")
    scope: Optional[StrictStr] = Field(None, description="A space-delimited list of scopes that the token can be used to access.")
    token_type: Optional[StrictStr] = Field(None, description="The type of token that was generated, i.e., `bearer`.")
    __properties = ["access_token", "expires_in", "jti", "scope", "token_type"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> TokenResponse:
        """Create an instance of TokenResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> TokenResponse:
        """Create an instance of TokenResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return TokenResponse.parse_obj(obj)

        _obj = TokenResponse.parse_obj({
            "access_token": obj.get("access_token"),
            "expires_in": obj.get("expires_in"),
            "jti": obj.get("jti"),
            "scope": obj.get("scope"),
            "token_type": obj.get("token_type")
        })
        return _obj


