# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional, Union
from pydantic import BaseModel, Field, StrictFloat, StrictInt, StrictStr, conlist
from com.zuora.models.unapply_payment_debit_memo_application_item import UnapplyPaymentDebitMemoApplicationItem

class UnapplyPaymentDebitMemoApplication(BaseModel):
    """
    UnapplyPaymentDebitMemoApplication
    """
    amount: Union[StrictFloat, StrictInt] = Field(..., description="The amount of the payment that is unapplied from the debit memo. ")
    debit_memo_id: Optional[StrictStr] = Field(None, alias="debitMemoId", description="The unique ID of the debit memo that the payment is unapplied from. ")
    debit_memo_number: Optional[StrictStr] = Field(None, alias="debitMemoNumber", description="The number of the debit memo that the payment is unapplied from. ")
    items: Optional[conlist(UnapplyPaymentDebitMemoApplicationItem)] = Field(None, description="Container for debit memo items. The maximum number of items is 1,000.  **Note:** This field is only available if you have the [Invoice Item Settlement](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/Invoice_Settlement/C_Invoice_Item_Settlement) feature enabled. Invoice Item Settlement must be used together with other Invoice Settlement features (Unapplied Payments, and Credit and Debit memos).  If you wish to enable Invoice Settlement, see [Invoice Settlement Enablement and Checklist Guide](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/Invoice_Settlement/Invoice_Settlement_Migration_Checklist_and_Guide) for more information. ")
    __properties = ["amount", "debitMemoId", "debitMemoNumber", "items"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> UnapplyPaymentDebitMemoApplication:
        """Create an instance of UnapplyPaymentDebitMemoApplication from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in items (list)
        _items = []
        if self.items:
            for _item in self.items:
                if _item:
                    _items.append(_item.to_dict())
            _dict['items'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> UnapplyPaymentDebitMemoApplication:
        """Create an instance of UnapplyPaymentDebitMemoApplication from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return UnapplyPaymentDebitMemoApplication.parse_obj(obj)

        _obj = UnapplyPaymentDebitMemoApplication.parse_obj({
            "amount": obj.get("amount"),
            "debit_memo_id": obj.get("debitMemoId"),
            "debit_memo_number": obj.get("debitMemoNumber"),
            "items": [UnapplyPaymentDebitMemoApplicationItem.from_dict(_item) for _item in obj.get("items")] if obj.get("items") is not None else None
        })
        return _obj


