# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictStr

class UpdateAccountContact(BaseModel):
    """
    Container for bill-to/sold-to contact information for this account.   # noqa: E501
    """
    address1: Optional[StrictStr] = Field(None, description="First address line, 255 characters or less. ")
    address2: Optional[StrictStr] = Field(None, description="Second address line, 255 characters or less. ")
    city: Optional[StrictStr] = Field(None, description="City, 40 characters or less. ")
    country: Optional[StrictStr] = Field(None, description="Country; must be a valid country name or abbreviation. If using Zuora Tax, you must specify a country in the sold-to contact to calculate tax. A bill-to contact may be used if no sold-to contact is provided. ")
    county: Optional[StrictStr] = Field(None, description="County; 32 characters or less. May optionally be used by Zuora Tax to calculate county tax. ")
    fax: Optional[StrictStr] = Field(None, description="Fax phone number, 40 characters or less. ")
    first_name: StrictStr = Field(..., alias="firstName", description="First name, 100 characters or less. ")
    home_phone: Optional[StrictStr] = Field(None, alias="homePhone", description="Home phone number, 40 characters or less. ")
    last_name: StrictStr = Field(..., alias="lastName", description="Last name, 100 characters or less. ")
    mobile_phone: Optional[StrictStr] = Field(None, alias="mobilePhone", description="Mobile phone number, 40 characters or less. ")
    nickname: Optional[StrictStr] = Field(None, description="Nickname for this contact ")
    other_phone: Optional[StrictStr] = Field(None, alias="otherPhone", description="Other phone number, 40 characters or less. ")
    other_phone_type: Optional[StrictStr] = Field(None, alias="otherPhoneType")
    personal_email: Optional[StrictStr] = Field(None, alias="personalEmail", description="Personal email address, 80 characters or less. ")
    state: Optional[StrictStr] = Field(None, description="State; must be a valid state or province name or 2-character abbreviation. If using Zuora Tax, be aware that Zuora Tax requires a state (in the US) or province (in Canada) in this field for the sold-to contact to calculate tax, and that a bill-to contact may be used if no sold-to contact is provided. ")
    tax_region: Optional[StrictStr] = Field(None, alias="taxRegion", description="If using Zuora Tax, a region string as optionally defined in your tax rules. Not required. ")
    work_email: Optional[StrictStr] = Field(None, alias="workEmail", description="Work email address, 80 characters or less. ")
    work_phone: Optional[StrictStr] = Field(None, alias="workPhone", description="Work phone number, 40 characters or less. ")
    zip_code: Optional[StrictStr] = Field(None, alias="zipCode", description="Zip code, 20 characters or less. ")
    additional_properties: Dict[str, Any] = {}
    __properties = ["address1", "address2", "city", "country", "county", "fax", "firstName", "homePhone", "lastName", "mobilePhone", "nickname", "otherPhone", "otherPhoneType", "personalEmail", "state", "taxRegion", "workEmail", "workPhone", "zipCode"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> UpdateAccountContact:
        """Create an instance of UpdateAccountContact from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                            "additional_properties"
                          },
                          exclude_none=True)
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> UpdateAccountContact:
        """Create an instance of UpdateAccountContact from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return UpdateAccountContact.parse_obj(obj)

        _obj = UpdateAccountContact.parse_obj({
            "address1": obj.get("address1"),
            "address2": obj.get("address2"),
            "city": obj.get("city"),
            "country": obj.get("country"),
            "county": obj.get("county"),
            "fax": obj.get("fax"),
            "first_name": obj.get("firstName"),
            "home_phone": obj.get("homePhone"),
            "last_name": obj.get("lastName"),
            "mobile_phone": obj.get("mobilePhone"),
            "nickname": obj.get("nickname"),
            "other_phone": obj.get("otherPhone"),
            "other_phone_type": obj.get("otherPhoneType"),
            "personal_email": obj.get("personalEmail"),
            "state": obj.get("state"),
            "tax_region": obj.get("taxRegion"),
            "work_email": obj.get("workEmail"),
            "work_phone": obj.get("workPhone"),
            "zip_code": obj.get("zipCode")
        })
        # store additional fields in additional_properties
        for _key in obj.keys():
            if _key not in cls.__properties:
                _obj.additional_properties[_key] = obj.get(_key)

        return _obj


