# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictBool, StrictInt, StrictStr, conlist, constr
from com.zuora.models.account_e_invoice_profile import AccountEInvoiceProfile
from com.zuora.models.account_object_ns_fields_customer_type_ns import AccountObjectNSFieldsCustomerTypeNS
from com.zuora.models.account_object_ns_fields_syncto_net_suite_ns import AccountObjectNSFieldsSynctoNetSuiteNS
from com.zuora.models.tax_info import TaxInfo
from com.zuora.models.update_account_contact import UpdateAccountContact

class UpdateAccountRequest(BaseModel):
    """
    UpdateAccountRequest
    """
    class__ns: Optional[constr(strict=True, max_length=255)] = Field(None, alias="Class__NS", description="Value of the Class field for the corresponding customer account in NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265). ")
    customer_type__ns: Optional[StrictStr] = Field(None, alias="CustomerType__NS")
    department__ns: Optional[constr(strict=True, max_length=255)] = Field(None, alias="Department__NS", description="Value of the Department field for the corresponding customer account in NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265). ")
    integration_id__ns: Optional[constr(strict=True, max_length=255)] = Field(None, alias="IntegrationId__NS", description="ID of the corresponding object in NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265). ")
    integration_status__ns: Optional[constr(strict=True, max_length=255)] = Field(None, alias="IntegrationStatus__NS", description="Status of the account's synchronization with NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265). ")
    location__ns: Optional[constr(strict=True, max_length=255)] = Field(None, alias="Location__NS", description="Value of the Location field for the corresponding customer account in NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265). ")
    subsidiary__ns: Optional[constr(strict=True, max_length=255)] = Field(None, alias="Subsidiary__NS", description="Value of the Subsidiary field for the corresponding customer account in NetSuite. The Subsidiary field is required if you use NetSuite OneWorld. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265). ")
    sync_date__ns: Optional[constr(strict=True, max_length=255)] = Field(None, alias="SyncDate__NS", description="Date when the account was sychronized with NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265). ")
    syncto_net_suite__ns: Optional[StrictStr] = Field(None, alias="SynctoNetSuite__NS")
    additional_email_addresses: Optional[conlist(StrictStr)] = Field(None, alias="additionalEmailAddresses", description="A list of additional email addresses to receive email notifications. Use commas to separate email addresses. ")
    auto_pay: Optional[StrictBool] = Field(None, alias="autoPay", description="Whether future payments are to be automatically billed when they are due.  ")
    batch: Optional[StrictStr] = Field(None, description="The alias name given to a batch. A string of 50 characters or less. ")
    bill_cycle_day: Optional[StrictInt] = Field(None, alias="billCycleDay", description="Sets the bill cycle day (BCD) for the charge. The BCD determines which day of the month the customer is billed. Values: Any activated system-defined bill cycle day （`1`-`31`） ")
    bill_to_contact: Optional[UpdateAccountContact] = Field(None, alias="billToContact")
    communication_profile_id: Optional[StrictStr] = Field(None, alias="communicationProfileId", description="The ID of the communication profile that this account is linked to.  You can provide either or both of the `communicationProfileId` and `profileNumber` fields.  If both are provided, the request will fail if they do not refer to the same communication profile. ")
    credit_memo_template_id: Optional[StrictStr] = Field(None, alias="creditMemoTemplateId", description="**Note:** This field is only available if you have [Invoice Settlement](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/Invoice_Settlement) enabled. The Invoice Settlement feature is generally available as of Zuora Billing Release 296 (March 2021). This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement, see [Invoice Settlement Enablement and Checklist Guide](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/Invoice_Settlement/Invoice_Settlement_Migration_Checklist_and_Guide) for more information.  The unique ID of the credit memo template, configured in **Billing Settings** > **Manage Billing Document Configuration** through the Zuora UI. For example, 2c92c08a6246fdf101626b1b3fe0144b. ")
    crm_id: Optional[StrictStr] = Field(None, alias="crmId", description="CRM account ID for the account, up to 100 characters. ")
    customer_service_rep_name: Optional[constr(strict=True, max_length=50)] = Field(None, alias="customerServiceRepName", description="Name of the account’s customer service representative, if applicable. ")
    debit_memo_template_id: Optional[StrictStr] = Field(None, alias="debitMemoTemplateId", description="**Note:** This field is only available if you have [Invoice Settlement](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/Invoice_Settlement) enabled. The Invoice Settlement feature is generally available as of Zuora Billing Release 296 (March 2021). This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement, see [Invoice Settlement Enablement and Checklist Guide](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/Invoice_Settlement/Invoice_Settlement_Migration_Checklist_and_Guide) for more information.  The unique ID of the debit memo template, configured in **Billing Settings** > **Manage Billing Document Configuration** through the Zuora UI. For example, 2c92c08d62470a8501626b19d24f19e2. ")
    default_payment_method_id: Optional[constr(strict=True, max_length=64)] = Field(None, alias="defaultPaymentMethodId", description="ID of the default payment method for the account.  Values: a valid ID for an existing payment method. ")
    invoice_delivery_prefs_email: Optional[StrictBool] = Field(None, alias="invoiceDeliveryPrefsEmail", description="Whether the customer wants to receive invoices through email.   The default value is `false`. ")
    invoice_delivery_prefs_print: Optional[StrictBool] = Field(None, alias="invoiceDeliveryPrefsPrint", description="Whether the customer wants to receive printed invoices, such as through postal mail.  The default value is `false`. ")
    invoice_template_id: Optional[StrictStr] = Field(None, alias="invoiceTemplateId", description="Invoice template ID, configured in Billing Settings in the Zuora UI. ")
    name: Optional[StrictStr] = Field(None, description="Account name, up to 255 characters. ")
    notes: Optional[StrictStr] = Field(None, description="A string of up to 65,535 characters. ")
    parent_id: Optional[StrictStr] = Field(None, alias="parentId", description="Identifier of the parent customer account for this Account object. The length is 32 characters. Use this field if you have <a href=\"https://knowledgecenter.zuora.com/Billing/Subscriptions/Customer_Accounts/A_Customer_Account_Introduction#Customer_Hierarchy\" target=\"_blank\">Customer Hierarchy</a> enabled.")
    partner_account: Optional[StrictBool] = Field(None, alias="partnerAccount", description="Whether the customer account is a partner, distributor, or reseller.  You can set this field to `true` if you have business with distributors or resellers, or operating in B2B model to manage numerous subscriptions through concurrent API requests. After this field is set to `true`, the calculation of account metrics is performed asynchronously during operations such as subscription creation, order changes, invoice generation, and payments. **Note**: This field is available only if you have the <a href=\"https://knowledgecenter.zuora.com/Zuora_Billing/Manage_customer_accounts/AAA_Overview_of_customer_accounts/Reseller_Account\" target=\"_blank\">Reseller Account</a> feature enabled. ")
    payment_gateway: Optional[StrictStr] = Field(None, alias="paymentGateway", description="The name of the payment gateway instance. If null or left unassigned, the Account will use the Default Gateway. ")
    payment_term: Optional[StrictStr] = Field(None, alias="paymentTerm", description="Payment terms for this account. Possible values are `Due Upon Receipt`, `Net 30`, `Net 60`, `Net 90`.")
    profile_number: Optional[StrictStr] = Field(None, alias="profileNumber", description="The number of the communication profile that this account is linked to.  You can provide either or both of the `communicationProfileId` and `profileNumber` fields.  If both are provided, the request will fail if they do not refer to the same communication profile. ")
    purchase_order_number: Optional[StrictStr] = Field(None, alias="purchaseOrderNumber", description="The purchase order number provided by your customer for services, products, or both purchased.")
    roll_up_usage: Optional[StrictBool] = Field(None, alias="rollUpUsage", description="Whether the usage of the account roll up to its parent account")
    sales_rep: Optional[StrictStr] = Field(None, alias="salesRep", description="The name of the sales representative associated with this account, if applicable. Maximum of 50 characters.")
    sequence_set_id: Optional[StrictStr] = Field(None, alias="sequenceSetId", description="The ID of the billing document sequence set to assign to the customer account.   The billing documents to generate for this account will adopt the prefix and starting document number configured in the sequence set.  If a customer account has no assigned billing document sequence set, billing documents generated for this account adopt the prefix and starting document number from the default sequence set. ")
    sold_to_contact: Optional[UpdateAccountContact] = Field(None, alias="soldToContact")
    tagging: Optional[StrictStr] = None
    tax_info: Optional[TaxInfo] = Field(None, alias="taxInfo")
    payment_gateway_number: Optional[StrictStr] = Field(None, alias="paymentGatewayNumber", description="paymentGatewayNumber ")
    summary_statement_template_id: Optional[StrictStr] = Field(None, alias="summaryStatementTemplateId", description="summaryStatementTemplateId ")
    einvoice_profile: Optional[AccountEInvoiceProfile] = Field(None, alias="einvoiceProfile")
    organization_label: Optional[StrictStr] = Field(None, alias="organizationLabel")
    additional_properties: Dict[str, Any] = {}
    __properties = ["Class__NS", "CustomerType__NS", "Department__NS", "IntegrationId__NS", "IntegrationStatus__NS", "Location__NS", "Subsidiary__NS", "SyncDate__NS", "SynctoNetSuite__NS", "additionalEmailAddresses", "autoPay", "batch", "billCycleDay", "billToContact", "communicationProfileId", "creditMemoTemplateId", "crmId", "customerServiceRepName", "debitMemoTemplateId", "defaultPaymentMethodId", "invoiceDeliveryPrefsEmail", "invoiceDeliveryPrefsPrint", "invoiceTemplateId", "name", "notes", "parentId", "partnerAccount", "paymentGateway", "paymentTerm", "profileNumber", "purchaseOrderNumber", "rollUpUsage", "salesRep", "sequenceSetId", "soldToContact", "tagging", "taxInfo", "paymentGatewayNumber", "summaryStatementTemplateId", "einvoiceProfile", "organizationLabel"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> UpdateAccountRequest:
        """Create an instance of UpdateAccountRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                            "additional_properties"
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of bill_to_contact
        if self.bill_to_contact:
            _dict['billToContact'] = self.bill_to_contact.to_dict()
        # override the default output from pydantic by calling `to_dict()` of sold_to_contact
        if self.sold_to_contact:
            _dict['soldToContact'] = self.sold_to_contact.to_dict()
        # override the default output from pydantic by calling `to_dict()` of tax_info
        if self.tax_info:
            _dict['taxInfo'] = self.tax_info.to_dict()
        # override the default output from pydantic by calling `to_dict()` of einvoice_profile
        if self.einvoice_profile:
            _dict['einvoiceProfile'] = self.einvoice_profile.to_dict()
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> UpdateAccountRequest:
        """Create an instance of UpdateAccountRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return UpdateAccountRequest.parse_obj(obj)

        _obj = UpdateAccountRequest.parse_obj({
            "class__ns": obj.get("Class__NS"),
            "customer_type__ns": obj.get("CustomerType__NS"),
            "department__ns": obj.get("Department__NS"),
            "integration_id__ns": obj.get("IntegrationId__NS"),
            "integration_status__ns": obj.get("IntegrationStatus__NS"),
            "location__ns": obj.get("Location__NS"),
            "subsidiary__ns": obj.get("Subsidiary__NS"),
            "sync_date__ns": obj.get("SyncDate__NS"),
            "syncto_net_suite__ns": obj.get("SynctoNetSuite__NS"),
            "additional_email_addresses": obj.get("additionalEmailAddresses"),
            "auto_pay": obj.get("autoPay"),
            "batch": obj.get("batch"),
            "bill_cycle_day": obj.get("billCycleDay"),
            "bill_to_contact": UpdateAccountContact.from_dict(obj.get("billToContact")) if obj.get("billToContact") is not None else None,
            "communication_profile_id": obj.get("communicationProfileId"),
            "credit_memo_template_id": obj.get("creditMemoTemplateId"),
            "crm_id": obj.get("crmId"),
            "customer_service_rep_name": obj.get("customerServiceRepName"),
            "debit_memo_template_id": obj.get("debitMemoTemplateId"),
            "default_payment_method_id": obj.get("defaultPaymentMethodId"),
            "invoice_delivery_prefs_email": obj.get("invoiceDeliveryPrefsEmail"),
            "invoice_delivery_prefs_print": obj.get("invoiceDeliveryPrefsPrint"),
            "invoice_template_id": obj.get("invoiceTemplateId"),
            "name": obj.get("name"),
            "notes": obj.get("notes"),
            "parent_id": obj.get("parentId"),
            "partner_account": obj.get("partnerAccount"),
            "payment_gateway": obj.get("paymentGateway"),
            "payment_term": obj.get("paymentTerm"),
            "profile_number": obj.get("profileNumber"),
            "purchase_order_number": obj.get("purchaseOrderNumber"),
            "roll_up_usage": obj.get("rollUpUsage"),
            "sales_rep": obj.get("salesRep"),
            "sequence_set_id": obj.get("sequenceSetId"),
            "sold_to_contact": UpdateAccountContact.from_dict(obj.get("soldToContact")) if obj.get("soldToContact") is not None else None,
            "tagging": obj.get("tagging"),
            "tax_info": TaxInfo.from_dict(obj.get("taxInfo")) if obj.get("taxInfo") is not None else None,
            "payment_gateway_number": obj.get("paymentGatewayNumber"),
            "summary_statement_template_id": obj.get("summaryStatementTemplateId"),
            "einvoice_profile": AccountEInvoiceProfile.from_dict(obj.get("einvoiceProfile")) if obj.get("einvoiceProfile") is not None else None,
            "organization_label": obj.get("organizationLabel")
        })
        # store additional fields in additional_properties
        for _key in obj.keys():
            if _key not in cls.__properties:
                _obj.additional_properties[_key] = obj.get(_key)

        return _obj


