# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictBool, StrictStr
from com.zuora.models.custom_object_custom_field_definition_update import CustomObjectCustomFieldDefinitionUpdate

class UpdateCustomObjectCusotmField(BaseModel):
    """
    A reference to a field.  # noqa: E501
    """
    auditable: Optional[StrictBool] = Field(None, description="Indicates whether Audit Trail will record changes of this custom field. You can change auditable fields to non-auditable, and vice versa. One custom object can have a maximum of five auditable fields. ")
    definition: Optional[CustomObjectCustomFieldDefinitionUpdate] = None
    filterable: Optional[StrictBool] = Field(None, description="Indicates whether the field is filterable or not. Applicable to `addField` and `updateField` actions.  You can change a filterable field to non-filterable and vice versa. You can also add a filterable field. One custom object can have a maximum of 10 filterable fields.  Note that changing filterable fields triggers reindexing. It will take 12-24 hours before all your data are reindexed and available to query. ")
    name: Optional[StrictStr] = Field(None, description="The name of the custom field to be updated")
    required: Optional[StrictBool] = Field(None, description="Indicates whether the field is required or optional.  You can update a required field to optional. On the other hand, you can only update an optional field to required on the custom object with no records.  You can only add a required field to the custom object with no records. ")
    target_name: Optional[StrictStr] = Field(None, alias="targetName", description="Required if the `type` of the action is `renameField`")
    unique: Optional[StrictBool] = Field(None, description="Indicates whether to specify a unique constraint to the field. You can remove the unique constraint on the field. However, you can only add a unique constraint to a filterable field if the custom object contains no record. One custom object can have a maximum of five fields with unique constraints. ")
    __properties = ["auditable", "definition", "filterable", "name", "required", "targetName", "unique"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> UpdateCustomObjectCusotmField:
        """Create an instance of UpdateCustomObjectCusotmField from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of definition
        if self.definition:
            _dict['definition'] = self.definition.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> UpdateCustomObjectCusotmField:
        """Create an instance of UpdateCustomObjectCusotmField from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return UpdateCustomObjectCusotmField.parse_obj(obj)

        _obj = UpdateCustomObjectCusotmField.parse_obj({
            "auditable": obj.get("auditable"),
            "definition": CustomObjectCustomFieldDefinitionUpdate.from_dict(obj.get("definition")) if obj.get("definition") is not None else None,
            "filterable": obj.get("filterable"),
            "name": obj.get("name"),
            "required": obj.get("required"),
            "target_name": obj.get("targetName"),
            "unique": obj.get("unique")
        })
        return _obj


