# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict, Optional
from pydantic import BaseModel, Field, StrictStr

class UpdateOrderAction(BaseModel):
    """
    UpdateOrderAction
    """
    change_reason: Optional[StrictStr] = Field(None, alias="changeReason", description="The change reason set for an order action when the order action is updated. ")
    custom_fields: Optional[Dict[str, Dict[str, Any]]] = Field(None, alias="customFields", description="Container for custom fields of an Order Action object. ")
    __properties = ["changeReason", "customFields"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> UpdateOrderAction:
        """Create an instance of UpdateOrderAction from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> UpdateOrderAction:
        """Create an instance of UpdateOrderAction from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return UpdateOrderAction.parse_obj(obj)

        _obj = UpdateOrderAction.parse_obj({
            "change_reason": obj.get("changeReason"),
            "custom_fields": obj.get("customFields")
        })
        return _obj


