# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from typing import Optional
from pydantic import BaseModel, Field, StrictStr

class UpdateOrderActionChargeTriggerDate(BaseModel):
    """
    UpdateOrderActionChargeTriggerDate
    """
    charge_number: Optional[StrictStr] = Field(None, alias="chargeNumber", description="Charge number of the charge which needs the triggering date to be provided. The charge's `triggerEvent` must have been set as `SpecificDate`.")
    specific_trigger_date: Optional[date] = Field(None, alias="specificTriggerDate", description="Date in YYYY-MM-DD format. The specific trigger date you are to set for the charge.")
    __properties = ["chargeNumber", "specificTriggerDate"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> UpdateOrderActionChargeTriggerDate:
        """Create an instance of UpdateOrderActionChargeTriggerDate from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> UpdateOrderActionChargeTriggerDate:
        """Create an instance of UpdateOrderActionChargeTriggerDate from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return UpdateOrderActionChargeTriggerDate.parse_obj(obj)

        _obj = UpdateOrderActionChargeTriggerDate.parse_obj({
            "charge_number": obj.get("chargeNumber"),
            "specific_trigger_date": obj.get("specificTriggerDate")
        })
        return _obj


