# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field
from com.zuora.models.update_order_action import UpdateOrderAction

class UpdateOrderActionRequest(BaseModel):
    """
    UpdateOrderActionRequest
    """
    order_action: Optional[UpdateOrderAction] = Field(None, alias="orderAction")
    __properties = ["orderAction"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> UpdateOrderActionRequest:
        """Create an instance of UpdateOrderActionRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of order_action
        if self.order_action:
            _dict['orderAction'] = self.order_action.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> UpdateOrderActionRequest:
        """Create an instance of UpdateOrderActionRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return UpdateOrderActionRequest.parse_obj(obj)

        _obj = UpdateOrderActionRequest.parse_obj({
            "order_action": UpdateOrderAction.from_dict(obj.get("orderAction")) if obj.get("orderAction") is not None else None
        })
        return _obj


