# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictStr, conlist
from com.zuora.models.update_order_subscriptions_order_actions_custom_fields import UpdateOrderSubscriptionsOrderActionsCustomFields

class UpdateOrderSubscriptionsCustomFields(BaseModel):
    """
    UpdateOrderSubscriptionsCustomFields
    """
    order_actions: Optional[conlist(UpdateOrderSubscriptionsOrderActionsCustomFields)] = Field(None, alias="orderActions")
    subscription_number: Optional[StrictStr] = Field(None, alias="subscriptionNumber")
    __properties = ["orderActions", "subscriptionNumber"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> UpdateOrderSubscriptionsCustomFields:
        """Create an instance of UpdateOrderSubscriptionsCustomFields from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in order_actions (list)
        _items = []
        if self.order_actions:
            for _item in self.order_actions:
                if _item:
                    _items.append(_item.to_dict())
            _dict['orderActions'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> UpdateOrderSubscriptionsCustomFields:
        """Create an instance of UpdateOrderSubscriptionsCustomFields from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return UpdateOrderSubscriptionsCustomFields.parse_obj(obj)

        _obj = UpdateOrderSubscriptionsCustomFields.parse_obj({
            "order_actions": [UpdateOrderSubscriptionsOrderActionsCustomFields.from_dict(_item) for _item in obj.get("orderActions")] if obj.get("orderActions") is not None else None,
            "subscription_number": obj.get("subscriptionNumber")
        })
        return _obj


