# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict, Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr

class UpdateOrderSubscriptionsOrderActionsCustomFields(BaseModel):
    """
    UpdateOrderSubscriptionsOrderActionsCustomFields
    """
    custom_fields: Optional[Dict[str, Dict[str, Any]]] = Field(None, alias="customFields", description="Container for custom fields of an Order Action object. ")
    order_action_id: Optional[StrictStr] = Field(None, alias="orderActionId", description="The Id of the order action in the order. You can provide either the `sequence` or the `orderActionId` field to specify which order action to update. You cannot use then both at the same time. ")
    sequence: Optional[StrictInt] = Field(None, description="The sequence number of the order action in the order. You can provide either the `sequence` or the `orderActionId` field to specify which order action to update. You cannot use then both at the same time. ")
    __properties = ["customFields", "orderActionId", "sequence"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> UpdateOrderSubscriptionsOrderActionsCustomFields:
        """Create an instance of UpdateOrderSubscriptionsOrderActionsCustomFields from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> UpdateOrderSubscriptionsOrderActionsCustomFields:
        """Create an instance of UpdateOrderSubscriptionsOrderActionsCustomFields from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return UpdateOrderSubscriptionsOrderActionsCustomFields.parse_obj(obj)

        _obj = UpdateOrderSubscriptionsOrderActionsCustomFields.parse_obj({
            "custom_fields": obj.get("customFields"),
            "order_action_id": obj.get("orderActionId"),
            "sequence": obj.get("sequence")
        })
        return _obj


