# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict, Optional
from pydantic import BaseModel, Field, StrictStr

class UpdateSubscriptionChargeCustomFieldsOfASpecifiedVersion(BaseModel):
    """
    UpdateSubscriptionChargeCustomFieldsOfASpecifiedVersion
    """
    charge_id: Optional[StrictStr] = Field(None, alias="chargeId", description="Use either this field or the `chargeNumber` field to specify the charge for which you will be updating the custom fields. By using this field you actually specify a specific charge segment of a charge. See [Segmented rate plan charges](https://knowledgecenter.zuora.com/Central_Platform/API/G_SOAP_API/E1_SOAP_API_Object_Reference/RatePlanCharge#Segmented_rate_plan_charges) for more information about charge segments. ")
    charge_number: Optional[StrictStr] = Field(None, alias="chargeNumber", description="Use either this field or the `chargeId` field to specify the charge for which you will be updating the custom fields. By using this field you actually specify the last charge segment of a charge. See [Segmented rate plan charges](https://knowledgecenter.zuora.com/Central_Platform/API/G_SOAP_API/E1_SOAP_API_Object_Reference/RatePlanCharge#Segmented_rate_plan_charges) for more information about charge segments. ")
    custom_fields: Optional[Dict[str, Dict[str, Any]]] = Field(None, alias="customFields", description="Container for custom fields of a Rate Plan Charge object. ")
    __properties = ["chargeId", "chargeNumber", "customFields"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> UpdateSubscriptionChargeCustomFieldsOfASpecifiedVersion:
        """Create an instance of UpdateSubscriptionChargeCustomFieldsOfASpecifiedVersion from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> UpdateSubscriptionChargeCustomFieldsOfASpecifiedVersion:
        """Create an instance of UpdateSubscriptionChargeCustomFieldsOfASpecifiedVersion from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return UpdateSubscriptionChargeCustomFieldsOfASpecifiedVersion.parse_obj(obj)

        _obj = UpdateSubscriptionChargeCustomFieldsOfASpecifiedVersion.parse_obj({
            "charge_id": obj.get("chargeId"),
            "charge_number": obj.get("chargeNumber"),
            "custom_fields": obj.get("customFields")
        })
        return _obj


