# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict, List, Optional
from pydantic import BaseModel, Field, StrictStr, conlist
from com.zuora.models.update_subscription_charge_custom_fields_of_a_specified_version import UpdateSubscriptionChargeCustomFieldsOfASpecifiedVersion

class UpdateSubscriptionRatePlanCustomFieldsOfASpecifiedVersion(BaseModel):
    """
    UpdateSubscriptionRatePlanCustomFieldsOfASpecifiedVersion
    """
    charges: Optional[conlist(UpdateSubscriptionChargeCustomFieldsOfASpecifiedVersion)] = None
    custom_fields: Optional[Dict[str, Dict[str, Any]]] = Field(None, alias="customFields", description="Container for custom fields of a Rate Plan object. ")
    rate_plan_id: StrictStr = Field(..., alias="ratePlanId", description="The rate plan id in any version of the subscription. This will be linked to the only one rate plan in the current version.")
    __properties = ["charges", "customFields", "ratePlanId"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> UpdateSubscriptionRatePlanCustomFieldsOfASpecifiedVersion:
        """Create an instance of UpdateSubscriptionRatePlanCustomFieldsOfASpecifiedVersion from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in charges (list)
        _items = []
        if self.charges:
            for _item in self.charges:
                if _item:
                    _items.append(_item.to_dict())
            _dict['charges'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> UpdateSubscriptionRatePlanCustomFieldsOfASpecifiedVersion:
        """Create an instance of UpdateSubscriptionRatePlanCustomFieldsOfASpecifiedVersion from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return UpdateSubscriptionRatePlanCustomFieldsOfASpecifiedVersion.parse_obj(obj)

        _obj = UpdateSubscriptionRatePlanCustomFieldsOfASpecifiedVersion.parse_obj({
            "charges": [UpdateSubscriptionChargeCustomFieldsOfASpecifiedVersion.from_dict(_item) for _item in obj.get("charges")] if obj.get("charges") is not None else None,
            "custom_fields": obj.get("customFields"),
            "rate_plan_id": obj.get("ratePlanId")
        })
        return _obj


