# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import Optional, Union
from pydantic import BaseModel, Field, StrictFloat, StrictInt, StrictStr

class UpdateUsageRequest(BaseModel):
    """
    UpdateUsageRequest
    """
    start_date_time: Optional[datetime] = Field(None, alias="StartDateTime", description=" The start date and time of a range of time when usage is tracked. Zuora uses this field value to determine the usage date. Unlike the `EndDateTime`, the `StartDateTime` field does affect usage calculation. **Character limit**: 29 **Values**: a valid date and time value")
    end_date_time: Optional[datetime] = Field(None, alias="EndDateTime", description=" The end date and time of a range of time when usage is tracked. Use this field for reporting; this field doesn't affect usage calculation. **Character limit**: 29 **Values**: a valid date and time value")
    uom: Optional[StrictStr] = Field(None, alias="UOM", description=" Specifies the units to measure usage. Units of measure are configured in the web-based UI. Your values depend on your configuration in **Billing Settings**. **Character limit**: **Values**: a valid unit of measure")
    quantity: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="Quantity", description=" Indicates the number of units used. **Character limit**: 16 **Values**: a valid decimal amount equal to or greater than 0")
    rbe_status: Optional[StrictStr] = Field(None, alias="RbeStatus", description=" Indicates if the rating and billing engine (RBE) processed usage data for an invoice. **Character limit**: 9 **Values**: automatically generated to be one of the following values: `Importing`, `Pending`, `Processed`")
    additional_properties: Dict[str, Any] = {}
    __properties = ["StartDateTime", "EndDateTime", "UOM", "Quantity", "RbeStatus"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> UpdateUsageRequest:
        """Create an instance of UpdateUsageRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                            "additional_properties"
                          },
                          exclude_none=True)
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> UpdateUsageRequest:
        """Create an instance of UpdateUsageRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return UpdateUsageRequest.parse_obj(obj)

        _obj = UpdateUsageRequest.parse_obj({
            "start_date_time": obj.get("StartDateTime"),
            "end_date_time": obj.get("EndDateTime"),
            "uom": obj.get("UOM"),
            "quantity": obj.get("Quantity"),
            "rbe_status": obj.get("RbeStatus")
        })
        # store additional fields in additional_properties
        for _key in obj.keys():
            if _key not in cls.__properties:
                _obj.additional_properties[_key] = obj.get(_key)

        return _obj


