# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field
from com.zuora.models.write_off_behavior_finance_information import WriteOffBehaviorFinanceInformation

class WriteOffBehavior(BaseModel):
    """
    The financial information of the credit memo items generated to write off the invoice balance.   **Note:**    - All the credit memo items that are used to write off the invoice will be applied with the same financial information.   - Credit memo items generated from the unconsumed services of the canceled subscription will not be applied with the finance information specified here.   # noqa: E501
    """
    finance_information: Optional[WriteOffBehaviorFinanceInformation] = Field(None, alias="financeInformation")
    __properties = ["financeInformation"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> WriteOffBehavior:
        """Create an instance of WriteOffBehavior from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of finance_information
        if self.finance_information:
            _dict['financeInformation'] = self.finance_information.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> WriteOffBehavior:
        """Create an instance of WriteOffBehavior from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return WriteOffBehavior.parse_obj(obj)

        _obj = WriteOffBehavior.parse_obj({
            "finance_information": WriteOffBehaviorFinanceInformation.from_dict(obj.get("financeInformation")) if obj.get("financeInformation") is not None else None
        })
        return _obj


