# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictBool
from com.zuora.models.write_off_invoice_response_credit_memo import WriteOffInvoiceResponseCreditMemo

class WriteOffInvoiceResponse(BaseModel):
    """
    WriteOffInvoiceResponse
    """
    credit_memo: Optional[WriteOffInvoiceResponseCreditMemo] = Field(None, alias="creditMemo")
    success: Optional[StrictBool] = Field(None, description="Returns `true` if the request was processed successfully. ")
    __properties = ["creditMemo", "success"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> WriteOffInvoiceResponse:
        """Create an instance of WriteOffInvoiceResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of credit_memo
        if self.credit_memo:
            _dict['creditMemo'] = self.credit_memo.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> WriteOffInvoiceResponse:
        """Create an instance of WriteOffInvoiceResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return WriteOffInvoiceResponse.parse_obj(obj)

        _obj = WriteOffInvoiceResponse.parse_obj({
            "credit_memo": WriteOffInvoiceResponseCreditMemo.from_dict(obj.get("creditMemo")) if obj.get("creditMemo") is not None else None,
            "success": obj.get("success")
        })
        return _obj


